//============================================================
//  TARGET PROJECT: PSM3(Prosessor Study Model3)
//  TARGET SYSTEM : Psm3Sys (PSM3 TEST SYSTEM)
//  FUNCTION      : Vga(video out interface) Contral Register
//  VERSION       : Ver0.60
//
//                      Copyright (C) 2008 by Tomoyuki Inomoto
//============================================================
`define     VGA_ENABLE_ADR      2'h0
`define     VGA_FM0_BASE_ADR    2'h1
`define     VGA_FM1_BASE_ADR    2'h2
module VgaCR(
    Clk         ,
    RstN        ,

    HostCS      ,
    HostRW      ,
    HostRQ      ,
    HostADR     ,
    HostWD      ,
    HostRD      ,

    VgaMode     ,
    VgaEna      ,
    VgaBase0    ,
    VgaBase1
);
    //==================================================
    //======== port  ===================================
    //==================================================
    //======== SYSTEM ==============
    input           Clk     ;
    input           RstN    ;

    //======== HOST BUS ==============
    input           HostCS  ;
    input           HostRW  ;
    input           HostRQ  ;
    input   [3:0]   HostADR ;
    input   [31:0]  HostWD  ;
    output  [31:0]  HostRD  ;

    //======== to VgaRC ==============
    output          VgaMode ;
    output          VgaEna  ;
    output  [25:4]  VgaBase0;
    output  [25:4]  VgaBase1;

    //==================================================
    //======== wire & reg ==============================
    //==================================================
    reg             VgaMode ;
    reg             VgaEna  ;
    reg     [25:4]  VgaBase0;
    reg     [25:4]  VgaBase1;

    //====================================================================
    //======== BODY ======================================================
    //====================================================================
    always  @(posedge Clk or negedge RstN) begin
        if(~RstN) begin
            VgaEna      <= 1'h0;
            VgaMode     <= 1'h0;
            VgaBase0    <= 22'h0;
            VgaBase1    <= 22'h0;
        end
        else if(HostCS & HostRQ & HostRW) begin
            if(HostADR[3:2] == `VGA_ENABLE_ADR  ) {VgaMode, VgaEna} <= HostWD[1:0];
            if(HostADR[3:2] == `VGA_FM0_BASE_ADR) VgaBase0 <= HostWD[25:4];
            if(HostADR[3:2] == `VGA_FM1_BASE_ADR) VgaBase1 <= HostWD[25:4];
        end
    end
    assign  HostRD = (HostADR[3:2] == `VGA_ENABLE_ADR  )? {30'h0, VgaMode, VgaEna}  :
                     (HostADR[3:2] == `VGA_FM0_BASE_ADR)? {6'h0, VgaBase0, 4'h0} :
                     (HostADR[3:2] == `VGA_FM1_BASE_ADR)? {6'h0, VgaBase1, 4'h0} : 32'h0;

endmodule
