//============================================================
//  TARGET SYSTEM : *
//  FUNCTION      : oXgpCu
//
//                  Copyright (C) 2009-2010 by Tomoyuki Inomoto
//=============================================================
#ifndef     __BIDIR_LIST_H__
#define     __BIDIR_LIST_H__

#include    <stdio.h>
#include    <stdlib.h>
#include    <string.h>
#include    <ctype.h>

#define     BIDIR_LIST_DEBUG


#define     BIDIR_LIST_OK   (0)
#define     BIDIR_LIST_NG   (-1)

#define     BIDIR_LIST_CHECK

//----- Xg̃o ------------------------------------------
struct BiDirListMember_t{
    struct BiDirListMember_t    *Prev; // Õoւ̃N
    struct BiDirListMember_t    *Next; // ̃oւ̃N
    void                        *Object; // XgɂԂ牺IuWFNgւ̃|C^
};

typedef struct BiDirListMember_t BiDirListMember;

//----- Xg̊ǗubN ------------------------------------------
struct BiDirList_t{
    int                         NumOfMember;    // XgɂԂ牺o
    BiDirListMember             *Entry;         // Xg̐擪
    BiDirListMember             *Last;          // Xg̍Ō
    BiDirListMember             **Index;        // Xg̃CfbNX\BXgQƂ̍ɎgB
                                                // NULL͖̎BBiDirListIndexCreate()̎sɗLB
                                                // AIndexĹAXgւ̒ǉ/폜n̑֎~B
    int                         (*Remove)(void *Object);
                                                // *(BiDirListMember.Object)free֐ւ̊֐|C^(BIDIR_LIST_OKAsBYDIR_LIST_NGԂ)
                                                // *(BiDirListMember.Object)XgAꖇ̃f[^\łȂŁAgIƉȂΕKvB
                                                // svȂBiDirListCreate()̑PNULLƂăXg΂悢B
    int                         (*Find)(BiDirListMember *Position, void *Key); // BiDirListMember֐ւ̊֐|C^
                                                // ̊֐́APosition->Object̓eKeyŎw肵L[ƈvBIDIR_LIST_OKAvȂBIDIR_LIST_OKȊOԂKv
                                                // XǧsvȂBiDirListCreate()̑QNULLƂăXg΂悢
                                                // ̏ꍇBiDirListMemberFind()͏BYDIR_LIST_NGԂ
                                                //  ORemoveA͎̎׈ȊB܂qsort()̗邵A{lgȂ낤OKƂ
                                                // Ȃ݂ɁAꍇɂČL[g
                                                // struct hoge_t{
                                                //      int     KeyType;
                                                //      void    *TrueKey;
                                                // } hoge;
                                                // `āAFind֐KeyœnAŒ`Find֐KeyTypeŌL[w肷΂悢͂B
};
typedef struct BiDirList_t BiDirList;


//----- ֐ ------------------------------------------
//====================================================================================================================
BiDirList *BiDirListCreate(int (*Remove)(void *Object), int (*Find)(BiDirListMember *Position, void *Key));
//====================================================================================================================
// [@\] Xg쐬
// [] Xg̃f[^i*(BiDirListMember.Data)free֐ւ̃|C^BwȂ̏ꍇNULLł悢
// [Ԓl] sNULLAABiDirListւ̃|C^ԂB

//====================================================================================================================
int BiDirListRemove(BiDirList *Ld);
//====================================================================================================================
// [@\] Xg̊ǗubN݂̂폜
// [] BiDirList *Ld     F폜Ώۂ̑oXg
// [Ԓl] sBYDIR_LIST_NGAABYDIR_LIST_OKԂB

//====================================================================================================================
int BiDirListRemoveAll(BiDirList *Ld);
//====================================================================================================================
// [@\] XgŜ폜
// [] BiDirList *Ld     F폜Ώۂ̑oXg
// [Ԓl] sBYDIR_LIST_NGAABYDIR_LIST_OKԂB

//====================================================================================================================
BiDirListMember  *BiDirListMemberAdd(BiDirList *Ld,  void *Object, int ObjectSize);
//====================================================================================================================
// [@\] Xg̍ŌɃoǉ(*Object̓Rs[ÃRs[XgɂԂ牺)
// [] BiDirList *Ld     FoXg
// [] void      *Object FǉIuWFNgւ̃|C^
// [] void      *ObjectSize FǉIuWFNg̃TCY
// [Ԓl] sNULLAAǉoւ̃|C^Ԃ

//====================================================================================================================
int BiDirListMemberRemove(BiDirList *Ld,  BiDirListMember *Position);
//====================================================================================================================
// [@\] XgPositoño폜
// [] BiDirList *Ld     FoXg
// [] int       PositionF폜郁ôւ̃|C^
// [Ԓl] sBIDIR_LIST_NGAABIDIR_LIST_OKԂB

//====================================================================================================================
int BiDirListMemberInsertPrev(BiDirList *Ld,  BiDirListMember *Position, void *Object, int ObjectSize);
//====================================================================================================================
// [@\] XgPositon̑OɃoǉ(*Object̓Rs[A
//        ̃Rs[BiDirListMember.ObjectɃXgɂԂ牺)
//        XgȂ΁A擪ɒǉ
// [] BiDirList        *Ld         F*ObjectǉoXg
// [] BiDirListMember  *Position   FIuWFNgǉʒu
// [] void             *Object     FǉIuWFNgւ̃|C^
// [] void             *ObjectSize FǉIuWFNg̃TCY
// [Ԓl] sBIDIR_LIST_NGAABIDIR_LIST_OKԂB

//====================================================================================================================
int BiDirListMemberInsertNext(BiDirList *Ld,  BiDirListMember *Position, void *Object, int ObjectSize);
//====================================================================================================================
// [@\] XgPositoňɃoǉ(*Object̓Rs[A
//        ̃Rs[BiDirListMember.ObjectɃXgɂԂ牺)
//        XgȂ΁A擪ɒǉ
// [] BiDirList        *Ld         F*ObjectǉoXg
// [] BiDirListMember  *Position   FIuWFNgǉʒu
// [] void             *Object     FǉIuWFNgւ̃|C^
// [] void             *ObjectSize FǉIuWFNg̃TCY
// [Ԓl] sBIDIR_LIST_NGAABIDIR_LIST_OKԂB

//====================================================================================================================
BiDirListMember *BiDirListMemberFind(BiDirList *Ld,  BiDirListMember *Position, void *Key);
//====================================================================================================================
// [@\] Ldɓo^ꂽFind֐KeyL[ƂāAXgPosition猟AŏɌoԂB
//        ɎsAȂNULLԂ
// [] BiDirList       *Ld       F*Objecti[oXg
// [] BiDirListMember *Position FJnʒu
// [] void            *Key      FL[ւ̃|C^
// [Ԓl] sNULL
//====================================================================================================================
void *BiDirListObjectFind(BiDirList *Ld, void *Key);
//====================================================================================================================
// [@\] Ldɓo^ꂽFind֐KeyL[ƂāAXg擪猟AŏɌoԂB
//        ɎsAȂNULLԂ
// [] BiDirList       *Ld       F*Objecti[oXg
// [] void            *Key      FL[ւ̃|C^
// [Ԓl] sNULL

//====================================================================================================================
BiDirListMember *BiDirListMemberGet(BiDirList *Ld,  int Position);
//====================================================================================================================
// [@\] Xg̐擪PositonԖڂ̃oւ̃|C^Ԃ
// [] BiDirList *Ld     FoXg
// [] int       PositionFʒui擪 : Position == 0)
// [Ԓl] sNULL

//====================================================================================================================
void *BiDirListObjectGet(BiDirList *Ld,  int Position);
//====================================================================================================================
// [@\] Xg̐擪PositonԖڂ̃oɂԂ牺ĂIuWFNgւ̃|C^Ԃ
// [] BiDirList *Ld     FoXg
// [] int       PositionFʒui擪 : Position == 0)
// [Ԓl] sNULL

//====================================================================================================================
int BiDirListConnect(BiDirList *LdPrev,  BiDirList *LdNext);
//====================================================================================================================
// [@\] LdPrevLdNextA
// [] BiDirList *LdPrev FoXg
// [] BiDirList *LdNext FoXg
// [Ԓl] sBIDIR_LIST_NGAABIDIR_LIST_OKԂB
//====================================================================================================================
int BiDirListSwap(BiDirList *Ld, BiDirListMember *Position0, BiDirListMember *Position1);
//====================================================================================================================
// [@\] Position0ObjectPosition1Objectւ
// [] BiDirList *LdFoXg
// [] BiDirListMember *Position0 FΏۃoʒu
// [] BiDirListMember *Position1 FΏۃoʒu
// [Ԓl] sBIDIR_LIST_NGAABIDIR_LIST_OKԂB
//====================================================================================================================
int BiDirListNumOfMemberGet(BiDirList *Ld);
//====================================================================================================================
// [@\] ݂̗vfԂ
// [] BiDirList *LdFoXg
// [Ԓl] sBIDIR_LIST_NGAA0ȏ̒lԂB
//====================================================================================================================
int BiDirListIndexCreate(BiDirList *Ld);
//====================================================================================================================
// [@\] Xg̃CfbNX\쐬BBiDirListMemberGet()ABiDirListObjectGet()
//        AIndexĹAXgւ̒ǉ/폜/oړn̑֎~B
// [] BiDirList *LdFoXg
// [Ԓl] sBIDIR_LIST_NGAABIDIR_LIST_OKB

#endif // __BIDIR_LIST_H__
