//============================================================
//  TARGET SYSTEM : Psm3Core (Processor Study Model 3 Core)
//  FUNCTION      : Psm3 C Compiler ()
//
//                  Copyright (C) 2009-2010 by Tomoyuki Inomoto
//=============================================================
#include    <stdio.h>
#include    <stdlib.h>
#include    <string.h>

#include    "p3cc.h"



//=========================================================
//  GLOBAL
//=========================================================
//=========================================================
//  for Debug
//=========================================================
//=========================================================
//  PROTOTYPE
//=========================================================
static int JudgeOneCharToken(char c);
static int JudgeStartOfOperator(char c);
static int GetOneCharOperator(char c);
static int GetTwoCharOperator(char *p);
static int GetTriCharOperator(char *p);
static int GetOperator(cc0_result *Cc0Res, cc0_result_handle   *Handle, char *TokenBuf);
static int RegistTokenTable(cc1_result *Cc1Res, int TokenType, int SrcTblIndex, void *ExtInfo);
static int GetIdentifierType(char *p, int StrLen);
static int GetIdentifier(cc0_result *Cc0Res, cc0_result_handle   *Handle, char *TokenBuf);
static int RegistIdentifierTbl(cc1_result *Cc1Res, char *IdentifierString);
static int GetNumLiteral(cc0_result *Cc0Res, cc0_result_handle   *Handle, char *TokenBuf, cc1_numeric_literal *NumericLiteral);
static int GetNumLiteral2(cc0_result *Cc0Res, cc0_result_handle   *Handle, char *TokenBuf, cc1_numeric_literal *NumericLiteral);
static int RegistNumLiteralTbl(cc1_result *Cc1Res, cc1_numeric_literal *NumericLiteral);
static int TokenType2Str(int TokenType, char *Str);
static int GetEscape(char c);
static int GetStringLiteral(cc0_result *Cc0Res, cc0_result_handle   *Handle, char *TokenBuf);
static int RegistStrLiteralTbl(cc1_result *Cc1Res, char *String);


//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// TOP
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
//=========================================================
// [@\] 
// [] vvZbTʂւ̃|C^
// [] g[Ne[uւ̃|C^
// [] őg[N
// [] ʎqe[uւ̃|C^
// [] 񃊃ee[ue[uւ̃|C^
// [] lee[uւ̃|C^
// [Ԓl] P3CC_OKP3CC_NGԂB
//=========================================================
int p3cc1(cc0_result *Cc0Res, cc1_result *Cc1Res)
{
    int                 i;
    int                 Ret;            // ֐̕Ԃl̈ꎞi[p
    cc0_result_handle   Handle;         // Cc0ResANZXp
    int                 CharCounter;    // TokenBuf̕JEg
    char                *SrcFile;       // G[o͗pFƂ̃\[Xt@C
    int                 LineNo;         // G[o͗pFƂ̃\[X̉s߂
    char                *SrcCode;       // G[o͗pFƂ̃\[X̊Ys
    cc1_numeric_literal NumericLiteral; // le̒lꎞi[
    char                TokenBuf[MAX_STRING_LITERAL_CHAR + 1];//g[Nꎞi[p

    // ͌ʊi[p̈m
    Ret = P3cc1ResultAreaGet(Cc1Res, Cc0Res->NumOfSrcLine);
    if(Ret == P3CC_NG){
        return Ret;
    }

    // 
    Handle.SrcTblIndex = 0;
    Handle.CodeIndex = 0;
    CharCounter = 0;
    Cc1Res->TokenTblIndex = 0;
    Cc1Res->IdentifierNum = 0;
    Cc1Res->StrLiteralNum = 0;
    Cc1Res->NumLiteralNum = 0;

    // C[v
    while(1){
        if(CharCounter == 0){ // P
            // g[Nꎞi[pobt@NA(G[\Ɏc[点)
            for(i = 0 ;i < MAX_STRING_LITERAL_CHAR + 1; i++) TokenBuf[i] = '\0';
            // ꕶǂݍ
            TokenBuf[CharCounter] = GetCharFromCc0Res(Cc0Res, &Handle);
            // NULLȂI
            if(TokenBuf[CharCounter] == '\0'){
                Ret = P3CC_OK;
                break;
            }
            // NULLȊȌꍇ
            // Xy[XA^uȂAǂݔ΂Ď
            if(TokenBuf[CharCounter] == ' ') continue;
            if(TokenBuf[CharCounter] == '\t') continue;
            // ꕶg[NȂAʂo^Ď
            Ret = JudgeOneCharToken(TokenBuf[CharCounter]);
            if(Ret != P3CC_NG){
                Ret = RegistTokenTable(Cc1Res, Ret, Handle.SrcTblIndex, NULL);
                if(Ret == P3CC_NG) break;
                continue;
            }
            // Xy[X́Aꕶg[NȊOȂACharCounterXVĎ
            ++CharCounter;
            continue;
        }
        else{ // Q
            // 1ڂZqȂ
            if(JudgeStartOfOperator(TokenBuf[0]) == P3CC_OK){
                Ret = GetOperator(Cc0Res, &Handle, TokenBuf);
                if(Ret == P3CC_NG){
                    GetSrcInfoFromCc0Res(Cc0Res, &Handle, &SrcFile, &LineNo, &SrcCode);
                    fprintf(MsgOut, "yG[z(p3cc1  LINE:%d) ZqɎs  %s %ds [%s]\n", __LINE__, SrcFile, LineNo, TokenBuf);
                    break;
                }
                else{
                    Ret = RegistTokenTable(Cc1Res, Ret, Handle.SrcTblIndex, NULL);
                    if(Ret == P3CC_NG) break;
                }
            }
            // 1ڂAt@xbgorA_[XRAȂ
            else if(IsAlphaAndUnderLine(TokenBuf[0]) == P3CC_OK){
                Ret = GetIdentifier(Cc0Res, &Handle, TokenBuf);
                if(Ret == P3CC_NG) break;
                Ret = RegistTokenTable(Cc1Res, Ret, Handle.SrcTblIndex, (void *)TokenBuf);
                if(Ret == P3CC_NG) break;
            }
            // 1ڂȂ
            else if(IsNum(TokenBuf[0]) == P3CC_OK){
                Ret = GetNumLiteral(Cc0Res, &Handle, TokenBuf, &NumericLiteral);
                if(Ret == P3CC_NG) break;
                Ret = RegistTokenTable(Cc1Res, Ret, Handle.SrcTblIndex, (void *)&NumericLiteral);
                if(Ret == P3CC_NG) break;
            }
            // 1ڂ'Ȃ
            else if(TokenBuf[0] == '\''){
                Ret = GetNumLiteral2(Cc0Res, &Handle, TokenBuf, &NumericLiteral);
                if(Ret == P3CC_NG) break;
                Ret = RegistTokenTable(Cc1Res, Ret, Handle.SrcTblIndex, (void *)&NumericLiteral);
                if(Ret == P3CC_NG) break;
            }
            // 1ڂ"Ȃ
            else if(TokenBuf[0] == '\"'){
                Ret = GetStringLiteral(Cc0Res, &Handle, TokenBuf);
                if(Ret == P3CC_NG) break;
                Ret = RegistTokenTable(Cc1Res, Ret, Handle.SrcTblIndex, (void *)&TokenBuf[1]);
                if(Ret == P3CC_NG) break;
            }
            // ǂɂĂ͂܂Ȃ
            else{
                GetSrcInfoFromCc0Res(Cc0Res, &Handle, &SrcFile, &LineNo, &SrcCode);
                if(TokenBuf[0] == '#'){
                    fprintf(MsgOut, "yINFOz(p3cc1  LINE:%d) %s %ds [ %s ] 𖳎܂\n", __LINE__, SrcFile, LineNo, SrcCode);
                    ForwardCc0ResHandleOneLine(Cc0Res, &Handle);
                }
                else{
                    fprintf(MsgOut, "yG[z(p3cc1  LINE:%d) グłB߂ȂB  %s %ds\n", __LINE__, SrcFile, LineNo);
                    Ret = P3CC_NG;
                    break;
                }
            }
            CharCounter = 0;
        }
    }
#ifdef CC1_DEBUG
    Print_cc1_result(Cc0Res, Cc1Res);
#endif

    return Ret;
}
//=========================================================
// [@\] ͌ i[p̈m
// [] cc1_resultւ̃|C^
// [Ԓl] P3CC_OKP3CC_NGԂB
//=========================================================
int P3cc1ResultAreaGet(cc1_result *Cc1Res, int NumOfSrcLine)
{
#ifdef CC_MSGENABLE
    int     TotalMemSize;
#endif
    // ͌ʊi[p̈m
    Cc1Res->MaxTokenNum = NumOfSrcLine * TOKEN_RATE;
    Cc1Res->TokenTbl = calloc(Cc1Res->MaxTokenNum  , sizeof(cc1_token));
    if(Cc1Res->TokenTbl == NULL){
        fprintf(MsgOut, "yG[z͌ʏo͗p̈mێs TCY%dKoCg\n", Cc1Res->MaxTokenNum / (1024) );
        return P3CC_NG;
    }

    // ʎqe[up̈m
    Cc1Res->IdentifierTbl  = calloc(MAX_IDENTIFIER_TABLE, sizeof(cc1_identifier));
    if(Cc1Res->IdentifierTbl == NULL){
        fprintf(MsgOut, "yG[zʎqe[up̈mێs TCY%dKoCg\n", (MAX_IDENTIFIER_TABLE * sizeof(cc1_identifier)) / (1024) );
        free(Cc1Res->TokenTbl);
        return P3CC_NG;
    }
    // 񃊃ee[up̈m
    Cc1Res->StrLiteralTbl  = calloc(MAX_STRING_LITERAL_TABLE, sizeof(cc1_string_literal));
    if(Cc1Res->StrLiteralTbl == NULL){
        fprintf(MsgOut, "yG[z񃊃ee[up̈mێs TCY%dKoCg\n", (MAX_STRING_LITERAL_TABLE * sizeof(cc1_string_literal)) / (1024) );
        free(Cc1Res->TokenTbl);
        free(Cc1Res->IdentifierTbl);
        return P3CC_NG;
    }

    // lee[up̈m
    Cc1Res->NumLiteralTbl  = calloc(MAX_NUMERIC_LITERAL_TABLE, sizeof(cc1_numeric_literal));
    if(Cc1Res->NumLiteralTbl == NULL){
        fprintf(MsgOut, "yG[zlee[up̈mێs TCY%dKoCg\n", (MAX_NUMERIC_LITERAL_TABLE * sizeof(cc1_numeric_literal)) / (1024) );
        free(Cc1Res->TokenTbl);
        free(Cc1Res->IdentifierTbl);
        free(Cc1Res->StrLiteralTbl);
        return P3CC_NG;
    }
#ifdef CC_MSGENABLE
    TotalMemSize  = Cc1Res->MaxTokenNum * sizeof(cc1_token);
    TotalMemSize += MAX_IDENTIFIER_TABLE * sizeof(cc1_identifier);
    TotalMemSize += MAX_STRING_LITERAL_TABLE * sizeof(cc1_string_literal);
    TotalMemSize += MAX_NUMERIC_LITERAL_TABLE * sizeof(cc1_numeric_literal);
    fprintf(MsgOut, "͌ʊi[p̈mې TCY%dKoCg\n", TotalMemSize/1024);
#endif
    return P3CC_OK;
}
//=========================================================
// [@\] ͌ i[p̈
// [] cc0_resultւ̃|C^
// [Ԓl] P3CC_OKP3CC_NGԂB
//=========================================================
int P3cc1ResultAreaFree(cc1_result *Cc1Res)
{
    int i;
    for(i=0;i < Cc1Res->StrLiteralNum; i++) free(Cc1Res->StrLiteralTbl[i].StringLiteral);
    free(Cc1Res->StrLiteralTbl);
    free(Cc1Res->IdentifierTbl);
    free(Cc1Res->NumLiteralTbl);
    free(Cc1Res->TokenTbl);
    return P3CC_OK;
}
//=========================================================
// [@\] cc1_result̓et@Cɏo
// [] cc0_resultւ̃|C^
// [] cc1_resultւ̃|C^
// [Ԓl] ȂB
//=========================================================
void Print_cc1_result(cc0_result *Cc0Res, cc1_result *Cc1Res)
{
    FILE        *Fp;
    int         Ret;
    int         i;
    int         FileNo;
    int         LineNo;
    int         SrcTblIndex;
    int         TokenType;
    int         ExtInfoIndex;
    char        *File;
    char        Token[MAX_SOURCE_LINE_CHAR];

    Fp = fopen("cc1_result.txt", "w");
    fprintf(Fp, "=====================================\n");
    fprintf(Fp, "===        CC1 RESULT            ====\n");
    fprintf(Fp, "=====================================\n");
    fprintf(Fp, "g[N       : %d\n", Cc1Res->TokenTblIndex);
    fprintf(Fp, "ʎq         : %d\n", Cc1Res->IdentifierNum);
    fprintf(Fp, "񃊃e : %d\n", Cc1Res->StrLiteralNum);
    fprintf(Fp, "le   : %d\n", Cc1Res->NumLiteralNum);
    for(i=0;i<Cc1Res->TokenTblIndex;i++){
        TokenType = Cc1Res->TokenTbl[i].Type;
        SrcTblIndex = Cc1Res->TokenTbl[i].SrcTblIndex;
        ExtInfoIndex = Cc1Res->TokenTbl[i].ExtInfoIndex;
        FileNo = Cc0Res->SrcTbl[SrcTblIndex].SourceFileNo;
        LineNo = Cc0Res->SrcTbl[SrcTblIndex].SourceLineNo;
        File = Cc0Res->SrcFileTbl[FileNo].FileName;
        fprintf(Fp, "%s: %d: %d:", File, LineNo, TokenType);
        if(TokenType == TOKEN_IDENTIFIER){
            fprintf(Fp, "%s",Cc1Res->IdentifierTbl[ExtInfoIndex].Identifier);
        }
        else if(TokenType == TOKEN_STRING_LITERAL){
            fprintf(Fp, "\"%s\"",Cc1Res->StrLiteralTbl[ExtInfoIndex].StringLiteral);
        }
        else if(TokenType == TOKEN_NUMERIC_LITERAL){
            if(Cc1Res->NumLiteralTbl[ExtInfoIndex].Type == DESCRIPTION_HEX){
                fprintf(Fp, "0x%x",Cc1Res->NumLiteralTbl[ExtInfoIndex].Value.FixedPointValue);
            }
            if(Cc1Res->NumLiteralTbl[ExtInfoIndex].Type == DESCRIPTION_DEC){
                fprintf(Fp, "%d",Cc1Res->NumLiteralTbl[ExtInfoIndex].Value.FixedPointValue);
            }
            if(Cc1Res->NumLiteralTbl[ExtInfoIndex].Type == DESCRIPTION_REAL){
                fprintf(Fp, "(_)͖Ή");
                fprintf(Fp, "%d",Cc1Res->NumLiteralTbl[ExtInfoIndex].Value.FloatingPointValue);
            }
        }
        else{
            Ret = TokenType2Str(TokenType, Token);
            if(Ret != P3CC_NG) fprintf(Fp, "%s",Token);
        }

        fprintf(Fp, "\n");
    }
//for(i=0; i<Cc1Res->IdentifierNum; i++){
//  printf("%d: %s\n", i, Cc1Res->IdentifierTbl[i].Identifier);
//}
    fclose(Fp);
}
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
//=========================================================
// [@\] cc1_result֓o^
// [] cc1_resultւ̃|C^
// [] o^g[N
// [] o^g[NʂCc0Res.SrcTblIndex
// [] gւ̃|C^isvȏꍇNULLj
// [Ԓl] P3CC_OK
//        s̏ꍇ́AP3CC_NGԂB
//=========================================================
static int RegistTokenTable(cc1_result *Cc1Res, int TokenType, int SrcTblIndex, void *ExtInfo)
{
    int     Ret;

    Ret = P3CC_OK;

    //o^\`FbN
    if(Cc1Res->TokenTblIndex == Cc1Res->MaxTokenNum){
        fprintf(MsgOut, "yG[z(p3cc1  LINE:%d) g[NMAX(%d)I[o[\n", __LINE__, Cc1Res->MaxTokenNum);
        return P3CC_NG;
    }
    // {o^
    Cc1Res->TokenTbl[Cc1Res->TokenTblIndex].Type = TokenType;
    Cc1Res->TokenTbl[Cc1Res->TokenTblIndex].SrcTblIndex = SrcTblIndex;

    // go^
    if(TokenType == TOKEN_IDENTIFIER){ // ʎq̏ꍇ
        Ret = RegistIdentifierTbl(Cc1Res, (char *)ExtInfo);
        if(Ret != P3CC_NG){
            Cc1Res->TokenTbl[Cc1Res->TokenTblIndex].ExtInfoIndex = Ret;
        }
        else{
            return P3CC_NG;
        }
    }
    if(TokenType == TOKEN_NUMERIC_LITERAL){ // lȅꍇ
        Ret = RegistNumLiteralTbl(Cc1Res, (cc1_numeric_literal *)ExtInfo);
        if(Ret != P3CC_NG){
            Cc1Res->TokenTbl[Cc1Res->TokenTblIndex].ExtInfoIndex = Ret;
        }
        else{
            return P3CC_NG;
        }
    }
    if(TokenType == TOKEN_STRING_LITERAL){ // 񃊃ȅꍇ
        Ret = RegistStrLiteralTbl(Cc1Res, (char *)ExtInfo);
        if(Ret != P3CC_NG){
            Cc1Res->TokenTbl[Cc1Res->TokenTblIndex].ExtInfoIndex = Ret;
        }
        else{
            return P3CC_NG;
        }
    }
    ++Cc1Res->TokenTblIndex;
    return Ret;
}
//=========================================================
// [@\] 񃊃ee[u֓o^
// [] cc1_resultւ̃|C^
// [] o^鎯ʎq̕
// [Ԓl] IdentifierTblIndexio^ꏊj
//        s̏ꍇ́AP3CC_NGԂB
//=========================================================
static int RegistStrLiteralTbl(cc1_result *Cc1Res, char *String)
{
    int     Ret;
    int     Len;

    //o^\`FbN
    if(Cc1Res->StrLiteralNum == MAX_STRING_LITERAL_TABLE){
        fprintf(MsgOut, "yG[z(p3cc1  LINE:%d) 񃊃eMAX(%d)I[o[\n", __LINE__, MAX_STRING_LITERAL_TABLE);
        return P3CC_NG;
    }
    //VKo^
    Len = strlen(String);
    Ret = Cc1Res->StrLiteralNum;
    Cc1Res->StrLiteralTbl[Ret].StringLiteral = malloc(Len + 1);
    if(Cc1Res->StrLiteralTbl[Ret].StringLiteral == NULL){
        fprintf(MsgOut, "yG[z(p3cc1  LINE:%d) 񃊃eMAX(%d)I[o[\n", __LINE__, MAX_STRING_LITERAL_TABLE);
        return P3CC_NG;
    }
    strcpy(Cc1Res->StrLiteralTbl[Ret].StringLiteral, String);
//printf("%d: %s\n",Cc1Res->StrLiteralNum, Cc1Res->StrLiteralTbl[Ret].StringLiteral);
    ++ Cc1Res->StrLiteralNum;
    return Ret;
}
//=========================================================
// [@\] 񃊃e擾
// [] cc0_result
// [] cc0_result_handle
// [] TokenBuf
// [Ԓl] g[N
//        s̏ꍇ́AP3CC_NGԂB
//=========================================================
static int GetStringLiteral(cc0_result *Cc0Res, cc0_result_handle   *Handle, char *TokenBuf)
{
    int     Ret;
    int     i;
    int     Mode;
    cc0_result_handle   HandleBkUp0;    // HandleobNAbvpi߂ׁ̈j
    char    *SrcFile;   // G[o͗pFƂ̃\[Xt@C
    int     LineNo;     // G[o͗pFƂ̃\[X̉s߂
    char    *SrcCode;       // G[o͗pFƂ̃\[X̊Ys

    Mode = NUMSTRLITERAL_NOMAL;
    i = 1;
    while(1){
        if(i > MAX_STRING_LITERAL_CHAR - 1){
            GetSrcInfoFromCc0Res(Cc0Res, Handle, &SrcFile, &LineNo, &SrcCode);
            fprintf(MsgOut, "yG[z(p3cc1  LINE:%d) ̍ő啶%d𒴂Ă܂  %s %ds\n", __LINE__, MAX_STRING_LITERAL_CHAR, SrcFile, LineNo);
            return P3CC_NG;
        }
        CopyCc0ResHndle(&HandleBkUp0, Handle);
        TokenBuf[i] = GetCharFromCc0Res(Cc0Res, Handle);
        if(Mode == NUMSTRLITERAL_NOMAL){
            if(TokenBuf[i] == '\"'){
                TokenBuf[i] = '\0';
                break;
            }
            if(TokenBuf[i] == '\\'){
                Mode = NUMSTRLITERAL_ESCAPE;
                continue;
            }
        }
        else{ // NUMSTRLITERAL_ESCAPE
            Ret = GetEscape(TokenBuf[i]);
            if(Ret != P3CC_NG){
                TokenBuf[i] = (char)Ret;
                Mode = NUMSTRLITERAL_NOMAL;
            }
            else{
                GetSrcInfoFromCc0Res(Cc0Res, Handle, &SrcFile, &LineNo, &SrcCode);
                fprintf(MsgOut, "yG[z(p3cc1  LINE:%d) [%s]͕s\(RgȊȌł͓{͎gȂ)  %s %ds\n", __LINE__, TokenBuf, SrcFile, LineNo);
                return P3CC_NG;
            }
        }
        ++i;
    }
    return TOKEN_STRING_LITERAL;
}
//=========================================================
// [@\] ̂悤Ȑle擾 ) 'a'
// [] cc0_result
// [] cc0_result_handle
// [] TokenBuf
// [] cc1_numeric_literali擾li[j
// [Ԓl] g[N
//        s̏ꍇ́AP3CC_NGԂB
//=========================================================
static int GetNumLiteral2(cc0_result *Cc0Res, cc0_result_handle   *Handle, char *TokenBuf, cc1_numeric_literal *NumericLiteral)
{
    int     Ret;
    int     i;
    int     Mode;
    cc0_result_handle   HandleBkUp0;    // HandleobNAbvpi߂ׁ̈j
    char                *SrcFile;       // G[o͗pFƂ̃\[Xt@C
    int                 LineNo;         // G[o͗pFƂ̃\[X̉s߂
    char                *SrcCode;       // G[o͗pFƂ̃\[X̊Ys

    i = 1;
    while(1){
        if(i > 3){
            GetSrcInfoFromCc0Res(Cc0Res, Handle, &SrcFile, &LineNo, &SrcCode);
            fprintf(MsgOut, "yG[z(p3cc1  LINE:%d) 萔[%s] 1  2 łȂ΂ȂȂ  %s %ds\n", __LINE__, TokenBuf, SrcFile, LineNo);
            return P3CC_NG;
        }
        CopyCc0ResHndle(&HandleBkUp0, Handle);
        TokenBuf[i] = GetCharFromCc0Res(Cc0Res, Handle);
        //if(TokenBuf[i] == ' ') continue;
        //if(TokenBuf[i] == '\t') continue;
        if(i==1){// '̒̕𔻒
            if(TokenBuf[i] == '\''){
                GetSrcInfoFromCc0Res(Cc0Res, Handle, &SrcFile, &LineNo, &SrcCode);
                fprintf(MsgOut, "yG[z(p3cc1  LINE:%d) 萔[%s] 1  2 łȂ΂ȂȂ  %s %ds\n", __LINE__, TokenBuf, SrcFile, LineNo);
                return P3CC_NG;
            }
            else if(TokenBuf[i] == '\\'){
                Mode = NUMSTRLITERAL_ESCAPE;
            }
            else{
                Mode = NUMSTRLITERAL_NOMAL;
            }
        }
        if(i == 2){//Q
            if(Mode == NUMSTRLITERAL_NOMAL){
                if(TokenBuf[i] == '\'') break;
            }
        }
        if(i == 3){//R
            if(TokenBuf[i] == '\'') break;
        }
        ++i;
    }
    TokenBuf[i+1] = '\0';
    NumericLiteral->Type = DESCRIPTION_HEX;
    if(Mode == NUMSTRLITERAL_NOMAL){
        if(i==2){
            NumericLiteral->Value.FixedPointValue = 0xFF & (unsigned long)TokenBuf[1];
        }
        else{
            NumericLiteral->Value.FixedPointValue  = (0xFF & (unsigned long)TokenBuf[1]) << 8;
            NumericLiteral->Value.FixedPointValue |= 0xFF & (unsigned long)TokenBuf[2];
        }
    }
    else{
        Ret = GetEscape(TokenBuf[2]);
        if(Ret != P3CC_NG){
            NumericLiteral->Value.FixedPointValue = (char)Ret;
        }
        else{
            GetSrcInfoFromCc0Res(Cc0Res, Handle, &SrcFile, &LineNo, &SrcCode);
            fprintf(MsgOut, "yG[z(p3cc1  LINE:%d) [%s]͕s\  %s %ds\n", __LINE__, TokenBuf, SrcFile, LineNo);
            return P3CC_NG;
        }
    }
//printf("%s:0x%x\n",TokenBuf, NumericLiteral->Value.FixedPointValue);
    return TOKEN_NUMERIC_LITERAL;
}
//=========================================================
// [@\] g\L擾
// [] g\L̂Q
// [Ԓl] g\LHexR[h
//=========================================================
static int GetEscape(char c)
{
    if     (c == '0') return '\0';
    else if(c == 'a') return '\a';
    else if(c == 'b') return '\b';
    else if(c == 't') return '\t';
    else if(c == 'n') return '\n';
    else if(c == 'v') return '\v';
    else if(c == 'f') return '\f';
    else if(c == 'r') return '\r';
    else if(c == '\"')return '\"';
    else if(c == '\'')return '\'';
    else if(c == '\?')return '\?';
    else if(c == '\\')return '\\';
    else              return P3CC_NG;
}
//=========================================================
// [@\] leǂr
// [] cc1_numeric_literal
// [] cc1_numeric_literal
// [Ԓl] ȂP3CC_OK
//        P3CC_NG
//=========================================================
static int CmpNumericLiteral(cc1_numeric_literal *p0, cc1_numeric_literal *p1)
{
    if(p0->Type != p1->Type) return P3CC_NG;
    if(p0->Type == DESCRIPTION_REAL){
        if(p0->Value.FloatingPointValue != p1->Value.FloatingPointValue) return P3CC_NG;
    }
    else{
        if(p0->Value.FixedPointValue != p1->Value.FixedPointValue) return P3CC_NG;
    }
    return P3CC_OK;
}

//=========================================================
// [@\] leRs[
// [] cc1_numeric_literal
// [] cc1_numeric_literal
// [Ԓl] ȂP3CC_OK
//        P3CC_NG
//=========================================================
static int CopyNumericLiteral(cc1_numeric_literal *d, cc1_numeric_literal *s)
{
    d->Type = s->Type;
    if(s->Type == DESCRIPTION_REAL) d->Value.FloatingPointValue = s->Value.FloatingPointValue;
    else d->Value.FixedPointValue = s->Value.FixedPointValue;
    return P3CC_OK;
}
//=========================================================
// [@\] leo^
// [] cc1_resultւ̃|C^
// [] o^li[cc1_numeric_literal
// [Ԓl] IdentifierTblIndexio^ꏊj
//        s̏ꍇ́AP3CC_NGԂB
//=========================================================
static int RegistNumLiteralTbl(cc1_result *Cc1Res, cc1_numeric_literal *NumericLiteral)
{
    int     i;

    //o^\`FbN
    if(Cc1Res->NumLiteralNum == MAX_NUMERIC_LITERAL_TABLE){
        fprintf(MsgOut, "yG[z(p3cc1  LINE:%d) leMAX(%d)I[o[\n", __LINE__, MAX_NUMERIC_LITERAL_TABLE);
        return P3CC_NG;
    }
    //lo^ς݂`FbN
    for(i=0; i < Cc1Res->NumLiteralNum; i++){
        if(CmpNumericLiteral(NumericLiteral, &Cc1Res->NumLiteralTbl[i]) == P3CC_OK) return i;
    }

    //VKo^
    i = Cc1Res->NumLiteralNum;
    CopyNumericLiteral(&Cc1Res->NumLiteralTbl[i], NumericLiteral);
    ++ Cc1Res->NumLiteralNum;
    return i;

}
//=========================================================
// [@\] le擾
// Ƃ肠A10i16î݂ɑΉB(_)Ή͌ 
// [] cc0_result
// [] cc0_result_handle
// [] TokenBuf
// [] cc1_numeric_literali擾li[j
// [Ԓl] g[N
//        s̏ꍇ́AP3CC_NGԂB
//=========================================================
static int GetNumLiteral(cc0_result *Cc0Res, cc0_result_handle   *Handle, char *TokenBuf, cc1_numeric_literal *NumericLiteral)
{
    int     Ret;
    int     i;
    int     Mode;                       // ̓[h
    cc0_result_handle   HandleBkUp0;    // HandleobNAbvpi߂ׁ̈j
    char                *SrcFile;       // G[o͗pFƂ̃\[Xt@C
    int                 LineNo;         // G[o͗pFƂ̃\[X̉s߂
    char                *SrcCode;       // G[o͗pFƂ̃\[X̊Ys

    if(TokenBuf[0] == '0') Mode = NUMLITERAL_HEX_READY;
    else                   Mode = NUMLITERAL_DEC_MODE;
    i = 1;
    while(1){
        if(i >= MAX_NUMERIC_LITERAL_CHAR){
            GetSrcInfoFromCc0Res(Cc0Res, Handle, &SrcFile, &LineNo, &SrcCode);
            fprintf(MsgOut, "yG[z(p3cc1  LINE:%d) le%dI[o[  %s %ds\n", __LINE__, MAX_NUMERIC_LITERAL_CHAR, SrcFile, LineNo);
            return P3CC_NG;
        }
        CopyCc0ResHndle(&HandleBkUp0, Handle);
        TokenBuf[i] = GetCharFromCc0Res(Cc0Res, Handle);

        if(TokenBuf[i] == '.'){
            GetSrcInfoFromCc0Res(Cc0Res, Handle, &SrcFile, &LineNo, &SrcCode);
            fprintf(MsgOut, "yG[z(p3cc1  LINE:%d) ɂ͖Ή   %s %ds\n", __LINE__,  SrcFile, LineNo);
            return P3CC_NG;
        }
        else{
            if(Mode == NUMLITERAL_DEC_MODE){
                Ret = IsNum(TokenBuf[i]);
            }
            else if(Mode == NUMLITERAL_HEX_READY){
                if(TokenBuf[i] == 'x'){
                    Ret = P3CC_OK;
                    Mode = NUMLITERAL_HEX_MODE;
                }
                else if(IsNum(TokenBuf[i]) == P3CC_OK){
                    GetSrcInfoFromCc0Res(Cc0Res, Handle, &SrcFile, &LineNo, &SrcCode);
                    fprintf(MsgOut, "yG[z(p3cc1  LINE:%d) 8iɂ͖Ή   %s %ds\n", __LINE__, SrcFile, LineNo);
                    return P3CC_NG;
                }
                else{
                    Ret = P3CC_NG;
                    Mode = NUMLITERAL_DEC_MODE;
                }
            }
            else if(Mode == NUMLITERAL_HEX_MODE){
                Ret = IsHex(TokenBuf[i]);
            }
        }
        ++i;
        if(Ret == P3CC_NG){
            //߂
            CopyCc0ResHndle(Handle, &HandleBkUp0);
            break;
        }
    }

    TokenBuf[i-1] = '\0';
//printf("%s:\n", TokenBuf);
    if(Mode == NUMLITERAL_HEX_MODE){
        NumericLiteral->Type = DESCRIPTION_HEX;
        NumericLiteral->Value.FixedPointValue = strtoul(TokenBuf,NULL,16);
    }
    else if(Mode == NUMLITERAL_DEC_MODE){
        NumericLiteral->Type = DESCRIPTION_DEC;
        NumericLiteral->Value.FixedPointValue = strtol(TokenBuf,NULL,10);
    }
    else{
        NumericLiteral->Type = DESCRIPTION_REAL;
        NumericLiteral->Value.FloatingPointValue = 0;
    }
    return TOKEN_NUMERIC_LITERAL;
}
//=========================================================
// [@\] ʎqe[u֓o^
// [] cc1_resultւ̃|C^
// [] o^鎯ʎq̕
// [Ԓl] IdentifierTblIndexio^ꏊj
//        s̏ꍇ́AP3CC_NGԂB
//=========================================================
static int RegistIdentifierTbl(cc1_result *Cc1Res, char *IdentifierString)
{
    int     i;

    //o^\`FbN
    if(Cc1Res->IdentifierNum == MAX_IDENTIFIER_TABLE){
        fprintf(MsgOut, "yG[z(p3cc1  LINE:%d) ʎqMAX(%d)I[o[\n", __LINE__, MAX_IDENTIFIER_TABLE);
        return P3CC_NG;
    }

    //񂪓o^ς݂`FbN
    for(i=0; i < Cc1Res->IdentifierNum; i++){
        if(strcmp(Cc1Res->IdentifierTbl[i].Identifier, IdentifierString) == 0) return i;
    }

    //VKo^
    i = Cc1Res->IdentifierNum;
    strcpy(Cc1Res->IdentifierTbl[i].Identifier, IdentifierString);
    ++ Cc1Res->IdentifierNum;
//printf("%d\n",Cc1Res->IdentifierNum);
    return i;
}
//=========================================================
// [@\] ʎq擾
// [] cc0_result
// [] cc0_result_handle
// [] TokenBuf
// [Ԓl] g[N
//        s̏ꍇ́AP3CC_NGԂB
//=========================================================
static int GetIdentifier(cc0_result *Cc0Res, cc0_result_handle   *Handle, char *TokenBuf)
{
    int     Ret;
    int     i;
    cc0_result_handle   HandleBkUp0;    // HandleobNAbvpi߂ׁ̈j
    char                *SrcFile;       // G[o͗pFƂ̃\[Xt@C
    int                 LineNo;         // G[o͗pFƂ̃\[X̉s߂
    char                *SrcCode;       // G[o͗pFƂ̃\[X̊Ys

    i = 1;
    while(1){
        if(i >= MAX_IDENTIFIER_CHAR - 1){
            GetSrcInfoFromCc0Res(Cc0Res, Handle, &SrcFile, &LineNo, &SrcCode);
            fprintf(MsgOut, "yG[z(p3cc1  LINE:%d) ʎq%dI[o[  %s %ds\n", __LINE__, MAX_IDENTIFIER_CHAR, SrcFile, LineNo);
            return P3CC_NG;
        }
        CopyCc0ResHndle(&HandleBkUp0, Handle);
        TokenBuf[i] = GetCharFromCc0Res(Cc0Res, Handle);
        Ret = IsAlphaAndNumAndUnderLine(TokenBuf[i]);
        ++i;
        if(Ret == P3CC_NG){
            //߂
            CopyCc0ResHndle(Handle, &HandleBkUp0);
            break;
        }
    }
    Ret = GetIdentifierType(TokenBuf, i - 1);
    if(Ret == P3CC_NG){
        GetSrcInfoFromCc0Res(Cc0Res, Handle, &SrcFile, &LineNo, &SrcCode);
        fprintf(MsgOut, "yG[z(p3cc1  LINE:%d) ʎq[%s]莸s  %s %ds\n", __LINE__, TokenBuf,  SrcFile, LineNo);
        return P3CC_NG;
    }
    return Ret;
}
//=========================================================
// [@\] ʎq̃g[NʂԂ
// [] z
// [Ԓl] g[N
//=========================================================
static int GetIdentifierType(char *p, int StrLen)
{
    p[StrLen] = '\0';
    //if(strcmp(p, "volatile" ) == 0) return TOKEN_VOLATILE;
    if(strcmp(p, "volatile" ) == 0){
        fprintf(MsgOut, "yINFOzƂ肠 volatile ͖܂BƂÂƂœKoĂȂ̂ŁASĂ̕ϐvolatile݂Ȃł\n");
        return TOKEN_VOLATILE;
    }
    //if(strcmp(p, "register" ) == 0) return TOKEN_REGISTER;
    if(strcmp(p, "register" ) == 0){
        fprintf(MsgOut, "yINFOzƂ肠 register ͖܂B\n");
        return TOKEN_REGISTER;
    }
    //if(strcmp(p, "const"    ) == 0) return TOKEN_CONST   ;
    if(strcmp(p, "const" ) == 0){
        fprintf(MsgOut, "yINFOzƂ肠 const ͖܂B\n");
        return TOKEN_CONST;
    }
    if(strcmp(p, "auto"     ) == 0) return TOKEN_AUTO    ;
    if(strcmp(p, "static"   ) == 0) return TOKEN_STATIC  ;
    if(strcmp(p, "extern"   ) == 0) return TOKEN_EXTERN  ;
    if(strcmp(p, "signed"   ) == 0) return TOKEN_SIGNED  ;
    if(strcmp(p, "unsigned" ) == 0) return TOKEN_UNSIGNED;
    if(strcmp(p, "void"     ) == 0) return TOKEN_VOID    ;
    if(strcmp(p, "char"     ) == 0) return TOKEN_CHAR    ;
    if(strcmp(p, "short"    ) == 0) return TOKEN_SHORT   ;
    if(strcmp(p, "int"      ) == 0) return TOKEN_INT     ;
    if(strcmp(p, "long"     ) == 0) return TOKEN_LONG    ;
    if(strcmp(p, "float"    ) == 0) {
#ifdef ENABLE_FLOAT
            return TOKEN_FLOAT;
#else
            fprintf(MsgOut, "yG[z߂Ȃ_^[float]͖Ήł\n");
            return P3CC_NG;
#endif
    }
    if(strcmp(p, "double"   ) == 0) {
#ifdef ENABLE_DOUBLE
            return TOKEN_DOUBLE;
#else
            fprintf(MsgOut, "yG[z߂Ȃ{x_^[double]͖Ήł\n");
            return P3CC_NG;
#endif
    }
    if(strcmp(p, "enum"     ) == 0) {
#ifdef ENABLE_DOUBLE
            return TOKEN_FLOAT;
#else
            fprintf(MsgOut, "yG[z߂Ȃ񋓌^[enum]͖Ήł\n");
            return P3CC_NG;
#endif
    }
    if(strcmp(p, "struct"   ) == 0) return TOKEN_STRUCT  ;
    if(strcmp(p, "union"    ) == 0) return TOKEN_UNION   ;
    if(strcmp(p, "typedef"  ) == 0) return TOKEN_TYPEDEF ;
    if(strcmp(p, "if"       ) == 0) return TOKEN_IF      ;
    if(strcmp(p, "else"     ) == 0) return TOKEN_ELSE    ;
    if(strcmp(p, "break"    ) == 0) return TOKEN_BREAK   ;
    if(strcmp(p, "case"     ) == 0) return TOKEN_CASE    ;
    if(strcmp(p, "continue" ) == 0) return TOKEN_CONTINUE;
    if(strcmp(p, "do"       ) == 0) return TOKEN_DO      ;
    if(strcmp(p, "for"      ) == 0) return TOKEN_FOR     ;
    if(strcmp(p, "switch"   ) == 0) return TOKEN_SWITCH  ;
    if(strcmp(p, "goto"     ) == 0) return TOKEN_GOTO    ;
    if(strcmp(p, "return"   ) == 0) return TOKEN_RETURN  ;
    if(strcmp(p, "while"    ) == 0) return TOKEN_WHILE   ;
    if(strcmp(p, "default"  ) == 0) return TOKEN_DEFAULT ;
    if(strcmp(p, "sizeof"   ) == 0) return TOKEN_SIZEOF  ;
    return TOKEN_IDENTIFIER;
}
//=========================================================
// [@\] Zq擾
// [] cc0_result
// [] cc0_result_handle
// [] TokenBuf
// [Ԓl] g[N
//        s̏ꍇ́AP3CC_NGԂB
//=========================================================
static int GetOperator(cc0_result *Cc0Res, cc0_result_handle   *Handle, char *TokenBuf)
{
    int     Ret;
    cc0_result_handle   HandleBkUp0; // HandleobNAbvpi߂ׁ̈j
    cc0_result_handle   HandleBkUp1; // HandleobNAbvpi߂ׁ̈j

    //  QǏo
    CopyCc0ResHndle(&HandleBkUp0, Handle);
    TokenBuf[1] = GetCharFromCc0Res(Cc0Res, Handle);
    CopyCc0ResHndle(&HandleBkUp1, Handle);
    TokenBuf[2] = GetCharFromCc0Res(Cc0Res, Handle);
    TokenBuf[3] = '\0';
    //  RIy[^H
    Ret = GetTriCharOperator(TokenBuf);
    if(Ret == P3CC_NG){
        //  QIy[^H
        TokenBuf[2] = '\0';
        Ret = GetTwoCharOperator(TokenBuf);
        if(Ret == P3CC_NG){
            //  PIy[^
            Ret = GetOneCharOperator(TokenBuf[0]);
            // ߂
            CopyCc0ResHndle(Handle, &HandleBkUp0);
        }
        else{
            CopyCc0ResHndle(Handle, &HandleBkUp1);
        }
    }
    return Ret;
}
//=========================================================
// [@\] RIy[^̃g[NʂԂ
// [] z
// [Ԓl] g[N
//        ȊȌꍇ́AP3CC_NGԂB
//=========================================================
static int GetTriCharOperator(char *p)
{
    if(strcmp(p, "<<=") == 0) return TOKEN_SHIFT_L_EQ;
    if(strcmp(p, ">>=") == 0) return TOKEN_SHIFT_R_EQ;
    if(strcmp(p, "...") == 0) return TOKEN_ELLIPSIS;
    return P3CC_NG;
}
//=========================================================
// [@\] QIy[^̃g[NʂԂ
// [] z
// [Ԓl] g[N
//        ȊȌꍇ́AP3CC_NGԂB
//=========================================================
static int GetTwoCharOperator(char *p)
{
    if(strcmp(p, "->") == 0) return TOKEN_ARROW;
    if(strcmp(p, "++") == 0) return TOKEN_DOUBLE_PLUS ;
    if(strcmp(p, "--") == 0) return TOKEN_DOUBLE_MINUS;
    if(strcmp(p, "<<") == 0) return TOKEN_SHIFT_L;
    if(strcmp(p, ">>") == 0) return TOKEN_SHIFT_R;
    if(strcmp(p, "<=") == 0) return TOKEN_LESS_EQ  ;
    if(strcmp(p, ">=") == 0) return TOKEN_GRATER_EQ;
    if(strcmp(p, "==") == 0) return TOKEN_EQ_EQ    ;
    if(strcmp(p, "!=") == 0) return TOKEN_NOT_EQ   ;
    if(strcmp(p, "&&") == 0) return TOKEN_AND_AND;
    if(strcmp(p, "||") == 0) return TOKEN_OR_OR  ;
    if(strcmp(p, "+=") == 0) return TOKEN_PLUS_EQ ;
    if(strcmp(p, "-=") == 0) return TOKEN_MINUS_EQ;
    if(strcmp(p, "*=") == 0) return TOKEN_MULT_EQ ;
    if(strcmp(p, "/=") == 0) return TOKEN_DIV_EQ  ;
    if(strcmp(p, "%=") == 0) return TOKEN_MOD_EQ  ;
    if(strcmp(p, "&=") == 0) return TOKEN_AND_EQ  ;
    if(strcmp(p, "^=") == 0) return TOKEN_XOR_EQ  ;
    if(strcmp(p, "|=") == 0) return TOKEN_OR_EQ   ;
    return P3CC_NG;
}
//=========================================================
// [@\] ꕶIy[^̃g[NʂԂ
// [] ꕶ
// [Ԓl] g[N
//        ȊȌꍇ́AP3CC_NGԂB
//=========================================================
static int GetOneCharOperator(char c)
{
    if(c == '+') return TOKEN_PLUS      ;
    if(c == '-') return TOKEN_MINUS     ;
    if(c == '*') return TOKEN_ASTERISK  ;
    if(c == '/') return TOKEN_DIV       ;
    if(c == '%') return TOKEN_MOD       ;
    if(c == '&') return TOKEN_AMPERSAND ;
    if(c == '|') return TOKEN_OR        ;
    if(c == '^') return TOKEN_XOR       ;
    if(c == '<') return TOKEN_LESS      ;
    if(c == '>') return TOKEN_GRATER    ;
    if(c == '=') return TOKEN_EQ        ;
    if(c == '!') return TOKEN_EXCLAMATION ;
    if(c == '.') return TOKEN_PERIOD   ;
    return P3CC_NG;
}
//=========================================================
// [@\] ꕶ߂Iy[^̊JnLۂ`FbN
// [] ꕶ
// [Ԓl] ꕶ߂Iy[^̊JnLȂP3CC_OK
//        ȊȌꍇ́AP3CC_NGԂB
//=========================================================
static int JudgeStartOfOperator(char c)
{
    if(c == '-') return P3CC_OK ;
    if(c == '+') return P3CC_OK ;
    if(c == '*') return P3CC_OK ;
    if(c == '/') return P3CC_OK ;
    if(c == '%') return P3CC_OK ;
    if(c == '&') return P3CC_OK ;
    if(c == '|') return P3CC_OK ;
    if(c == '^') return P3CC_OK ;
    if(c == '<') return P3CC_OK ;
    if(c == '>') return P3CC_OK ;
    if(c == '=') return P3CC_OK ;
    if(c == '!') return P3CC_OK ;
    if(c == '.') return P3CC_OK ;
    return P3CC_NG;
}
//=========================================================
// [@\] ꕶg[Nۂ`FbN
// [] ꕶ
// [Ԓl] ꕶg[Nł΁Ãg[Nʂ
//        ȊȌꍇ́AP3CC_NGԂB
//=========================================================
static int JudgeOneCharToken(char c)
{
    if(c == '[') return TOKEN_SQUARE_L ;
    if(c == ']') return TOKEN_SQUARE_R ;
    if(c == '{') return TOKEN_BRACE_L  ;
    if(c == '}') return TOKEN_BRACE_R  ;
    if(c == '(') return TOKEN_BRACKET_L;
    if(c == ')') return TOKEN_BRACKET_R;
    if(c == ':') return TOKEN_COLON    ;
    if(c == ';') return TOKEN_SEMICOLON;
    if(c == ',') return TOKEN_COMMA    ;
    //if(c == '.') return TOKEN_PERIOD   ;
    if(c == '~') return TOKEN_NOT      ;
    if(c == '?') return TOKEN_QUESTION ;
    return P3CC_NG;
}

//=========================================================
// [@\] g[Nʂ𕶎֕ϊ
// [] g[N
// [Ԓl] P3CC_OK
//        s̏ꍇ́AP3CC_NGԂB
//=========================================================
static int TokenType2Str(int TokenType, char *Str)
{
    if(TokenType == TOKEN_VOLATILE ){ strcpy(Str, "volatile"); return P3CC_OK;}
    if(TokenType == TOKEN_REGISTER ){ strcpy(Str, "register"); return P3CC_OK;}
    if(TokenType == TOKEN_CONST    ){ strcpy(Str, "const"   ); return P3CC_OK;}
    if(TokenType == TOKEN_AUTO     ){ strcpy(Str, "auto"    ); return P3CC_OK;}
    if(TokenType == TOKEN_STATIC   ){ strcpy(Str, "static"  ); return P3CC_OK;}
    if(TokenType == TOKEN_EXTERN   ){ strcpy(Str, "extern"  ); return P3CC_OK;}
    if(TokenType == TOKEN_SIGNED   ){ strcpy(Str, "signed"  ); return P3CC_OK;}
    if(TokenType == TOKEN_UNSIGNED ){ strcpy(Str, "unsigned"); return P3CC_OK;}
    if(TokenType == TOKEN_VOID     ){ strcpy(Str, "void"    ); return P3CC_OK;}
    if(TokenType == TOKEN_CHAR     ){ strcpy(Str, "char"    ); return P3CC_OK;}
    if(TokenType == TOKEN_SHORT    ){ strcpy(Str, "short"   ); return P3CC_OK;}
    if(TokenType == TOKEN_INT      ){ strcpy(Str, "int"     ); return P3CC_OK;}
    if(TokenType == TOKEN_LONG     ){ strcpy(Str, "long"    ); return P3CC_OK;}
    if(TokenType == TOKEN_FLOAT    ){ strcpy(Str, "float"   ); return P3CC_OK;}
    if(TokenType == TOKEN_DOUBLE   ){ strcpy(Str, "double"  ); return P3CC_OK;}
    if(TokenType == TOKEN_ENUM     ){ strcpy(Str, "enum"    ); return P3CC_OK;}
    if(TokenType == TOKEN_STRUCT   ){ strcpy(Str, "struct"  ); return P3CC_OK;}
    if(TokenType == TOKEN_UNION    ){ strcpy(Str, "union"   ); return P3CC_OK;}
    if(TokenType == TOKEN_TYPEDEF  ){ strcpy(Str, "typedef" ); return P3CC_OK;}
    if(TokenType == TOKEN_IF       ){ strcpy(Str, "if"      ); return P3CC_OK;}
    if(TokenType == TOKEN_ELSE     ){ strcpy(Str, "else"    ); return P3CC_OK;}
    if(TokenType == TOKEN_BREAK    ){ strcpy(Str, "break"   ); return P3CC_OK;}
    if(TokenType == TOKEN_CASE     ){ strcpy(Str, "case"    ); return P3CC_OK;}
    if(TokenType == TOKEN_CONTINUE ){ strcpy(Str, "continue"); return P3CC_OK;}
    if(TokenType == TOKEN_DO       ){ strcpy(Str, "do"      ); return P3CC_OK;}
    if(TokenType == TOKEN_FOR      ){ strcpy(Str, "for"     ); return P3CC_OK;}
    if(TokenType == TOKEN_SWITCH   ){ strcpy(Str, "switch"  ); return P3CC_OK;}
    if(TokenType == TOKEN_GOTO     ){ strcpy(Str, "goto"    ); return P3CC_OK;}
    if(TokenType == TOKEN_RETURN   ){ strcpy(Str, "return"  ); return P3CC_OK;}
    if(TokenType == TOKEN_WHILE    ){ strcpy(Str, "while"   ); return P3CC_OK;}
    if(TokenType == TOKEN_DEFAULT  ){ strcpy(Str, "default" ); return P3CC_OK;}
    if(TokenType == TOKEN_SIZEOF   ){ strcpy(Str, "sizeof"  ); return P3CC_OK;}
    if(TokenType == TOKEN_SQUARE_L ){ strcpy(Str, "["       ); return P3CC_OK;}
    if(TokenType == TOKEN_SQUARE_R ){ strcpy(Str, "]"       ); return P3CC_OK;}
    if(TokenType == TOKEN_BRACE_L  ){ strcpy(Str, "{"       ); return P3CC_OK;}
    if(TokenType == TOKEN_BRACE_R  ){ strcpy(Str, "}"       ); return P3CC_OK;}
    if(TokenType == TOKEN_BRACKET_L){ strcpy(Str, "("       ); return P3CC_OK;}
    if(TokenType == TOKEN_BRACKET_R){ strcpy(Str, ")"       ); return P3CC_OK;}
    if(TokenType == TOKEN_COLON    ){ strcpy(Str, ":"       ); return P3CC_OK;}
    if(TokenType == TOKEN_SEMICOLON){ strcpy(Str, ";"       ); return P3CC_OK;}
    if(TokenType == TOKEN_COMMA    ){ strcpy(Str, ","       ); return P3CC_OK;}
    if(TokenType == TOKEN_PERIOD   ){ strcpy(Str, "."       ); return P3CC_OK;}
    if(TokenType == TOKEN_ARROW    ){ strcpy(Str, "->"      ); return P3CC_OK;}
    if(TokenType == TOKEN_NOT         ){ strcpy(Str, "~"    ); return P3CC_OK;}
    if(TokenType == TOKEN_DOUBLE_PLUS ){ strcpy(Str, "++"   ); return P3CC_OK;}
    if(TokenType == TOKEN_DOUBLE_MINUS){ strcpy(Str, "--"   ); return P3CC_OK;}
    if(TokenType == TOKEN_PLUS     ){ strcpy(Str, "+"       ); return P3CC_OK;}
    if(TokenType == TOKEN_MINUS    ){ strcpy(Str, "-"       ); return P3CC_OK;}
    if(TokenType == TOKEN_ASTERISK ){ strcpy(Str, "*"       ); return P3CC_OK;}
    if(TokenType == TOKEN_DIV      ){ strcpy(Str, "/"       ); return P3CC_OK;}
    if(TokenType == TOKEN_MOD      ){ strcpy(Str, "%"       ); return P3CC_OK;}
    if(TokenType == TOKEN_AMPERSAND){ strcpy(Str, "&"       ); return P3CC_OK;}
    if(TokenType == TOKEN_OR       ){ strcpy(Str, "|"       ); return P3CC_OK;}
    if(TokenType == TOKEN_XOR      ){ strcpy(Str, "^"       ); return P3CC_OK;}
    if(TokenType == TOKEN_SHIFT_L  ){ strcpy(Str, "<<"      ); return P3CC_OK;}
    if(TokenType == TOKEN_SHIFT_R  ){ strcpy(Str, ">>"      ); return P3CC_OK;}
    if(TokenType == TOKEN_LESS     ){ strcpy(Str, "<"       ); return P3CC_OK;}
    if(TokenType == TOKEN_GRATER   ){ strcpy(Str, ">"       ); return P3CC_OK;}
    if(TokenType == TOKEN_LESS_EQ  ){ strcpy(Str, "<="      ); return P3CC_OK;}
    if(TokenType == TOKEN_GRATER_EQ){ strcpy(Str, ">="      ); return P3CC_OK;}
    if(TokenType == TOKEN_EQ_EQ    ){ strcpy(Str, "=="      ); return P3CC_OK;}
    if(TokenType == TOKEN_NOT_EQ   ){ strcpy(Str, "!="      ); return P3CC_OK;}
    if(TokenType == TOKEN_EXCLAMATION){ strcpy(Str, "!"     ); return P3CC_OK;}
    if(TokenType == TOKEN_AND_AND    ){ strcpy(Str, "&&"    ); return P3CC_OK;}
    if(TokenType == TOKEN_OR_OR      ){ strcpy(Str, "||"    ); return P3CC_OK;}
    if(TokenType == TOKEN_EQ        ){ strcpy(Str, "="      ); return P3CC_OK;}
    if(TokenType == TOKEN_PLUS_EQ   ){ strcpy(Str, "+="     ); return P3CC_OK;}
    if(TokenType == TOKEN_MINUS_EQ  ){ strcpy(Str, "-="     ); return P3CC_OK;}
    if(TokenType == TOKEN_MULT_EQ   ){ strcpy(Str, "*="     ); return P3CC_OK;}
    if(TokenType == TOKEN_DIV_EQ    ){ strcpy(Str, "/="     ); return P3CC_OK;}
    if(TokenType == TOKEN_MOD_EQ    ){ strcpy(Str, "%="     ); return P3CC_OK;}
    if(TokenType == TOKEN_AND_EQ    ){ strcpy(Str, "&="     ); return P3CC_OK;}
    if(TokenType == TOKEN_XOR_EQ    ){ strcpy(Str, "^="     ); return P3CC_OK;}
    if(TokenType == TOKEN_OR_EQ     ){ strcpy(Str, "|="     ); return P3CC_OK;}
    if(TokenType == TOKEN_SHIFT_L_EQ){ strcpy(Str, "<<="    ); return P3CC_OK;}
    if(TokenType == TOKEN_SHIFT_R_EQ){ strcpy(Str, ">>="    ); return P3CC_OK;}
    if(TokenType == TOKEN_QUESTION  ){ strcpy(Str, "?"      ); return P3CC_OK;}
    if(TokenType == TOKEN_ELLIPSIS  ){ strcpy(Str, "..."    ); return P3CC_OK;}
    return P3CC_NG;
}
