//============================================================
//  TARGET SYSTEM : Psm3Core (Processor Study Model 3 Core)
//  FUNCTION      : Psm3pAZuJ version 2.00
//
//                  Copyright (C) 2009-2010 by Tomoyuki Inomoto
//=============================================================

//====================================================================================
//y⑫z
//    ̂ƂARpC̏o͂̓AZũ\[XA
//    AZuƃJʁXɍ̂ʓ|Ȃ̂ŁAAZuJ鎖ɂƂB
//    ܂APSM3́Aʂ͑傫ĂK`SKoCg̃vOg܂Ȃł낤A
//    ́uAZuJv̐݌vR[fBOZԂł܂̂ŁA
//    sx⃁gpʂȂǂ͋CɂȂƂB
//====================================================================================

#include    <stdio.h>
#include    <stdlib.h>
#include    <string.h>


#include    "p3al.h"

#define     TOKEN_READ_DEBUG

//============================================================================================================
//============================================================================================================
//  EXTERN
//============================================================================================================
//============================================================================================================

//============================================================================================================
//============================================================================================================
//  GLOBAL
//============================================================================================================
//============================================================================================================
int             SmallMemory;            //ԎwA̒lP3AL_TRUEȂÓIϐ32KoCgȉ
FILE            *MsgOut = NULL;
FILE            *LogOut = NULL;
//===== ͊֘A =========================
BiDirList       *InputSrcList = NULL;   //\[Xt@CXgB̃Xg̊evfInputSrcFileInfo_t
BiDirList       *IdentifierList = NULL; //ʎqXgB̃Xg̊evf͎ʎq̕
BiDirList       *StrLiteralList = NULL; //񃊃eXgB̃Xg̊evf͕񃊃e̕
BiDirList       *NumLiteralList = NULL; //leXgB̃Xg̊evf͐l(unsigned long)

BiDirList       *Global0 = NULL; //l̃O[oϐXg ̃Xg̊evf͐l(Variable)
BiDirList       *Global1 = NULL; //lL̃O[oϐXg ̃Xg̊evf͐l(Variable)

unsigned long   TotalSizeOfGlobal;
unsigned long   TotalSizeOfGlobal0;
unsigned long   TotalSizeOfGlobal1;
unsigned long   TotalSizeOfCode;
unsigned long   TotalSizeOfReadOnlyData;
unsigned long   AddressOfReadOnlyData;
unsigned long   AddressOfInitData;

unsigned char   *ReadOnlyData = NULL;
unsigned char   *InitData = NULL;

unsigned long   GlobalBaseAddress = 0; // O[oϐ̃x[XAhXA\[XɁA
                                       // .GLOBAL_BASE_ADDRESS  0xXXXXXXXX ̐錾
                                       // ̒l 0xXXXXXXXX gp(r10)鎞̂ݐʂƂȂ

// fobOp
int             ConstantExpressionDebugFlag = 0;
int             DebugFlag = 0;

//============================================================================================================
//============================================================================================================
//  PRIVATE
//============================================================================================================
//============================================================================================================
//-------- ̓f[^n ----------------------------------------


//============================================================================================================
//============================================================================================================
//  PROTOTYPE
//============================================================================================================

//============================================================================================================
static void             PrintHelp(void);
//-------- AZuJ{ ----------------------------------------
static int              P3Al(int argc, char *argv[]);

//-------- ͊֘A ----------------------------------------
static int              P3AlLex(void);
static int              P3AlLexBody(int SrcFileNo);
static int              P3AlLexGetChar(char *p, int *Line, InputSrcFileInfo *SrcInfo, int Mode);
static int              P3AlLexGetCharHandleUpdate(struct SrcListAccessHandle_t *Handle, int Mode);
static int              P3AlLexRegistTokenTable(BiDirList *TokenList, TokenInfo *Token);
static int              P3AlLexJudgeOneCharToken(char c);
static int              P3AlLexGetIdentifier(char *TokenBuf, InputSrcFileInfo *SrcInfo, TokenInfo *Token);
static int              P3AlLexGetIdentifierType(char *p);
static char             *P3AlLexAddIdentifierList(char *Id, BiDirList *IdList);
static char             *P3AlLexAddStrLiteralList(char *Id, BiDirList *IdList);
static unsigned long    *P3AlLexAddNumLiteralList(unsigned long Num, BiDirList *NumList);
static int              P3AlLexGetNumLiteral(char *TokenBuf, InputSrcFileInfo *SrcInfo, TokenInfo *Token);
static int              P3AlLexGetEscapeChar(char c);
static int              P3AlLexGetNumLiteral2(char *TokenBuf, InputSrcFileInfo *SrcInfo, TokenInfo *Token);
static int              P3AlLexGetStringLiteral(char *TokenBuf, InputSrcFileInfo *SrcInfo, TokenInfo *Token);
static int              P3AlPsr1Global1Trim(void);

//-------- \/Ӗ  R[h֘A ----------------------------------------
static int              P3AlPsr(void);
static int              P3AlPsr0(void);
static int              P3AlPsr1(void);
static int              P3AlPsr2(void);
static int              P3AlPsr0Body(TokenAccessHandler *TokenHandle);
static TokenInfo        *P3AlPsrTokenGet(BiDirList   *TokenList, int TokenIndex);
static int              P3AlPsr0IncTokenIndex(TokenAccessHandler *TokenHandle);
static int              P3AlPsrTokenSkip2LF(TokenAccessHandler *TokenHandle);
static int              P3AlPsr0VariableGet(TokenAccessHandler *TokenHandle);
static int              P3AlPsr0FunctionGet(TokenAccessHandler *TokenHandle);
static int              P3AlPsr0GlobalBaseGet(TokenAccessHandler *TokenHandle);
static int              P3AlPsr0CodeGet(TokenAccessHandler *TokenHandle);
static unsigned long    P3AlPsr1CodeAlloc(void);
static long             P3AlPsr1VariableAlloc(int Mode, BiDirList *VList);
static long             P3AlPsr1VariableAllocBody(int Mode, BiDirList *VList);
static int              P3AlPsr1LocalAndArgAlloc(void);
static int              P3AlPsr1InitializerAlloc(void);
static int              P3AlPsr1MakeReadOnlyData(void);
static Function         *P3AlPsrFindFunction(char *FuncName);
static int              P3AlPsr1InitDataTrim(void);
static int              P3AlPsr1LocalLabelCheck(void);
static int              P3AlPsr2CodeGen(Function *f, BiDirList *TokenList);
static int              P3AlPsr2HexCodeGen(Function *f, BiDirList *TokenList, int   CodeIndex);
static void             P3AlPsr2PrintError(TokenInfo *Token, int Line);
static void             P3AlPsr2PrintError2(char *FileName, int FileLine, int Line);
static int              P3AlPsr2BranchCodeGen(unsigned long OpCode, Function *f, BiDirList *TokenList, int *TokenIndex, int *NumOfToken, CodeInfo *Code);
static int              P3AlPsr2GetRegNo(int TokenType);
static int              P3AlPsr2Imm24RangeCheck(unsigned long Imm);
static int              P3AlPsr2Imm16RangeCheck(unsigned long Imm);
static int              P3AlPsr2UnsignedImm16RangeCheck(unsigned long Imm);
static int              P3AlPsr2LdStCodeGen(unsigned long OpCode, Function *f, BiDirList *TokenList, int *TokenIndex, int *NumOfToken, CodeInfo *Code);

#ifdef TOKEN_READ_DEBUG
static TokenInfo        *P3AlPsr2NewTokenGet(BiDirList   *TokenList, int *TokenIndex, int *NumOfToken, int Line);
#else
static TokenInfo        *P3AlPsr2NewTokenGet(BiDirList   *TokenList, int *TokenIndex, int *NumOfToken);
#endif

static int              P3AlPsr2ConstExpressionTop(unsigned long *Result, Function *f, BiDirList *TokenList, int *TokenIndex, int *NumOfToken, unsigned long Adr);
static int              P3AlPsr2ConstExpressionBitOr(unsigned long *Result, Function *f, BiDirList *TokenList, int *TokenIndex, int *NumOfToken, unsigned long Adr);
static int              P3AlPsr2ConstExpressionBitXor(unsigned long *Result, Function *f, BiDirList *TokenList, int *TokenIndex, int *NumOfToken, unsigned long Adr);
static int              P3AlPsr2ConstExpressionBitAnd(unsigned long *Result, Function *f, BiDirList *TokenList, int *TokenIndex, int *NumOfToken, unsigned long Adr);
static int              P3AlPsr2ConstExpressionShift(unsigned long *Result, Function *f, BiDirList *TokenList, int *TokenIndex, int *NumOfToken, unsigned long Adr);
static int              P3AlPsr2ConstExpressionAddaptive(unsigned long *Result, Function *f, BiDirList *TokenList, int *TokenIndex, int *NumOfToken, unsigned long Adr);
static int              P3AlPsr2ConstExpressionMultiplicative(unsigned long *Result, Function *f, BiDirList *TokenList, int *TokenIndex, int *NumOfToken, unsigned long Adr);
static int              P3AlPsr2ConstExpressionPrimary(unsigned long *Result, Function *f, BiDirList *TokenList, int *TokenIndex, int *NumOfToken, unsigned long Adr);
static int              P3AlPsr2LabelAdrGet(unsigned long *Result, Function *f, char *Label);
static int              P3AlPsr2LdStWithUpDateCheck(unsigned long OpCode);
static int              P3AlPsr2SysCodeGen(unsigned long OpCode, char *FileName, int Line, int *NumOfToken, CodeInfo *Code);
static int              P3AlPsr2ImmsetGen(char *FileName, int Line, Function *f, BiDirList *TokenList, int *TokenIndex, int *NumOfToken, CodeInfo *Code);
static int              P3AlPsr2CpCodeGen(char *FileName, int Line);
static int              P3AlPsr2CalcCodeGen(unsigned long OpCode, Function *f, BiDirList *TokenList, int *TokenIndex, int *NumOfToken, CodeInfo *Code);

//-------- Xg֘A(ėp) ----------------------------------------
static int              FindStr(BiDirListMember *Position, void *Key);
static int              FindNum(BiDirListMember *Position, void *Key);
static int              FindVariable(BiDirListMember *Position, void *Key);
static int              FindFunction(BiDirListMember *Position, void *Key);
static int              FindLabel(BiDirListMember *Position, void *Key);

//-------- Oit@CǍ݂Ǝ́j֘A ----------------------------------
static int              ReadSrcFile(int Mode, int argc, char *argv[]);
static void             ReadSrcRemoveComment(char *p);
static int              ReadSrcEquPermutation(char *buf, BiDirList *EquList);
static int              ReadSrcStrPermutation(char *buf, char *BeforeStr, char *AfterStr);
static int              ReadSrcEquAnalsys(char *buf, BiDirList *EquList);

//-------- 񑀍֘A ----------------------------------------
static int              FileExtensionSwitch(char *In, char *Out, char *Ext);
static int              FileExtensionCut(char *In, char *Out);
static int              IsChar(char c, char *s);
static int              IsAlphaAndUnderLineDol(char c);
static int              IsAlphaAndNumAndUnderLine(char c);
static int              IsAlNumUnderLineAtDotDol(char c);
static int              IsNum(char c);
static int              IsHex(char c);
static long             str2long(char *p);


//-------- ʏo͊֘A ----------------------------------------
static int              OutputList(char *FileName);
static CodeInfo         *OutputListFindCodeByLine(BiDirList *FunctionList, int SrcLine);
static int              OutputMap(char *FileName);
static int              OutputMapVariable(FILE *Fp, Variable *v, unsigned long BaseAddress);
static void             OutputInfo(void);


//-------- fobO֘A ----------------------------------------
//static void           PrintWarning(int Line, char *Str0, char *Str1, char *Str2);
//static void           PrintInfo(int Line, char *Str0, char *Str1, char *Str2);
//static void           PrintError(int Line, char *Str0, char *Str1, char *Str2);
static void             PrintError0(int Line, char *Str0, char *Str1, char *Str2);
static void             PrintSrcFile(int);
static void             PrintToken(void);
static void             PrintTokenBody0(char *buf, TokenInfo  *Token);
static void             PrintTokenBody(char *buf, TokenInfo  *Token);
static void             PrintEqu(BiDirList *EquList);
static void             PrintVariableBody(Variable *v);
static void             PrintVariable(BiDirList *VariableList);
static void             PrintGlobal(void);
static void             PrintFunctionBody(Function *f, BiDirList *TokenList);
static void             PrintFunction(void);
static void             PrintCode(BiDirList *CodeList, BiDirList *TokenList);
static void             PrintCodeBody(CodeInfo *Code, BiDirList *TokenList);
static void             PrintReadOnlyData(void);
static void             PrintInitData(void);


//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// MAIN
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
//=====================================================================================================================
int  main(int argc, char *argv[])
//=====================================================================================================================
// [@\] AZuJ  main
// []
// [Ԓl] FP3AS_OKAsFP3AS_NG
{
    int     Ret;
    printf("PSM3Dp AZuJ %d.%d.%d  Copyright (C) 2009 mototom\n", VERSION_MAJOR, VERSION_MINER, VERSION_SUB_MINER);
    if(argc < 3){
        printf("gNG\n");
        PrintHelp();
        return 0;
    }
    
    if(strcmp(argv[1], "-s") == 0){
        SmallMemory = P3AL_TRUE;
        if(argc == 3){
            printf("gNG\n");
            PrintHelp();
            return 0;
        }
    }
    else{
        SmallMemory = P3AL_FALSE;
    }
    
    Ret = P3Al(argc, argv);

    if(Ret == P3AL_OK){
        printf("I\n");
    }
    else{
        printf("~ُI~\n");
    }
    return Ret;
}
//=====================================================================================================================
static void    PrintHelp(void)
//=====================================================================================================================
// [@\] AZuJ  HELP\
// [] Ȃ
// [Ԓl] Ȃ
{
    printf("g\n");
    printf("p3al.exe [-s] output_file input_file1.asm input_file2.asm ...\n");
    printf(" output_fileFo̓t@C(gqȂ) o͂Ƃoutput_file.lstoutput_file.map쐬\n");
    printf(" input_file1.asmF͂AZu\[Xt@CBw肷ꍇ͏L̗̂悤ɃXy[Xŋ؂\n");
    printf("                  ŏ̃t@CvO̐擪ƂȂ̂ŁAŏ̃t@C̓X^[gAbv[`w肷邱ƁB\n");
    printf("A-stƁAÓIϐ̗̈32KoCgȉɐ񂳂ɁA኱Ȃ\n");
    printf("    -sȗƁAÓIϐ̗̈̐񂪂ȂɁA኱xȂ\n");
    printf("     -stꍇ́ARpC邷ׂẴ\[X-swŃRpCA\n");
    printf("       JAZuł-stKv\n");
}
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// MAIN
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
//=====================================================================================================================
static int  P3Al(int argc, char *argv[])
//=====================================================================================================================
// [@\] AZuJ  {
// []
// [Ԓl] FP3AS_OKAsFP3AS_NG
{
    char        *OutPutFileName;
#ifdef P3AL_DEBUG
    DebugFlag = 1;
    ConstantExpressionDebugFlag = 1;
#endif

    MsgOut = stderr;

#ifdef P3AL_LOG
    LogOut = fopen("p3al_log.txt", "w");
#else
    LogOut = stdout;
#endif


    InputSrcList = BiDirListCreate(NULL, NULL);
    IdentifierList = BiDirListCreate(NULL, FindStr);
    StrLiteralList = BiDirListCreate(NULL, FindStr);
    NumLiteralList = BiDirListCreate(NULL, FindNum);
    Global0 = BiDirListCreate(NULL, FindVariable);
    Global1 = BiDirListCreate(NULL, FindVariable);

    if(ReadSrcFile(FILE_READ_AND_TRIM, argc, argv) == P3AL_NG) return P3AL_NG;
    //PrintSrcFile(0);
    //PrintSrcFile(1);
    if(P3AlLex() == P3AL_NG) return P3AL_NG;
    //PrintToken();

    if(P3AlPsr() == P3AL_NG) return P3AL_NG;
    if(DebugFlag){
        PrintGlobal();
        PrintFunction();
        PrintReadOnlyData();
        PrintInitData();
    }


    if(SmallMemory == P3AL_TRUE){
        OutPutFileName = argv[2];
    }
    else{
        OutPutFileName = argv[1];
    }
    
    if(OutputList(OutPutFileName) == P3AL_NG)  return P3AL_NG;
    if(OutputMap(OutPutFileName) == P3AL_NG)  return P3AL_NG;

    OutputInfo();
#ifdef P3AL_LOG
    fclose(LogOut);
#endif

    return P3AL_OK;
}
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// ʏo͊֘A
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
//=====================================================================================================================
static void  OutputInfo(void)
//=====================================================================================================================
// [@\] ʏo
// []
// [Ԓl] FP3AL_OKAsFP3AL_NG
{
    if(TotalSizeOfCode != 0){
        printf("CODE(PROGRAM) F0x%08x - 0x%08x : %dbytes\n", 0, TotalSizeOfCode - 1, TotalSizeOfCode);
    }
    if(TotalSizeOfReadOnlyData != 0){
        printf("READ_ONLY_DATAF0x%08x - 0x%08x : %dbytes\n", TotalSizeOfCode, TotalSizeOfCode + TotalSizeOfReadOnlyData - 1, TotalSizeOfReadOnlyData);
    }
    if(TotalSizeOfGlobal1 != 0){
        printf("INIT_DATA     F0x%08x - 0x%08x : %dbytes\n", TotalSizeOfCode + TotalSizeOfReadOnlyData, TotalSizeOfCode + TotalSizeOfReadOnlyData + TotalSizeOfGlobal1 - 1, TotalSizeOfGlobal1);
    }
}
//=====================================================================================================================
static int  OutputMap(char *FileName)
//=====================================================================================================================
// [@\] MAPo
// []
// [Ԓl] FP3AL_OKAsFP3AL_NG
{
    int                 i, j, k, len;
    FILE                *Fp;
    int                 NumOfFiles;
    InputSrcFileInfo    *SrcInfo;
    Function            *f;
    int                 NumOfFunc;
    Variable            *v;
    int                 NumOfVariable;
    char                MapFileName[256];

#ifdef P3AL_MSGENABLE
        printf(" %s.mapo", FileName);
#endif

    i = strlen(FileName);
    if((i < 1) || (i > (256 - 5))){
        PrintError0(__LINE__, "o̓t@C", "", "");
    }
    sprintf(MapFileName, "%s.map",FileName);
    Fp = fopen(MapFileName, "w");

    fprintf(Fp,"___BEGIN_PROGRAM_LABELS___\n");

    NumOfFiles = BiDirListNumOfMemberGet(InputSrcList);
    for(i = 0; i < NumOfFiles; i++){
#ifdef P3AL_MSGENABLE
        printf(".");
#endif
        SrcInfo = (InputSrcFileInfo *)BiDirListObjectGet(InputSrcList, i);
        NumOfFunc = BiDirListNumOfMemberGet(SrcInfo->FunctionList);
        for(j = 0; j < NumOfFunc; j++){
            f = (Function *)BiDirListObjectGet(SrcInfo->FunctionList, j);
            len = strlen(f->Name);
            fprintf(Fp, "%s", f->Name);
            for(k = 20 - len; k > 0; k--) fprintf(Fp, " ");
            fprintf(Fp, ":0x%08x :", f->EntryAddress);
            len = strlen(f->FileName);
            fprintf(Fp, "%s", f->FileName);
            for(k = 20 - len; k > 0; k--) fprintf(Fp, " ");
            fprintf(Fp, ":(Function Entry Point)\n");
        }
    }

    fprintf(Fp,"___END_PROGRAM_LABELS___\n");



    fprintf(Fp,"___BEGIN_GLOBAL_VARIABLES___\n");

    NumOfVariable = BiDirListNumOfMemberGet(Global0);
    for(i = 0; i < NumOfVariable; i++){
        v = (Variable *)BiDirListObjectGet(Global0, i);
        OutputMapVariable(Fp, v, GlobalBaseAddress);
    }
#ifdef P3AL_MSGENABLE
        printf(" .");
#endif

    NumOfVariable = BiDirListNumOfMemberGet(Global1);
    for(i = 0; i < NumOfVariable; i++){
        v = (Variable *)BiDirListObjectGet(Global1, i);
        OutputMapVariable(Fp, v, GlobalBaseAddress);
    }
#ifdef P3AL_MSGENABLE
        printf(" .");
#endif

    fprintf(Fp,"___END_GLOBAL_VARIABLES___\n");
#ifdef P3AL_MSGENABLE
        printf("\n");
#endif

    fclose(Fp);
    return P3AL_OK;
}
//=====================================================================================================================
static int  OutputMapVariable(FILE *Fp, Variable *v, unsigned long BaseAddress)
//=====================================================================================================================
// [@\] MAPo
// []
// [Ԓl] FP3AL_OKAsFP3AL_NG
{
    int     k, len;

    fprintf(Fp, "0x%08x : %8d:  : %s", v->Offset + BaseAddress, v->Offset, v->Name);
    len = strlen(v->Name);
    for(k = 20 - len; k > 0; k--) fprintf(Fp, " ");
    fprintf(Fp, ":  :  :%8d\n", v->Size);
    return P3AL_OK;
}
//=====================================================================================================================
static void  OutputListTrimSrc(char *Src)
//=====================================================================================================================
// [@\] \[X':'Xy[XɕϊifobKŋ؂蕶'F'ɂĂ̂Łj
// []
// [Ԓl] FP3AL_OKAsFP3AL_NG
{
    while(*Src != NULL){
        if(*Src == ':') *Src = ' ';
        ++Src;
    }
}

//=====================================================================================================================
static int  OutputList(char *FileName)
//=====================================================================================================================
// [@\] Xgo
// []
// [Ԓl] FP3AL_OKAsFP3AL_NG
{
    FILE                *Fp;
    int                 NumOfFiles;
    int                 i, j;
    InputSrcFileInfo    *SrcInfo;
    char                *SrcStr;
    int                 NumOfLine;
    CodeInfo            *Code;
    char                ListFileName[256];
    unsigned long       Data, k;

#ifdef P3AL_MSGENABLE
        printf(" %s.lsto", FileName);
#endif

    i = strlen(FileName);
    if((i < 1) || (i > (256 - 5))){
        PrintError0(__LINE__, "o̓t@C", "", "");
    }
    sprintf(ListFileName, "%s.lst",FileName);
    Fp = fopen(ListFileName, "w");

    NumOfFiles = BiDirListNumOfMemberGet(InputSrcList);
    for(i = 0; i < NumOfFiles; i++){
#ifdef P3AL_MSGENABLE
        printf(".");
#endif
        SrcInfo = (InputSrcFileInfo *)BiDirListObjectGet(InputSrcList, i);
        NumOfLine = BiDirListNumOfMemberGet(SrcInfo->OrgSrcList);
        for(j = 0; j < NumOfLine; j++){
            SrcStr = (char *)BiDirListObjectGet(SrcInfo->OrgSrcList, j);
            Code = OutputListFindCodeByLine(SrcInfo->FunctionList, j);
            if(Code == NULL){
                fprintf(Fp, "          :          :    ");
            }
            else{
                fprintf(Fp, "0x%08x:0x%08x:    ", Code->Address, Code->HexCode);

            }
            OutputListTrimSrc(SrcStr);
            fprintf(Fp, ":%s", SrcStr);
        }
    }

    if(TotalSizeOfReadOnlyData != 0){
        for(k = 0; k < TotalSizeOfReadOnlyData; k++){
            if(k%4 ==0) Data  = (ReadOnlyData[k] << 24) & 0xFF000000;
            if(k%4 ==1) Data |= (ReadOnlyData[k] << 16) & 0x00FF0000;
            if(k%4 ==2) Data |= (ReadOnlyData[k] << 8)  & 0x0000FF00;
            if(k%4 ==3){
                Data |= ReadOnlyData[k] & 0x00000FF;
                fprintf(Fp, "0x%08x:0x%08x:    :read only data\n", (AddressOfReadOnlyData + k - 3), Data);
            }
        }
    }
    if(TotalSizeOfGlobal1 != 0){
        for(k = 0; k < TotalSizeOfGlobal1; k++){
            if(k%4 ==0) Data  = (InitData[k] << 24) & 0xFF000000;
            if(k%4 ==1) Data |= (InitData[k] << 16) & 0x00FF0000;
            if(k%4 ==2) Data |= (InitData[k] << 8)  & 0x0000FF00;
            if(k%4 ==3){
                Data |= InitData[k] & 0x00000FF;
                fprintf(Fp, "0x%08x:0x%08x:    :init data\n", (AddressOfInitData + k - 3), Data);
            }
        }
    }
#ifdef P3AL_MSGENABLE
        printf("\n");
#endif


    fclose(Fp);
    return P3AL_OK;
}

//=====================================================================================================================
static CodeInfo  *OutputListFindCodeByLine(BiDirList *FunctionList, int SrcLine)
//=====================================================================================================================
// [@\] w肳ꂽ\[X̃CNoɑΉR[hT
// []
// [Ԓl] FCodeInfoւ̃|C^AsFNULL
{
    int                 i,j;
    Function            *f;
    int                 NumOfFunc;
    int                 NumOfCode;
    CodeInfo            *Code;

    NumOfFunc = BiDirListNumOfMemberGet(FunctionList);
    for(i = 0; i < NumOfFunc; i++){
        f = (Function *)BiDirListObjectGet(FunctionList, i);
        NumOfCode = BiDirListNumOfMemberGet(f->CodeList);
        for(j = 0; j < NumOfCode; j++){
            Code = (CodeInfo *)BiDirListObjectGet(f->CodeList, j);
            if(Code->Line == SrcLine) return Code;
        }
    }
    return NULL;
}

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// O֘A
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
//=====================================================================================================================
static int  ReadSrcFile(int Mode, int argc, char *argv[])
//=====================================================================================================================
// [@\] ׂẴ\[Xt@Cǂݍ
// [] ̓t@Cargv̂RԖڂ
// [Ԓl] FP3AL_OKAsFP3AL_NG
{
    int                 StartArg;
    int                 i, j, Length;
    InputSrcFileInfo    Info;
    FILE                *Fp;
    char                buf[MAX_LINE_LENGTH + 1];
    char                Msg[1024];

    if(SmallMemory == P3AL_TRUE){
        StartArg = 3;
    }
    else{
        StartArg = 2;
    }
    for(i = StartArg; i < argc; i++){
        Info.FileName = argv[i];
        Info.SrcList  = BiDirListCreate(NULL, NULL);
        Info.OrgSrcList = BiDirListCreate(NULL, NULL);
        Info.TokenList  = BiDirListCreate(NULL, NULL);
        Info.EquList  = BiDirListCreate(NULL, NULL);
        Info.FunctionList  = BiDirListCreate(NULL, FindFunction);
        Fp = fopen(argv[i], "r");
        if(Fp == NULL){
            PrintError0(__LINE__, argv[i], "̃I[vɎs", "");
            return P3AL_NG;
        }
#ifdef P3AL_MSGENABLE
        printf(" READ FILE :%s\n",argv[i]);
#endif
        j = 0;
        while(1){
            if(feof(Fp)) break;
            if(fgets(buf, (MAX_LINE_LENGTH), Fp) == NULL) break;
            ++j;
            Length = strlen(buf) + 1;
            if(Length >= MAX_LINE_LENGTH - 1){
                sprintf(Msg, "t@CǍݎsB%s%dsځBPs̕%d𒴂Ă܂B", Info.FileName, j, MAX_LINE_LENGTH - 1);
                PrintError0(__LINE__, Msg, "", "");
                return P3AL_NG;
            }
            if(BiDirListMemberAdd(Info.OrgSrcList, buf, Length) == NULL){
                PrintError0(__LINE__, argv[i], "t@CǍݎsB", "");
                return P3AL_NG;
            }
            if(Mode == FILE_READ_AND_TRIM){
                ReadSrcRemoveComment(buf);
                if(ReadSrcEquPermutation(buf, Info.EquList) == P3AL_NG){
                    sprintf(Msg, "t@CǍݎsB%s%dsځB.EQU̒uɎsB", Info.FileName, j);
                    PrintError0(__LINE__, Msg, "", "");
                }
            }
            Length = strlen(buf) + 1;
            if(BiDirListMemberAdd(Info.SrcList, buf, Length) == NULL){
                PrintError0(__LINE__, argv[i], "t@CǍݎsB", "");
                return P3AL_NG;
            }
        }
        fclose(Fp);
        if(BiDirListMemberAdd(InputSrcList, &Info, sizeof(BiDirList)) == NULL){
            PrintError0(__LINE__, argv[i], "t@CǍݎsB", "");
            return P3AL_NG;
        }
        //PrintEqu(Info.EquList);
    }

    return P3AL_OK;
}


//====================================================================================================================
static void ReadSrcRemoveComment(char *buf)
//====================================================================================================================
// [@\] "//"'\0'Œu
// []
// [Ԓl]
{
    char                *CommentTop;
    CommentTop = strstr(buf, "//");
    if(CommentTop != NULL){
        *CommentTop = '\n';
        ++CommentTop;
        *CommentTop = '\0';
    }
}

//====================================================================================================================
static int ReadSrcEquPermutation(char *buf, BiDirList *EquList)
//====================================================================================================================
// [@\] .EQȔ
// []
// [Ԓl] P3AL_OK/P3AL_NG
{
    int                 i;
    EquInfo             *Equ;

    for(i = 0; i < EquList->NumOfMember; i++){
        Equ = BiDirListObjectGet(EquList, i);
        if(ReadSrcStrPermutation(buf, Equ->BeforeStr, Equ->AfterStr) == P3AL_NG) return P3AL_NG;
    }
    return ReadSrcEquAnalsys(buf, EquList);
}
//====================================================================================================================
static int ReadSrcEquAnalsys(char *buf, BiDirList *EquList)
//====================================================================================================================
// [@\] buf.EQU`邩ǂ肵A`݂AEquList֓o^
// []
// [Ԓl] P3AL_OK/P3AL_NG
{
    char                *p;
    EquInfo             Equ;
    char                TmpBuf[MAX_LINE_LENGTH + 1];

    strcpy(TmpBuf, buf); // strtok()͑Ώەj󂷂̂ŁARs[B
    p = strtok(TmpBuf, " \t");
    if(p == NULL) return P3AL_OK;
    if(strcmp(p, ".EQU") == 0){
        p = strtok(NULL, " \t");
        if(p == NULL) return P3AL_NG;
        Equ.BeforeStr = malloc(strlen(p));
        strcpy(Equ.BeforeStr, p);
        p = strtok(NULL, "\n");
        if(p == NULL) return P3AL_NG;
        Equ.AfterStr = malloc(strlen(p));
        strcpy(Equ.AfterStr, p);
        if(BiDirListMemberAdd(EquList, (void *)&Equ, sizeof(EquInfo)) == NULL) return P3AL_NG;
        buf[0] = '\n';
        buf[1] = '\0';
    }
    return P3AL_OK;
}
//====================================================================================================================
static int ReadSrcStrPermutation(char *buf, char *BeforeStr, char *AfterStr)
//====================================================================================================================
// [@\] buf̒̕BeforeStrAfterStrɒu
// []
// [Ԓl] P3AL_OK/P3AL_NG
{
    int                 i,j;
    int                 BeforeStrLen;
    int                 AfterStrLen;
    char                TmpBuf[MAX_LINE_LENGTH + 1];

    BeforeStrLen = strlen(BeforeStr);
    AfterStrLen = strlen(AfterStr);
    i = 0;
    j = 0;
    while(1){
        if(buf[i] == NULL) break;
        if(j > MAX_LINE_LENGTH - 1) return P3AL_NG;
        if((strncmp(&buf[i], BeforeStr, BeforeStrLen) == 0)
        && (IsChar(buf[i + BeforeStrLen], " \t\n\r[]{}():;,~+*-/%&|^=") == P3AL_OK)
        && ((i == 0) || ((i>0) && (IsChar(buf[i - 1], " \t\n\r[]{}():;,~+*-/%&|^=") == P3AL_OK)))){
            strncpy(&TmpBuf[j], AfterStr, AfterStrLen);
            i += BeforeStrLen;
            j += AfterStrLen;
        }
        else{
            TmpBuf[j++] = buf[i++];
        }
    }
    TmpBuf[j] = '\0';
    strcpy(buf, TmpBuf);
    return P3AL_OK;
}
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// ͊֘A
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
//====================================================================================================================
static int P3AlLex(void)
//====================================================================================================================
// [@\] 
// []
// [Ԓl] FP3AL_OK, sFP3AL_NG
{
    int                 NumOfFiles;
    int                 i;

    NumOfFiles = BiDirListNumOfMemberGet(InputSrcList);
#ifdef P3AL_MSGENABLE
        printf(" ");
#endif
    for(i = 0; i < NumOfFiles; i++){
#ifdef P3AL_MSGENABLE
        printf(".");
#endif
        if(P3AlLexBody(i) == P3AL_NG){
            PrintError0(__LINE__, "͎sB", "", "");
            return P3AL_NG;
        }
    }
#ifdef P3AL_MSGENABLE
        printf("\n");
#endif
    return P3AL_OK;
}
//====================================================================================================================
static int P3AlLexBody(int SrcFileNo)
//====================================================================================================================
// [@\] ͖{
// []
// [Ԓl] FP3AL_OK, sFP3AL_NG
{
    InputSrcFileInfo    *SrcInfo;
    int                 i;
    int                 Line;
    int                 Ret;
    int                 CharCounter;    // TokenBuf̕JEg
    BiDirList           *TokenList;
    TokenInfo           Token;
    char                *FileName;
    char                TokenBuf[MAX_LINE_LENGTH + 1];//g[Nꎞi[p
    char                Msg[1024];

    SrcInfo = (InputSrcFileInfo *)BiDirListObjectGet(InputSrcList, SrcFileNo);
    TokenList = SrcInfo->TokenList;
    FileName = SrcInfo->FileName;

    P3AlLexGetChar(&TokenBuf[0], &Line, SrcInfo, GET_CHAR_MODE_INIT);
    CharCounter = 0;
    while(1){
        if(CharCounter == 0){ // P
            for(i = 0 ;i < MAX_LINE_LENGTH + 1; i++) TokenBuf[i] = '\0';
            Ret = P3AlLexGetChar(&TokenBuf[CharCounter], &Line, SrcInfo, GET_CHAR_MODE_NOMAL);
            if(Ret == P3AL_NG){
                sprintf(Msg, "Ǎ()sB%s%ds", FileName, Line);
                PrintError0(__LINE__, Msg, "", "");
                return P3AL_NG;
            }
            if(Ret == P3AL_ESCAPE) break;
            // Xy[XA^uȂAǂݔ΂Ď
            if(TokenBuf[CharCounter] == ' ') continue;
            if(TokenBuf[CharCounter] == '\t') continue;
            //if(TokenBuf[CharCounter] == '\n') continue;
            //if(TokenBuf[CharCounter] == '\r') continue;
            // ꕶg[NȂAʂo^Ď
            Ret = P3AlLexJudgeOneCharToken(TokenBuf[CharCounter]);
            if(Ret != P3AL_NG){
                Token.Type = Ret;
                Token.FileName = FileName;
                Token.Line = Line;
                Token.ExtInfo = NULL;
                Ret = P3AlLexRegistTokenTable(TokenList, &Token);
                if(Ret == P3AL_NG){
                    sprintf(Msg, "g[N̓o^sB%s%ds", FileName, Line);
                    PrintError0(__LINE__, Msg, "", "");
                    return P3AL_NG;
                }
                continue;
            }
            // Xy[X́Aꕶg[NȊOȂACharCounterXVĎ
            ++CharCounter;
            continue;
        }
        else{ // Q
            Token.Line = Line;
            Token.ExtInfo = NULL;
            // 1ڂ'<''>'Ȃ
            if((TokenBuf[0] == '<') || (TokenBuf[0] == '>')){
                Ret = P3AlLexGetChar(&TokenBuf[CharCounter], &Line, SrcInfo, GET_CHAR_MODE_NOMAL);
                if(Ret != P3AL_OK){
                    PrintError0(__LINE__, "͎sB", "", "");
                    return P3AL_NG;
                }
                if(strcmp(TokenBuf, "<<") == 0)         Token.Type = TOKEN_SHIFT_L;
                else if(strcmp(TokenBuf, ">>") == 0)    Token.Type = TOKEN_SHIFT_R;
                else                                    Token.Type = P3AL_NG;
                if(Token.Type == P3AL_NG){
                    sprintf(Msg, "\"<<\"\"<<\"͎̉sB%s%ds", FileName, Line);
                    PrintError0(__LINE__, Msg, "", "");
                    return P3AL_NG;
                }
                Ret = P3AlLexRegistTokenTable(TokenList, &Token);
                if(Ret == P3AL_NG){
                    sprintf(Msg, "g[N̓o^sB%s%ds", FileName, Line);
                    PrintError0(__LINE__, Msg, "", "");
                    return P3AL_NG;
                }
            }
            // 1ڂAt@xbgorA_[XRAorsIhȂ
            else if((IsAlphaAndUnderLineDol(TokenBuf[0]) == P3AL_OK) || (TokenBuf[0] == '.')){
                Ret = P3AlLexGetIdentifier(TokenBuf, SrcInfo, &Token);
                if(Ret == P3AL_NG){
                    sprintf(Msg, "ʎq͎̉sB%s%ds", FileName, Line);
                    PrintError0(__LINE__, Msg, "", "");
                    return P3AL_NG;
                }
                Ret = P3AlLexRegistTokenTable(TokenList, &Token);
                if(Ret == P3AL_NG){
                    sprintf(Msg, "g[N̓o^sB%s%ds", FileName, Line);
                    PrintError0(__LINE__, Msg, "", "");
                    return P3AL_NG;
                }
            }
            // 1ڂA '  "Ȃ
            else if((IsNum(TokenBuf[0]) == P3AL_OK) || (TokenBuf[0] == '\'') || (TokenBuf[0] == '\"')){
                if(IsNum(TokenBuf[0]) == P3AL_OK) Ret = P3AlLexGetNumLiteral(TokenBuf, SrcInfo, &Token);
                else if(TokenBuf[0] == '\'')      Ret = P3AlLexGetNumLiteral2(TokenBuf, SrcInfo, &Token);
                else                              Ret = P3AlLexGetStringLiteral(TokenBuf, SrcInfo, &Token);
                if(Ret == P3AL_NG){
                    sprintf(Msg, "ʎq͎̉sB%s%ds", FileName, Line);
                    PrintError0(__LINE__, Msg, "", "");
                    return P3AL_NG;
                }
                Ret = P3AlLexRegistTokenTable(TokenList, &Token);
                if(Ret == P3AL_NG){
                    sprintf(Msg, "g[N̓o^sB%s%ds", FileName, Line);
                    PrintError0(__LINE__, Msg, "", "");
                    return P3AL_NG;
                }
            }
            // ǂɂĂ͂܂Ȃ
            else{
                sprintf(Msg, "͎sB%s%ds %s", FileName, Line, TokenBuf);
                PrintError0(__LINE__, Msg, "", "");
                return P3AL_NG;
            }
            CharCounter = 0;
        }
    }

    BiDirListIndexCreate(TokenList);

    return P3AL_OK;
}
//====================================================================================================================
static int P3AlLexGetStringLiteral(char *TokenBuf, InputSrcFileInfo *SrcInfo, TokenInfo *Token)
//====================================================================================================================
// [@\] 񃊃e擾
// [] char *TokenBuf            Fg[Ni[pobt@
// [] InputSrcFileInfo *SrcInfo F\[Xt@Cւ̃nh
// [] TokenInfo *Token          FʂԂׂ̍\TokenInfo
// [Ԓl] P3A_OK/P3AL_NG
{
    int                 Ret;
    int                 i;
    int                 Mode;                       // ̓[h
    char                TmpChar;
    int                 TmpLine;
    char                Msg[1024];
    char                *FileName;
    int                 Line;
    unsigned long       Num;

    FileName = SrcInfo->FileName;
    Line     = Token->Line;
    Mode = NUMSTRLITERAL_NOMAL;
    i = 1;
    while(1){
        if(i > MAX_STRING_LITERAL_CHAR - 1){
            sprintf(Msg, "̍ő啶%d𒴂Ă܂B%s%ds", MAX_STRING_LITERAL_CHAR - 1, FileName, Line);
            PrintError0(__LINE__, Msg, "", "");
            return P3AL_NG;
        }
        Ret = P3AlLexGetChar(&TokenBuf[i], &TmpLine, SrcInfo, GET_CHAR_MODE_NOMAL);
        if(Ret != P3AL_OK){
            PrintError0(__LINE__, "͎sB", "", "");
            return P3AL_NG;
        }
        if(Mode == NUMSTRLITERAL_NOMAL){
            if(TokenBuf[i] == '\"'){
                TokenBuf[i] = '\0';
                break;
            }
            if(TokenBuf[i] == '\\'){
                Mode = NUMSTRLITERAL_ESCAPE;
                continue;
            }
        }
        else{ // NUMSTRLITERAL_ESCAPE
            Ret = P3AlLexGetEscapeChar(TokenBuf[i]);
            if(Ret != P3AL_NG){
                TokenBuf[i] = (char)Ret;
                Mode = NUMSTRLITERAL_NOMAL;
            }
            else{
                sprintf(Msg, "[%s]͕s\(RgȊȌł͓{͎gȂ)B%s%ds", TokenBuf, FileName, Line);
                PrintError0(__LINE__, Msg, "", "");
                return P3AL_NG;
            }
        }
        ++i;
    }
    Token->ExtInfo = P3AlLexAddStrLiteralList(&TokenBuf[1], StrLiteralList);
    if(Token->ExtInfo == NULL){
        PrintError0(__LINE__, "񃊃eXgo^sB", "", "");
    }
    Token->Type = TOKEN_STRING_LITERAL;
    return P3AL_OK;
}
//====================================================================================================================
static char *P3AlLexAddStrLiteralList(char *Id, BiDirList *IdList)
//====================================================================================================================
// [@\] 񃊃eo^
// [] char *Id          Fʎqւ̃|C^
// [] BiDirList *IdList FʎqXgւ̃|C^
// [Ԓl] ʎqւ̃|C^isNULLԂj
{
    BiDirListMember *p;

    p = BiDirListMemberFind(IdList, IdList->Entry, Id);
    if(p == NULL){
        p = BiDirListMemberAdd(IdList, Id, strlen(Id) + 1);
    }
    return (char *)p->Object;
}

//====================================================================================================================
static int P3AlLexGetEscapeChar(char c)
//====================================================================================================================
// [@\] g\L擾
// [] g\L̂Q
// [Ԓl] g\LHexR[h
{
    if     (c == '0') return '\0';
    else if(c == 'a') return '\a';
    else if(c == 'b') return '\b';
    else if(c == 't') return '\t';
    else if(c == 'n') return '\n';
    else if(c == 'v') return '\v';
    else if(c == 'f') return '\f';
    else if(c == 'r') return '\r';
    else if(c == '\"')return '\"';
    else if(c == '\'')return '\'';
    else if(c == '\?')return '\?';
    else if(c == '\\')return '\\';
    else              return P3AL_NG;
}

//====================================================================================================================
static int P3AlLexGetNumLiteral2(char *TokenBuf, InputSrcFileInfo *SrcInfo, TokenInfo *Token)
//====================================================================================================================
// [@\] ̂悤Ȑle擾 ) 'a'
// [] char *TokenBuf            Fg[Ni[pobt@
// [] InputSrcFileInfo *SrcInfo F\[Xt@Cւ̃nh
// [] TokenInfo *Token          FʂԂׂ̍\TokenInfo
// [Ԓl] P3A_OK/P3AL_NG
{
    int                 Ret;
    int                 i;
    int                 Mode;                       // ̓[h
    char                TmpChar;
    int                 TmpLine;
    char                Msg[1024];
    char                *FileName;
    int                 Line;
    unsigned long       Num;

    FileName = SrcInfo->FileName;
    Line     = Token->Line;

    i = 1;
    while(1){
        if(i > 3){
            sprintf(Msg, "萔[%s] 1  2 łȂ΂ȂȂB%s%ds", TokenBuf, FileName, Line);
            PrintError0(__LINE__, Msg, "", "");
            return P3AL_NG;
        }

        Ret = P3AlLexGetChar(&TokenBuf[i], &TmpLine, SrcInfo, GET_CHAR_MODE_NOMAL);
        if(Ret != P3AL_OK){
            PrintError0(__LINE__, "͎sB", "", "");
            return P3AL_NG;
        }
        if(TokenBuf[i] == ' ') continue;
        if(TokenBuf[i] == '\t') continue;

        if(i==1){// '̒̕𔻒
            if(TokenBuf[i] == '\''){
                sprintf(Msg, "萔[%s] 1  2 łȂ΂ȂȂB%s%ds", TokenBuf, FileName, Line);
                PrintError0(__LINE__, Msg, "", "");
                return P3AL_NG;
            }
            else if(TokenBuf[i] == '\\'){
                Mode = NUMSTRLITERAL_ESCAPE;
            }
            else{
                Mode = NUMSTRLITERAL_NOMAL;
            }
        }
        if(i == 2){//Q
            if(Mode == NUMSTRLITERAL_NOMAL){
                if(TokenBuf[i] == '\'') break;
            }
        }
        if(i == 3){//R
            if(TokenBuf[i] == '\'') break;
        }
        ++i;
    }
    TokenBuf[i+1] = '\0';

    if(Mode == NUMSTRLITERAL_NOMAL){
        if(i==2){
            Num = 0xFF & (unsigned long)TokenBuf[1];
        }
        else{
            Num  = (0xFF & (unsigned long)TokenBuf[1]) << 8;
            Num |= 0xFF & (unsigned long)TokenBuf[2];
        }
    }
    else{
        Ret = P3AlLexGetEscapeChar(TokenBuf[2]);
        if(Ret != P3AL_NG){
            Num = (char)Ret;
        }
        else{
            sprintf(Msg, "[%s]͕s\ B%s%ds", TokenBuf, FileName, Line);
            PrintError0(__LINE__, Msg, "", "");
            return P3AL_NG;
        }
    }

    Token->ExtInfo = P3AlLexAddNumLiteralList(Num, NumLiteralList);
    if(Token->ExtInfo == NULL){
        PrintError0(__LINE__, "leXgo^sB", "", "");
    }
    Token->Type = TOKEN_NUMERIC_LITERAL;

    return P3AL_OK;
}

//====================================================================================================================
static int P3AlLexGetNumLiteral(char *TokenBuf, InputSrcFileInfo *SrcInfo, TokenInfo *Token)
//====================================================================================================================
//====================================================================================================================
// [@\] le擾
//        Ƃ肠A10i16î݂ɑΉB
// [] char *TokenBuf            Fg[Ni[pobt@
// [] InputSrcFileInfo *SrcInfo F\[Xt@Cւ̃nh
// [] TokenInfo *Token          FʂԂׂ̍\TokenInfo
// [Ԓl] P3A_OK/P3AL_NG
{
    int                 Ret;
    int                 i;
    int                 Mode;                       // ̓[h
    char                TmpChar;
    int                 TmpLine;
    char                Msg[1024];
    char                *FileName;
    int                 Line;
    unsigned long       Num;

    FileName = SrcInfo->FileName;
    Line     = Token->Line;

    if(TokenBuf[0] == '0') Mode = NUMLITERAL_HEX_READY;
    else                   Mode = NUMLITERAL_DEC_MODE;

    i = 1;
    while(1){
        if(i >= MAX_NUMERIC_LITERAL_CHAR){
            sprintf(Msg, "le̕%d𒴂Ă܂B%s%ds", MAX_NUMERIC_LITERAL_CHAR - 1, FileName, Line);
            PrintError0(__LINE__, Msg, "", "");
            return P3AL_NG;
        }

        Ret = P3AlLexGetChar(&TokenBuf[i], &TmpLine, SrcInfo, GET_CHAR_MODE_NOMAL);
        if(Ret != P3AL_OK){
            PrintError0(__LINE__, "͎sB", "", "");
            return P3AL_NG;
        }

        if(TokenBuf[i] == '.'){
            sprintf(Msg, "ɂ͖Ή B%s%ds", FileName, Line);
            PrintError0(__LINE__, Msg, "", "");
            return P3AL_NG;
        }
        else{
            if(Mode == NUMLITERAL_DEC_MODE){
                Ret = IsNum(TokenBuf[i]);
            }
            else if(Mode == NUMLITERAL_HEX_READY){
                if(TokenBuf[i] == 'x'){
                    Ret = P3AL_OK;
                    Mode = NUMLITERAL_HEX_MODE;
                }
                else if(IsNum(TokenBuf[i]) == P3AL_OK){
                    sprintf(Msg, "8iɂ͖Ή B%s%ds", FileName, Line);
                    PrintError0(__LINE__, Msg, "", "");
                    return P3AL_NG;
                }
                else{
                    Ret = P3AL_NG;
                    Mode = NUMLITERAL_DEC_MODE;
                }
            }
            else if(Mode == NUMLITERAL_HEX_MODE){
                Ret = IsHex(TokenBuf[i]);
            }
        }
        if(Ret == P3AL_NG){
            Ret = P3AlLexGetChar(&TmpChar, &TmpLine, SrcInfo, GET_CHAR_MODE_BACK); //߂
            if(Ret != P3AL_OK){
                PrintError0(__LINE__, "͎sB", "", "");
                return P3AL_NG;
            }
            TokenBuf[i] = '\0';
            break;
        }
        ++i;
    }

    if(Mode == NUMLITERAL_HEX_MODE){
        Num = strtoul(TokenBuf,NULL,16);
    }
    else if(Mode == NUMLITERAL_DEC_MODE){
        Num = strtol(TokenBuf,NULL,10);
    }
    else{
        PrintError0(__LINE__, "͎sB", "", "");
        return P3AL_NG;
    }

    Token->ExtInfo = P3AlLexAddNumLiteralList(Num, NumLiteralList);
    if(Token->ExtInfo == NULL){
        PrintError0(__LINE__, "leXgo^sB", "", "");
    }
    Token->Type = TOKEN_NUMERIC_LITERAL;
    return P3AL_OK;
}
//====================================================================================================================
static unsigned long *P3AlLexAddNumLiteralList(unsigned long Num, BiDirList *NumList)
//====================================================================================================================
// [@\] ʎqo^
// [] char *Id          Fʎqւ̃|C^
// [] BiDirList *IdList FʎqXgւ̃|C^
// [Ԓl] ʎqւ̃|C^isNULLԂj
{
    BiDirListMember *p;

    p = BiDirListMemberFind(NumList, NumList->Entry, &Num);
    if(p == NULL){
        p = BiDirListMemberAdd(NumList, &Num, sizeof(unsigned long));
    }
    return (unsigned long *)p->Object;
}

//====================================================================================================================
static int P3AlLexGetIdentifier(char *TokenBuf, InputSrcFileInfo *SrcInfo, TokenInfo *Token)
//====================================================================================================================
// [@\] ʎq擾
// [] char *TokenBuf            Fg[Ni[pobt@
// [] InputSrcFileInfo *SrcInfo F\[Xt@Cւ̃nh
// [] TokenInfo *Token          FʂԂׂ̍\TokenInfo
// [Ԓl] P3A_OK/P3AL_NG
{
    int                 Ret;
    int                 i;
    char                TmpChar;
    int                 TmpLine;
    char                Msg[1024];
    char                *FileName;
    int                 Line;

    FileName = SrcInfo->FileName;
    Line     = Token->Line;

    i = 1;
    while(1){
        if(i >= MAX_IDENTIFIER_CHAR - 1){
            sprintf(Msg, "ʎq̕%d𒴂Ă܂B%s%ds", MAX_IDENTIFIER_CHAR - 1, FileName, Line);
            PrintError0(__LINE__, Msg, "", "");
            return P3AL_NG;
        }
        Ret = P3AlLexGetChar(&TokenBuf[i], &TmpLine, SrcInfo, GET_CHAR_MODE_NOMAL);
        if(Ret != P3AL_OK){
            PrintError0(__LINE__, "͎sB", "", "");
            return P3AL_NG;
        }
        Ret = IsAlNumUnderLineAtDotDol(TokenBuf[i]);
        if(Ret == P3AL_NG){
            Ret = P3AlLexGetChar(&TmpChar, &TmpLine, SrcInfo, GET_CHAR_MODE_BACK); //߂
            if(Ret != P3AL_OK){
                PrintError0(__LINE__, "͎sB", "", "");
                return P3AL_NG;
            }
            TokenBuf[i] = '\0';
            break;
        }
        ++i;
    }
    Token->Type = P3AlLexGetIdentifierType(TokenBuf);
    Token->ExtInfo = P3AlLexAddIdentifierList(TokenBuf, IdentifierList);
    if(Token->ExtInfo == NULL){
        PrintError0(__LINE__, "ʎqXgo^sB", "", "");
    }

    return P3AL_OK;
}
//====================================================================================================================
static char *P3AlLexAddIdentifierList(char *Id, BiDirList *IdList)
//====================================================================================================================
// [@\] ʎqo^
// [] char *Id          Fʎqւ̃|C^
// [] BiDirList *IdList FʎqXgւ̃|C^
// [Ԓl] ʎqւ̃|C^isNULLԂj
{
    BiDirListMember *p;

    p = BiDirListMemberFind(IdList, IdList->Entry, Id);
    if(p == NULL){
        p = BiDirListMemberAdd(IdList, Id, strlen(Id) + 1);
    }
    return (char *)p->Object;
}
//====================================================================================================================
static int P3AlLexGetIdentifierType(char *p)
//====================================================================================================================
// [@\] ʎq̃g[NʂԂ
// [] z
// [Ԓl] g[N
{
    if(strcmp(p, "jpr"              ) == 0) return TOKEN_JP_R           ;
    if(strcmp(p, "jpi"              ) == 0) return TOKEN_JP_I           ;
    if(strcmp(p, "callr"            ) == 0) return TOKEN_CALL_R         ;
    if(strcmp(p, "calli"            ) == 0) return TOKEN_CALL_I         ;
    if(strcmp(p, "djpr"             ) == 0) return TOKEN_DJP_R          ;
    if(strcmp(p, "rtir"             ) == 0) return TOKEN_RTI_R          ;
    if(strcmp(p, "ldwr"             ) == 0) return TOKEN_LDW_R          ;
    if(strcmp(p, "ldwi"             ) == 0) return TOKEN_LDW_I          ;
    if(strcmp(p, "ldwubr"           ) == 0) return TOKEN_LDW_UB_R       ;
    if(strcmp(p, "ldwubi"           ) == 0) return TOKEN_LDW_UB_I       ;
    if(strcmp(p, "ldwuar"           ) == 0) return TOKEN_LDW_UA_R       ;
    if(strcmp(p, "ldwuai"           ) == 0) return TOKEN_LDW_UA_I       ;
    if(strcmp(p, "ldhr"             ) == 0) return TOKEN_LDH_R          ;
    if(strcmp(p, "ldhi"             ) == 0) return TOKEN_LDH_I          ;
    if(strcmp(p, "ldhubr"           ) == 0) return TOKEN_LDH_UB_R       ;
    if(strcmp(p, "ldhubi"           ) == 0) return TOKEN_LDH_UB_I       ;
    if(strcmp(p, "ldhuar"           ) == 0) return TOKEN_LDH_UA_R       ;
    if(strcmp(p, "ldhuai"           ) == 0) return TOKEN_LDH_UA_I       ;
    if(strcmp(p, "ldbr"             ) == 0) return TOKEN_LDB_R          ;
    if(strcmp(p, "ldbi"             ) == 0) return TOKEN_LDB_I          ;
    if(strcmp(p, "ldbubr"           ) == 0) return TOKEN_LDB_UB_R       ;
    if(strcmp(p, "ldbubi"           ) == 0) return TOKEN_LDB_UB_I       ;
    if(strcmp(p, "ldbuar"           ) == 0) return TOKEN_LDB_UA_R       ;
    if(strcmp(p, "ldbuai"           ) == 0) return TOKEN_LDB_UA_I       ;
    if(strcmp(p, "ldshr"            ) == 0) return TOKEN_LDSH_R         ;
    if(strcmp(p, "ldshi"            ) == 0) return TOKEN_LDSH_I         ;
    if(strcmp(p, "ldshubr"          ) == 0) return TOKEN_LDSH_UB_R      ;
    if(strcmp(p, "ldshubi"          ) == 0) return TOKEN_LDSH_UB_I      ;
    if(strcmp(p, "ldshuar"          ) == 0) return TOKEN_LDSH_UA_R      ;
    if(strcmp(p, "ldshuai"          ) == 0) return TOKEN_LDSH_UA_I      ;
    if(strcmp(p, "ldsbr"            ) == 0) return TOKEN_LDSB_R         ;
    if(strcmp(p, "ldsbi"            ) == 0) return TOKEN_LDSB_I         ;
    if(strcmp(p, "ldsbubr"          ) == 0) return TOKEN_LDSB_UB_R      ;
    if(strcmp(p, "ldsbubi"          ) == 0) return TOKEN_LDSB_UB_I      ;
    if(strcmp(p, "ldsbuar"          ) == 0) return TOKEN_LDSB_UA_R      ;
    if(strcmp(p, "ldsbuai"          ) == 0) return TOKEN_LDSB_UA_I      ;
    if(strcmp(p, "stwr"             ) == 0) return TOKEN_STW_R          ;
    if(strcmp(p, "stwi"             ) == 0) return TOKEN_STW_I          ;
    if(strcmp(p, "stwubr"           ) == 0) return TOKEN_STW_UB_R       ;
    if(strcmp(p, "stwubi"           ) == 0) return TOKEN_STW_UB_I       ;
    if(strcmp(p, "stwuar"           ) == 0) return TOKEN_STW_UA_R       ;
    if(strcmp(p, "stwuai"           ) == 0) return TOKEN_STW_UA_I       ;
    if(strcmp(p, "sthr"             ) == 0) return TOKEN_STH_R          ;
    if(strcmp(p, "sthi"             ) == 0) return TOKEN_STH_I          ;
    if(strcmp(p, "sthubr"           ) == 0) return TOKEN_STH_UB_R       ;
    if(strcmp(p, "sthubi"           ) == 0) return TOKEN_STH_UB_I       ;
    if(strcmp(p, "sthuar"           ) == 0) return TOKEN_STH_UA_R       ;
    if(strcmp(p, "sthuai"           ) == 0) return TOKEN_STH_UA_I       ;
    if(strcmp(p, "stbr"             ) == 0) return TOKEN_STB_R          ;
    if(strcmp(p, "stbi"             ) == 0) return TOKEN_STB_I          ;
    if(strcmp(p, "stbubr"           ) == 0) return TOKEN_STB_UB_R       ;
    if(strcmp(p, "stbubi"           ) == 0) return TOKEN_STB_UB_I       ;
    if(strcmp(p, "stbuar"           ) == 0) return TOKEN_STB_UA_R       ;
    if(strcmp(p, "stbuai"           ) == 0) return TOKEN_STB_UA_I       ;
    if(strcmp(p, "dcdrain"          ) == 0) return TOKEN_DCDRAIN        ;
    if(strcmp(p, "movi"             ) == 0) return TOKEN_MOV_I          ;
    if(strcmp(p, "movr"             ) == 0) return TOKEN_MOV_R          ;
    if(strcmp(p, "movli"            ) == 0) return TOKEN_MOVL_I         ;
    if(strcmp(p, "movhi"            ) == 0) return TOKEN_MOVH_I         ;
    if(strcmp(p, "addr"             ) == 0) return TOKEN_ADD_R          ;
    if(strcmp(p, "addi"             ) == 0) return TOKEN_ADD_I          ;
    if(strcmp(p, "subr"             ) == 0) return TOKEN_SUB_R          ;
    if(strcmp(p, "subi"             ) == 0) return TOKEN_SUB_I          ;
    if(strcmp(p, "andr"             ) == 0) return TOKEN_AND_R          ;
    if(strcmp(p, "andi"             ) == 0) return TOKEN_AND_I          ;
    if(strcmp(p, "orr"              ) == 0) return TOKEN_OR_R           ;
    if(strcmp(p, "ori"              ) == 0) return TOKEN_OR_I           ;
    if(strcmp(p, "xorr"             ) == 0) return TOKEN_XOR_R          ;
    if(strcmp(p, "xori"             ) == 0) return TOKEN_XOR_I          ;
    if(strcmp(p, "lsrr"             ) == 0) return TOKEN_LSR_R          ;
    if(strcmp(p, "lsri"             ) == 0) return TOKEN_LSR_I          ;
    if(strcmp(p, "lslr"             ) == 0) return TOKEN_LSL_R          ;
    if(strcmp(p, "lsli"             ) == 0) return TOKEN_LSL_I          ;
    if(strcmp(p, "asrr"             ) == 0) return TOKEN_ASR_R          ;
    if(strcmp(p, "asri"             ) == 0) return TOKEN_ASR_I          ;
    if(strcmp(p, "mulr"             ) == 0) return TOKEN_MUL_R          ;
    if(strcmp(p, "muli"             ) == 0) return TOKEN_MUL_I          ;
    if(strcmp(p, "divur"            ) == 0) return TOKEN_DIVU_R         ;
    if(strcmp(p, "divui"            ) == 0) return TOKEN_DIVU_I         ;
    if(strcmp(p, "divr"             ) == 0) return TOKEN_DIV_R          ;
    if(strcmp(p, "divi"             ) == 0) return TOKEN_DIV_I          ;
    if(strcmp(p, "modur"            ) == 0) return TOKEN_MODU_R         ;
    if(strcmp(p, "modui"            ) == 0) return TOKEN_MODU_I         ;
    if(strcmp(p, "modr"             ) == 0) return TOKEN_MOD_R          ;
    if(strcmp(p, "modi"             ) == 0) return TOKEN_MOD_I          ;
    if(strcmp(p, "di"               ) == 0) return TOKEN_DI             ;
    if(strcmp(p, "ei"               ) == 0) return TOKEN_EI             ;
    if(strcmp(p, "dic"              ) == 0) return TOKEN_DIC            ;
    if(strcmp(p, "eic"              ) == 0) return TOKEN_EIC            ;
    if(strcmp(p, "ddc"              ) == 0) return TOKEN_DDC            ;
    if(strcmp(p, "edc"              ) == 0) return TOKEN_EDC            ;
    if(strcmp(p, "bulk"             ) == 0) return TOKEN_BULK           ;
    if(strcmp(p, "blk"              ) == 0) return TOKEN_BLK            ;
    if(strcmp(p, "cprd"             ) == 0) return TOKEN_CPRD           ;
    if(strcmp(p, "cpwr"             ) == 0) return TOKEN_CPWR           ;
    if(strcmp(p, "break"            ) == 0) return TOKEN_BREAK          ;
    if(strcmp(p, "nop"              ) == 0) return TOKEN_NOP            ;
    if(strcmp(p, "immset"           ) == 0) return TOKEN_IMMSET         ;
    if(strcmp(p, "rts"              ) == 0) return TOKEN_RTS            ;
    if(strcmp(p, "push"             ) == 0) return TOKEN_PUSH           ;
    if(strcmp(p, "pop"              ) == 0) return TOKEN_POP            ;

    if(strcmp(p, "al" ) == 0) return TOKEN_COND_ALWAYS                  ;
    if(strcmp(p, "eq" ) == 0) return TOKEN_COND_ZERO                    ;
    if(strcmp(p, "ne" ) == 0) return TOKEN_COND_NOT_ZERO                ;
    if(strcmp(p, "hs" ) == 0) return TOKEN_COND_UNSIGNED_HIGHER_OR_SAME ;
    if(strcmp(p, "lo" ) == 0) return TOKEN_COND_UNSIGNED_LOWER          ;
    if(strcmp(p, "mi" ) == 0) return TOKEN_COND_MINUS                   ;
    if(strcmp(p, "pl" ) == 0) return TOKEN_COND_PLUS                    ;
    if(strcmp(p, "vs" ) == 0) return TOKEN_COND_OVERFLOW                ;
    if(strcmp(p, "vc" ) == 0) return TOKEN_COND_NOT_OVERFLOW            ;
    if(strcmp(p, "hi" ) == 0) return TOKEN_COND_UNSIGNED_HIGHER         ;
    if(strcmp(p, "ls" ) == 0) return TOKEN_COND_UNSIGNED_LOWER_OR_SAME  ;
    if(strcmp(p, "ge" ) == 0) return TOKEN_COND_SIGNED_GRATER_THAN_OR_EQ;
    if(strcmp(p, "lt" ) == 0) return TOKEN_COND_SIGNED_LESS_THAN        ;
    if(strcmp(p, "gt" ) == 0) return TOKEN_COND_SIGNED_GRATER_THAN      ;
    if(strcmp(p, "le" ) == 0) return TOKEN_COND_SIGNED_LESS_THAN_OR_EQ  ;

//    if(strcmp(p, ".P3CC_ASM_OUT"    ) == 0) return TOKEN_P3CC_ASM_OUT   ;
//    if(strcmp(p, ".SRCFILE"         ) == 0) return TOKEN_SRCFILE        ;
//    if(strcmp(p, ".ENDSRCFILE"      ) == 0) return TOKEN_ENDSRCFILE     ;
    if(strcmp(p, ".FUNCTION"        ) == 0) return TOKEN_FUNCTION       ;
    if(strcmp(p, ".ENDFUNCTION"     ) == 0) return TOKEN_ENDFUNCTION    ;
    if(strcmp(p, ".CODE"            ) == 0) return TOKEN_CODE           ;
    if(strcmp(p, ".EXTERNAL_FUNC"   ) == 0) return TOKEN_EXTERNAL_FUNC  ;
    if(strcmp(p, ".EXTERNAL_VAR"    ) == 0) return TOKEN_EXTERNAL_VAR   ;
    if(strcmp(p, ".GLOBAL_VAR"      ) == 0) return TOKEN_GLOBAL_VAR     ;
    if(strcmp(p, ".LOCAL_VAR"       ) == 0) return TOKEN_LOCAL_VAR      ;
    if(strcmp(p, ".ARG"             ) == 0) return TOKEN_ARG            ;
    if(strcmp(p, ".EQU"             ) == 0) return TOKEN_EQU            ;
    if(strcmp(p, ".GLOBAL_BASE_ADDRESS")== 0) return TOKEN_GLOBAL_BASE  ;
    if(strcmp(p, "PcOffsetOf"       ) == 0) return TOKEN_PcOffsetOf     ;
    if(strcmp(p, "FpOffsetOf"       ) == 0) return TOKEN_FpOffsetOf     ;
    if(strcmp(p, "GpOffsetOf"       ) == 0) return TOKEN_GpOffsetOf     ;
    if(strcmp(p, "GpOffsetHiOf"     ) == 0) return TOKEN_GpOffsetHiOf   ;
    if(strcmp(p, "GpOffsetLoOf"     ) == 0) return TOKEN_GpOffsetLoOf   ;
    if(strcmp(p, "AddressOf"        ) == 0) return TOKEN_AddressOf      ;
    if(strcmp(p, "AddressHiOf"      ) == 0) return TOKEN_AddressHiOf    ;
    if(strcmp(p, "AddressLoOf"      ) == 0) return TOKEN_AddressLoOf    ;
    if(strcmp(p, "EntryPointOf"     ) == 0) return TOKEN_EntryPointOf   ;
    if(strcmp(p, "EntryPointHiOf"   ) == 0) return TOKEN_EntryPointHiOf ;
    if(strcmp(p, "EntryPointLoOf"   ) == 0) return TOKEN_EntryPointLoOf ;
    if(strcmp(p, "$SizeOfGlobals$"  ) == 0) return TOKEN_SizeOfGlobals  ;
    if(strcmp(p, "$OffsetOfGlobals$") == 0) return TOKEN_OffsetOfGlobals;
    if(strcmp(p, "$SizeOfGlobals0$" ) == 0) return TOKEN_SizeOfGlobals0 ;
    if(strcmp(p, "$SizeOfGlobals1$" ) == 0) return TOKEN_SizeOfGlobals1 ;
    if(strcmp(p, "$InitialValue$"   ) == 0) return TOKEN_InitialValue   ;
    if(strcmp(p, "non"              ) == 0) return TOKEN_NON            ;
    if(strcmp(p, "r0"               ) == 0) return TOKEN_R0             ;
    if(strcmp(p, "r1"               ) == 0) return TOKEN_R1             ;
    if(strcmp(p, "r2"               ) == 0) return TOKEN_R2             ;
    if(strcmp(p, "r3"               ) == 0) return TOKEN_R3             ;
    if(strcmp(p, "r4"               ) == 0) return TOKEN_R4             ;
    if(strcmp(p, "r5"               ) == 0) return TOKEN_R5             ;
    if(strcmp(p, "r6"               ) == 0) return TOKEN_R6             ;
    if(strcmp(p, "r7"               ) == 0) return TOKEN_R7             ;
    if(strcmp(p, "r8"               ) == 0) return TOKEN_R8             ;
    if(strcmp(p, "r9"               ) == 0) return TOKEN_R9             ;
    if(strcmp(p, "r10"              ) == 0) return TOKEN_R10            ;
    if(strcmp(p, "r11"              ) == 0) return TOKEN_R11            ;
    if(strcmp(p, "r12"              ) == 0) return TOKEN_R12            ;
    if(strcmp(p, "r13"              ) == 0) return TOKEN_R13            ;
    if(strcmp(p, "r14"              ) == 0) return TOKEN_R14            ;
    if(strcmp(p, "r15"              ) == 0) return TOKEN_R15            ;
    if(strcmp(p, "sr"               ) == 0) return TOKEN_SR             ;
    if(strcmp(p, "isr"              ) == 0) return TOKEN_ISR            ;
    if(strcmp(p, "fp"               ) == 0) return TOKEN_FP             ;
    if(strcmp(p, "gp"               ) == 0) return TOKEN_GP             ;
    if(strcmp(p, "sp"               ) == 0) return TOKEN_SP             ;
    if(strcmp(p, "lr"               ) == 0) return TOKEN_LR             ;
    if(strcmp(p, "ilr"              ) == 0) return TOKEN_ILR            ;
    if(strcmp(p, "pc"               ) == 0) return TOKEN_PC             ;

    if(strcmp(p, "JPR"              ) == 0) return TOKEN_JP_R           ;
    if(strcmp(p, "JPI"              ) == 0) return TOKEN_JP_I           ;
    if(strcmp(p, "CALLR"            ) == 0) return TOKEN_CALL_R         ;
    if(strcmp(p, "CALLI"            ) == 0) return TOKEN_CALL_I         ;
    if(strcmp(p, "DJPR"             ) == 0) return TOKEN_DJP_R          ;
    if(strcmp(p, "RTIR"             ) == 0) return TOKEN_RTI_R          ;
    if(strcmp(p, "LDWR"             ) == 0) return TOKEN_LDW_R          ;
    if(strcmp(p, "LDWI"             ) == 0) return TOKEN_LDW_I          ;
    if(strcmp(p, "LDWUBR"           ) == 0) return TOKEN_LDW_UB_R       ;
    if(strcmp(p, "LDWUBI"           ) == 0) return TOKEN_LDW_UB_I       ;
    if(strcmp(p, "LDWUAR"           ) == 0) return TOKEN_LDW_UA_R       ;
    if(strcmp(p, "LDWUAI"           ) == 0) return TOKEN_LDW_UA_I       ;
    if(strcmp(p, "LDHR"             ) == 0) return TOKEN_LDH_R          ;
    if(strcmp(p, "LDHI"             ) == 0) return TOKEN_LDH_I          ;
    if(strcmp(p, "LDHUBR"           ) == 0) return TOKEN_LDH_UB_R       ;
    if(strcmp(p, "LDHUBI"           ) == 0) return TOKEN_LDH_UB_I       ;
    if(strcmp(p, "LDHUAR"           ) == 0) return TOKEN_LDH_UA_R       ;
    if(strcmp(p, "LDHUAI"           ) == 0) return TOKEN_LDH_UA_I       ;
    if(strcmp(p, "LDBR"             ) == 0) return TOKEN_LDB_R          ;
    if(strcmp(p, "LDBI"             ) == 0) return TOKEN_LDB_I          ;
    if(strcmp(p, "LDBUBR"           ) == 0) return TOKEN_LDB_UB_R       ;
    if(strcmp(p, "LDBUBI"           ) == 0) return TOKEN_LDB_UB_I       ;
    if(strcmp(p, "LDBUAR"           ) == 0) return TOKEN_LDB_UA_R       ;
    if(strcmp(p, "LDBUAI"           ) == 0) return TOKEN_LDB_UA_I       ;
    if(strcmp(p, "LDSHR"            ) == 0) return TOKEN_LDSH_R         ;
    if(strcmp(p, "LDSHI"            ) == 0) return TOKEN_LDSH_I         ;
    if(strcmp(p, "LDSHUBR"          ) == 0) return TOKEN_LDSH_UB_R      ;
    if(strcmp(p, "LDSHUBI"          ) == 0) return TOKEN_LDSH_UB_I      ;
    if(strcmp(p, "LDSHUAR"          ) == 0) return TOKEN_LDSH_UA_R      ;
    if(strcmp(p, "LDSHUAI"          ) == 0) return TOKEN_LDSH_UA_I      ;
    if(strcmp(p, "LDSBR"            ) == 0) return TOKEN_LDSB_R         ;
    if(strcmp(p, "LDSBI"            ) == 0) return TOKEN_LDSB_I         ;
    if(strcmp(p, "LDSBUBR"          ) == 0) return TOKEN_LDSB_UB_R      ;
    if(strcmp(p, "LDSBUBI"          ) == 0) return TOKEN_LDSB_UB_I      ;
    if(strcmp(p, "LDSBUAR"          ) == 0) return TOKEN_LDSB_UA_R      ;
    if(strcmp(p, "LDSBUAI"          ) == 0) return TOKEN_LDSB_UA_I      ;
    if(strcmp(p, "STWR"             ) == 0) return TOKEN_STW_R          ;
    if(strcmp(p, "STWI"             ) == 0) return TOKEN_STW_I          ;
    if(strcmp(p, "STWUBR"           ) == 0) return TOKEN_STW_UB_R       ;
    if(strcmp(p, "STWUBI"           ) == 0) return TOKEN_STW_UB_I       ;
    if(strcmp(p, "STWUAR"           ) == 0) return TOKEN_STW_UA_R       ;
    if(strcmp(p, "STWUAI"           ) == 0) return TOKEN_STW_UA_I       ;
    if(strcmp(p, "STHR"             ) == 0) return TOKEN_STH_R          ;
    if(strcmp(p, "STHI"             ) == 0) return TOKEN_STH_I          ;
    if(strcmp(p, "STHUBR"           ) == 0) return TOKEN_STH_UB_R       ;
    if(strcmp(p, "STHUBI"           ) == 0) return TOKEN_STH_UB_I       ;
    if(strcmp(p, "STHUAR"           ) == 0) return TOKEN_STH_UA_R       ;
    if(strcmp(p, "STHUAI"           ) == 0) return TOKEN_STH_UA_I       ;
    if(strcmp(p, "STBR"             ) == 0) return TOKEN_STB_R          ;
    if(strcmp(p, "STBI"             ) == 0) return TOKEN_STB_I          ;
    if(strcmp(p, "STBUBR"           ) == 0) return TOKEN_STB_UB_R       ;
    if(strcmp(p, "STBUBI"           ) == 0) return TOKEN_STB_UB_I       ;
    if(strcmp(p, "STBUAR"           ) == 0) return TOKEN_STB_UA_R       ;
    if(strcmp(p, "STBUAI"           ) == 0) return TOKEN_STB_UA_I       ;
    if(strcmp(p, "DCDRAIN"          ) == 0) return TOKEN_DCDRAIN        ;
    if(strcmp(p, "MOVI"             ) == 0) return TOKEN_MOV_I          ;
    if(strcmp(p, "MOVR"             ) == 0) return TOKEN_MOV_R          ;
    if(strcmp(p, "MOVLI"            ) == 0) return TOKEN_MOVL_I         ;
    if(strcmp(p, "MOVHI"            ) == 0) return TOKEN_MOVH_I         ;
    if(strcmp(p, "ADDR"             ) == 0) return TOKEN_ADD_R          ;
    if(strcmp(p, "ADDI"             ) == 0) return TOKEN_ADD_I          ;
    if(strcmp(p, "SUBR"             ) == 0) return TOKEN_SUB_R          ;
    if(strcmp(p, "SUBI"             ) == 0) return TOKEN_SUB_I          ;
    if(strcmp(p, "ANDR"             ) == 0) return TOKEN_AND_R          ;
    if(strcmp(p, "ANDI"             ) == 0) return TOKEN_AND_I          ;
    if(strcmp(p, "ORR"              ) == 0) return TOKEN_OR_R           ;
    if(strcmp(p, "ORI"              ) == 0) return TOKEN_OR_I           ;
    if(strcmp(p, "XORR"             ) == 0) return TOKEN_XOR_R          ;
    if(strcmp(p, "XORI"             ) == 0) return TOKEN_XOR_I          ;
    if(strcmp(p, "LSRR"             ) == 0) return TOKEN_LSR_R          ;
    if(strcmp(p, "LSRI"             ) == 0) return TOKEN_LSR_I          ;
    if(strcmp(p, "LSLR"             ) == 0) return TOKEN_LSL_R          ;
    if(strcmp(p, "LSLI"             ) == 0) return TOKEN_LSL_I          ;
    if(strcmp(p, "ASRR"             ) == 0) return TOKEN_ASR_R          ;
    if(strcmp(p, "ASRI"             ) == 0) return TOKEN_ASR_I          ;
    if(strcmp(p, "MULR"             ) == 0) return TOKEN_MUL_R          ;
    if(strcmp(p, "MULI"             ) == 0) return TOKEN_MUL_I          ;
    if(strcmp(p, "DIVUR"            ) == 0) return TOKEN_DIVU_R         ;
    if(strcmp(p, "DIVUI"            ) == 0) return TOKEN_DIVU_I         ;
    if(strcmp(p, "DIVR"             ) == 0) return TOKEN_DIV_R          ;
    if(strcmp(p, "DIVI"             ) == 0) return TOKEN_DIV_I          ;
    if(strcmp(p, "MODUR"            ) == 0) return TOKEN_MODU_R         ;
    if(strcmp(p, "MODUI"            ) == 0) return TOKEN_MODU_I         ;
    if(strcmp(p, "MODR"             ) == 0) return TOKEN_MOD_R          ;
    if(strcmp(p, "MODI"             ) == 0) return TOKEN_MOD_I          ;
    if(strcmp(p, "DI"               ) == 0) return TOKEN_DI             ;
    if(strcmp(p, "EI"               ) == 0) return TOKEN_EI             ;
    if(strcmp(p, "DIC"              ) == 0) return TOKEN_DIC            ;
    if(strcmp(p, "EIC"              ) == 0) return TOKEN_EIC            ;
    if(strcmp(p, "DDC"              ) == 0) return TOKEN_DDC            ;
    if(strcmp(p, "EDC"              ) == 0) return TOKEN_EDC            ;
    if(strcmp(p, "BULK"             ) == 0) return TOKEN_BULK           ;
    if(strcmp(p, "BLK"              ) == 0) return TOKEN_BLK            ;
    if(strcmp(p, "CPRD"             ) == 0) return TOKEN_CPRD           ;
    if(strcmp(p, "CPWR"             ) == 0) return TOKEN_CPWR           ;
    if(strcmp(p, "BREAK"            ) == 0) return TOKEN_BREAK          ;
    if(strcmp(p, "NOP"              ) == 0) return TOKEN_NOP            ;

    if(strcmp(p, "AL" ) == 0) return TOKEN_COND_ALWAYS                  ;
    if(strcmp(p, "EQ" ) == 0) return TOKEN_COND_ZERO                    ;
    if(strcmp(p, "NE" ) == 0) return TOKEN_COND_NOT_ZERO                ;
    if(strcmp(p, "HS" ) == 0) return TOKEN_COND_UNSIGNED_HIGHER_OR_SAME ;
    if(strcmp(p, "LO" ) == 0) return TOKEN_COND_UNSIGNED_LOWER          ;
    if(strcmp(p, "MI" ) == 0) return TOKEN_COND_MINUS                   ;
    if(strcmp(p, "PL" ) == 0) return TOKEN_COND_PLUS                    ;
    if(strcmp(p, "VS" ) == 0) return TOKEN_COND_OVERFLOW                ;
    if(strcmp(p, "VC" ) == 0) return TOKEN_COND_NOT_OVERFLOW            ;
    if(strcmp(p, "HI" ) == 0) return TOKEN_COND_UNSIGNED_HIGHER         ;
    if(strcmp(p, "LS" ) == 0) return TOKEN_COND_UNSIGNED_LOWER_OR_SAME  ;
    if(strcmp(p, "GE" ) == 0) return TOKEN_COND_SIGNED_GRATER_THAN_OR_EQ;
    if(strcmp(p, "LT" ) == 0) return TOKEN_COND_SIGNED_LESS_THAN        ;
    if(strcmp(p, "GT" ) == 0) return TOKEN_COND_SIGNED_GRATER_THAN      ;
    if(strcmp(p, "LE" ) == 0) return TOKEN_COND_SIGNED_LESS_THAN_OR_EQ  ;

    if(strcmp(p, "IMMSET"           ) == 0) return TOKEN_IMMSET         ;
    if(strcmp(p, "RTS"              ) == 0) return TOKEN_RTS            ;
    if(strcmp(p, "PUSH"             ) == 0) return TOKEN_PUSH           ;
    if(strcmp(p, "POP"              ) == 0) return TOKEN_POP            ;
    if(strcmp(p, "NON"              ) == 0) return TOKEN_NON            ;
    if(strcmp(p, "R0"               ) == 0) return TOKEN_R0             ;
    if(strcmp(p, "R1"               ) == 0) return TOKEN_R1             ;
    if(strcmp(p, "R2"               ) == 0) return TOKEN_R2             ;
    if(strcmp(p, "R3"               ) == 0) return TOKEN_R3             ;
    if(strcmp(p, "R4"               ) == 0) return TOKEN_R4             ;
    if(strcmp(p, "R5"               ) == 0) return TOKEN_R5             ;
    if(strcmp(p, "R6"               ) == 0) return TOKEN_R6             ;
    if(strcmp(p, "R7"               ) == 0) return TOKEN_R7             ;
    if(strcmp(p, "R8"               ) == 0) return TOKEN_R8             ;
    if(strcmp(p, "R9"               ) == 0) return TOKEN_R9             ;
    if(strcmp(p, "R10"              ) == 0) return TOKEN_R10            ;
    if(strcmp(p, "R11"              ) == 0) return TOKEN_R11            ;
    if(strcmp(p, "R12"              ) == 0) return TOKEN_R12            ;
    if(strcmp(p, "R13"              ) == 0) return TOKEN_R13            ;
    if(strcmp(p, "R14"              ) == 0) return TOKEN_R14            ;
    if(strcmp(p, "R15"              ) == 0) return TOKEN_R15            ;
    if(strcmp(p, "SR"               ) == 0) return TOKEN_SR             ;
    if(strcmp(p, "ISR"              ) == 0) return TOKEN_ISR            ;
    if(strcmp(p, "FP"               ) == 0) return TOKEN_FP             ;
    if(strcmp(p, "GP"               ) == 0) return TOKEN_GP             ;
    if(strcmp(p, "SP"               ) == 0) return TOKEN_SP             ;
    if(strcmp(p, "LR"               ) == 0) return TOKEN_LR             ;
    if(strcmp(p, "ILR"              ) == 0) return TOKEN_ILR            ;
    if(strcmp(p, "PC"               ) == 0) return TOKEN_PC             ;

    return TOKEN_IDENTIFIER;
}
//====================================================================================================================
static int P3AlLexRegistTokenTable(BiDirList *TokenList, TokenInfo *Token)
//====================================================================================================================
// [@\] g[No^
// [] BiDirList *TokenListFo^
// [] TokenInfo *Token    Fo^g[N
// [Ԓl] FP3AL_OK, sFP3AL_NG
{
    void    *Ret;

    Ret = BiDirListMemberAdd(TokenList, Token, sizeof(TokenInfo));
    if(Ret == NULL){
        PrintError0(__LINE__, "Ǎ݂Ɏs", "", "");
        return P3AL_NG;
    }
    return P3AL_OK;
}
//====================================================================================================================
static int P3AlLexJudgeOneCharToken(char c)
//====================================================================================================================
// [@\] ꕶg[Nۂ`FbN
// [] ꕶ
// [Ԓl] ꕶg[Nł΁Ãg[Nʂ
//        ȊȌꍇ́AP3AL_ESCAPE_NGԂB
{
    if(c == '[')  return TOKEN_SQUARE_L ;
    if(c == ']')  return TOKEN_SQUARE_R ;
    if(c == '{')  return TOKEN_BRACE_L  ;
    if(c == '}')  return TOKEN_BRACE_R  ;
    if(c == '(')  return TOKEN_BRACKET_L;
    if(c == ')')  return TOKEN_BRACKET_R;
    if(c == ':')  return TOKEN_COLON    ;
    if(c == ';')  return TOKEN_SEMICOLON;
    if(c == ',')  return TOKEN_COMMA    ;
    //if(c == '.')  return TOKEN_PERIOD   ;
    if(c == '~')  return TOKEN_NOT      ;
    if(c == '+')  return TOKEN_PLUS     ;
    if(c == '-')  return TOKEN_MINUS    ;
    if(c == '*')  return TOKEN_ASTERISK ;
    if(c == '/')  return TOKEN_DIV      ;
    if(c == '%')  return TOKEN_MOD      ;
    if(c == '&')  return TOKEN_AMPERSAND;
    if(c == '|')  return TOKEN_OR       ;
    if(c == '^')  return TOKEN_XOR      ;
    if(c == '=')  return TOKEN_EQ       ;
    if(c == '\n') return TOKEN_LF       ;
    if(c == '\r') return TOKEN_LF       ;
    return P3AL_NG;
}

//====================================================================================================================
static int P3AlLexGetCharHandleUpdate(struct SrcListAccessHandle_t *Handle, int Mode)
//====================================================================================================================
// [@\] SrcListAccessHandle_tXV
// [] struct SrcListAccessHandle_t *HandleFΏ
// [] int Mode                  F
//            GET_CHAR_MODE_NOMAL:HandlePi߂
//            GET_CHAR_MODE_BACK :HandleP߂
// [Ԓl] FP3AL_OK, t@C̏I[ɒB:P3AL_ESCAPE, sFP3AL_NG
{
    char            *Str;
    int             Len;

    if(Mode == GET_CHAR_MODE_NOMAL){
        Str = (char *)BiDirListObjectGet(Handle->SrcList, Handle->LineNo);
        Len = strlen(Str);
        if(Handle->CharNo >= Len - 1){
            Handle->LineNo += 1;
            Handle->CharNo = 0;
        }
        else{
            Handle->CharNo += 1;
        }
    }
    else{
        if(Handle->CharNo == 0){
            if(Handle->LineNo <= 0) return P3AL_NG;
            Handle->LineNo -= 1;
            Str = (char *)BiDirListObjectGet(Handle->SrcList, Handle->LineNo);
            Len = strlen(Str);
            Handle->CharNo = Len - 1;
        }
        else{
            Handle->CharNo -= 1;
        }
    }
//printf("LINE = %d, CHAR = %d\n", Handle->LineNo, Handle->CharNo);
    return P3AL_OK;
}
//====================================================================================================================
static int P3AlLexGetChar(char *p, int *Line, InputSrcFileInfo *SrcInfo, int Mode)
//====================================================================================================================
// [@\] \[XꕶǍ
// [] char *p                   Fǂ݂Pi[
// [] int  *Line                Fǂ݂Psڂi[
// [] InputSrcFileInfo *SrcInfo FANZXΏۂInputSrcFileInfo_tA ModeGET_CHAR_MODE_INITȊOȂNULLł悢
// [] int Mode                  F
//            GET_CHAR_MODE_INIT :Handle\[X擪ɏ
//            GET_CHAR_MODE_NOMAL:ꕶǍ݁AHandlePi߂
//            GET_CHAR_MODE_BACK :HandleP߂āAꕶǍ
// [Ԓl] FP3AL_OK, t@C̏I[ɒB:P3AL_ESCAPE, sFP3AL_NG
{
    char            *Str;
    int             Len;
    static struct   SrcListAccessHandle_t Handle = {NULL, 0, 0, 0};

//char msg[2];
//msg[1] = '\0';

    if(Mode == GET_CHAR_MODE_INIT){
        if(SrcInfo->SrcList == NULL) return P3AL_NG;
        Handle.SrcList = SrcInfo->SrcList;
        Handle.LineNo = 0;
        Handle.CharNo = 0;
        Handle.TotalLine = BiDirListNumOfMemberGet(Handle.SrcList);
        if(Handle.TotalLine <= 0){
            PrintError0(__LINE__, "̃t@CǂݍƂĂ܂B", "", "");
            return P3AL_NG;
        }
    }
    else{
        if(Handle.SrcList == NULL) return P3AL_NG;
        if(Mode == GET_CHAR_MODE_NOMAL){
            while(1){
//printf("%08x,%d,%d,%d\n", Handle.SrcList, Handle.LineNo, Handle.CharNo, Handle.TotalLine);
                if(Handle.LineNo >= Handle.TotalLine){//ŏIs𒴂Ă邩H
                    return P3AL_ESCAPE;
                }
                else{
                    Str = (char *)BiDirListObjectGet(Handle.SrcList, Handle.LineNo);
                    Len = strlen(Str);
                    if(Len == 0){
                        P3AlLexGetCharHandleUpdate(&Handle, GET_CHAR_MODE_NOMAL);
                        continue;
                    }
                    *p = Str[Handle.CharNo];
                    *Line = Handle.LineNo;
                    P3AlLexGetCharHandleUpdate(&Handle, GET_CHAR_MODE_NOMAL);
                    break;
                }
            }
        }
        else{
            while(1){
                if(P3AlLexGetCharHandleUpdate(&Handle, GET_CHAR_MODE_BACK) == P3AL_NG) return P3AL_NG;
                Str = (char *)BiDirListObjectGet(Handle.SrcList, Handle.LineNo);
                Len = strlen(Str);
                if(Len == 0){
                    continue;
                }
                *p = Str[Handle.CharNo];
                *Line = Handle.LineNo;
                break;
            }
        }
    }

//msg[0] = *p;
//printf("%s 0x%02x %d\n",msg, *p, Mode);

    return P3AL_OK;
}

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
//  \/Ӗ  R[h֘A
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
//====================================================================================================================
static int P3AlPsr(void)
//====================================================================================================================
// [@\] \/Ӗ  R[h
// []
// [Ԓl] FP3AL_OK, sFP3AL_NG
{
    if(P3AlPsr0() == P3AL_NG) return P3AL_NG;
    if(P3AlPsr1() == P3AL_NG) return P3AL_NG;
    if(P3AlPsr2() == P3AL_NG) return P3AL_NG;
    return P3AL_OK;
}

//====================================================================================================================
static int P3AlPsr0(void)
//====================================================================================================================
// [@\] ϐ\ER[h\̍쐬
// []
// [Ԓl] FP3AL_OK, sFP3AL_NG
{
    int                     i;
    TokenAccessHandler    TokenHandle;

#ifdef P3AL_MSGENABLE
        printf(" ϐ\ER[h\쐬");
#endif
    if(InputSrcList == NULL) return P3AL_NG;
    for(i = 0; i < InputSrcList->NumOfMember; i++){
#ifdef P3AL_MSGENABLE
        printf(".");
#endif
        TokenHandle.SrcInfo = (InputSrcFileInfo *)BiDirListObjectGet(InputSrcList, i);
        TokenHandle.TokenIndex = 0;
        TokenHandle.NumOfToken = BiDirListNumOfMemberGet(TokenHandle.SrcInfo->TokenList);
        if(P3AlPsr0Body(&TokenHandle) == P3AL_NG) return P3AL_NG;

    }
#ifdef P3AL_MSGENABLE
        printf("\n");
#endif
    return P3AL_OK;
}
//====================================================================================================================
static int P3AlPsr1(void)
//====================================================================================================================
// [@\] V{QƂ̉
// []
// [Ԓl] FP3AL_OK, sFP3AL_NG
{
#ifdef P3AL_MSGENABLE
        printf(" V{QƂ̉");
#endif

    //R[hzu
    TotalSizeOfCode = P3AlPsr1CodeAlloc();
#ifdef P3AL_MSGENABLE
        printf(".");
#endif

    //O[oϐzu
    TotalSizeOfGlobal0 = P3AlPsr1VariableAlloc(VARIABLE_GLOBAL, Global0);
    TotalSizeOfGlobal1 = P3AlPsr1VariableAlloc(VARIABLE_GLOBAL, Global1);
    P3AlPsr1Global1Trim();
    TotalSizeOfGlobal = TotalSizeOfGlobal0 + TotalSizeOfGlobal1;
#ifdef P3AL_MSGENABLE
        printf(".");
#endif
    //[Jϐ&zu
    P3AlPsr1LocalAndArgAlloc();
#ifdef P3AL_MSGENABLE
        printf(".");
#endif
    // READ ONLYf[^쐬
    AddressOfReadOnlyData = TotalSizeOfCode;
    TotalSizeOfReadOnlyData = P3AlPsr1MakeReadOnlyData();
#ifdef P3AL_MSGENABLE
        printf(".");
#endif
    // ̑Af[^̃V{QƂ̉Ȃ
    P3AlPsr1InitDataTrim();
#ifdef P3AL_MSGENABLE
        printf(".");
#endif
    //f[^zu
    AddressOfInitData = AddressOfReadOnlyData + TotalSizeOfReadOnlyData;
    P3AlPsr1InitializerAlloc();
#ifdef P3AL_MSGENABLE
        printf(".");
#endif

    //e֐̃[Jȃx̏d`FbN
    if(P3AlPsr1LocalLabelCheck() == P3AL_NG) return P3AL_NG;
#ifdef P3AL_MSGENABLE
        printf(".\n");
#endif

    return P3AL_OK;
}

//====================================================================================================================
static int P3AlPsr2(void)
//====================================================================================================================
// [@\] HEXR[h(S\[X)
// []
// [Ԓl] FP3AL_OK, sFP3AL_NG
{
    int                 NumOfFiles;
    int                 i,j;
    InputSrcFileInfo    *SrcInfo;
    Function            *f;
    int                 NumOfFunc;

#ifdef P3AL_MSGENABLE
        printf(" HEXR[h");
#endif
    NumOfFiles = BiDirListNumOfMemberGet(InputSrcList);
    for(i = 0; i < NumOfFiles; i++){
#ifdef P3AL_MSGENABLE
        printf(".");
#endif
        SrcInfo = (InputSrcFileInfo *)BiDirListObjectGet(InputSrcList, i);
        NumOfFunc = BiDirListNumOfMemberGet(SrcInfo->FunctionList);
        for(j = 0; j < NumOfFunc; j++){
            f = (Function *)BiDirListObjectGet(SrcInfo->FunctionList, j);
            if(P3AlPsr2CodeGen(f, SrcInfo->TokenList) == P3AL_NG) return P3AL_NG;
        }
    }
#ifdef P3AL_MSGENABLE
        printf("\n");
#endif

    return P3AL_OK;
}
//====================================================================================================================
static int P3AlPsr2CodeGen(Function *f, BiDirList *TokenList)
//====================================================================================================================
// [@\] HEXR[hi֐Pʁj
// []
// [Ԓl] FP3AL_OK, sFP3AL_NG
{
    int                 i;
    int                 NumOfCode;

    NumOfCode = BiDirListNumOfMemberGet(f->CodeList);
    for(i = 0; i < NumOfCode; i++){
        if(P3AlPsr2HexCodeGen(f, TokenList, i) == P3AL_NG) return P3AL_NG;
    }
    return P3AL_OK;
}
//====================================================================================================================
static void  P3AlPsr2PrintError(TokenInfo *Token, int Line)
//====================================================================================================================
// [@\] HEXR[hiߒPʁj
// []
// [Ԓl] FP3AL_OK, sFP3AL_NG
{
    char                Msg[1024];
    sprintf(Msg, "%s%ds", Token->FileName, Token->Line + 1);
    PrintError0(Line, Msg, "", "");
    PrintTokenBody(Msg, Token);
    PrintError0(Line, "\"", Msg, "\"ρH");
}
//====================================================================================================================
static void  P3AlPsr2PrintError2(char *FileName, int FileLine, int Line)
//====================================================================================================================
// [@\] HEXR[hiߒPʁj
// []
// [Ԓl] FP3AL_OK, sFP3AL_NG
{
    char                Msg[1024];
    sprintf(Msg, "%s%ds", FileName, FileLine);
    PrintError0(Line, Msg, "", "");
}

//====================================================================================================================
static int  P3AlPsr2HexCodeGen(Function *f, BiDirList *TokenList, int  CodeIndex)
//====================================================================================================================
// [@\] HEXR[hiߒPʁj
// []
// [Ԓl] FP3AL_OK, sFP3AL_NG
{
    CodeInfo            *Code;
    int                 TokenIndex;
    int                 NumOfToken;
    TokenInfo           *Token;
    char                Msg[1024];

    Code = (CodeInfo *)BiDirListObjectGet(f->CodeList, CodeIndex);
    TokenIndex = Code->StartTokenIndex;
    NumOfToken = Code->NumOfToken;
#ifdef TOKEN_READ_DEBUG
    Token = P3AlPsr2NewTokenGet(TokenList, &TokenIndex, &NumOfToken, __LINE__);
#else
    Token = P3AlPsr2NewTokenGet(TokenList, &TokenIndex, &NumOfToken);
#endif

    if(Token == NULL){ P3AlPsr2PrintError2(f->FileName, Code->Line + 1, __LINE__); return P3AL_NG;}

    if(Token->Type == TOKEN_JP_R        ) return P3AlPsr2BranchCodeGen((HEXCODE_JP                   ), f, TokenList, &TokenIndex, &NumOfToken, Code);
    if(Token->Type == TOKEN_JP_I        ) return P3AlPsr2BranchCodeGen((HEXCODE_JP   | OPERAND_IS_IMM), f, TokenList, &TokenIndex, &NumOfToken, Code);
    if(Token->Type == TOKEN_CALL_R      ) return P3AlPsr2BranchCodeGen((HEXCODE_CALL                 ), f, TokenList, &TokenIndex, &NumOfToken, Code);
    if(Token->Type == TOKEN_CALL_I      ) return P3AlPsr2BranchCodeGen((HEXCODE_CALL | OPERAND_IS_IMM), f, TokenList, &TokenIndex, &NumOfToken, Code);
    if(Token->Type == TOKEN_DJP_R       ) return P3AlPsr2BranchCodeGen((HEXCODE_DJP                  ), f, TokenList, &TokenIndex, &NumOfToken, Code);
    if(Token->Type == TOKEN_RTI_R       ) return P3AlPsr2BranchCodeGen((HEXCODE_RTI                  ), f, TokenList, &TokenIndex, &NumOfToken, Code);
    if(Token->Type == TOKEN_RTS         ) return P3AlPsr2BranchCodeGen((HEXCODE_RTS                  ), f, TokenList, &TokenIndex, &NumOfToken, Code);

    if(Token->Type == TOKEN_LDW_R       ) return P3AlPsr2LdStCodeGen((HEXCODE_LDW                    ), f, TokenList, &TokenIndex, &NumOfToken, Code);
    if(Token->Type == TOKEN_LDW_I       ) return P3AlPsr2LdStCodeGen((HEXCODE_LDW    | OPERAND_IS_IMM), f, TokenList, &TokenIndex, &NumOfToken, Code);
    if(Token->Type == TOKEN_LDW_UB_R    ) return P3AlPsr2LdStCodeGen((HEXCODE_LDWUB                  ), f, TokenList, &TokenIndex, &NumOfToken, Code);
    if(Token->Type == TOKEN_LDW_UB_I    ) return P3AlPsr2LdStCodeGen((HEXCODE_LDWUB  | OPERAND_IS_IMM), f, TokenList, &TokenIndex, &NumOfToken, Code);
    if(Token->Type == TOKEN_LDW_UA_R    ) return P3AlPsr2LdStCodeGen((HEXCODE_LDWUA                  ), f, TokenList, &TokenIndex, &NumOfToken, Code);
    if(Token->Type == TOKEN_LDW_UA_I    ) return P3AlPsr2LdStCodeGen((HEXCODE_LDWUA  | OPERAND_IS_IMM), f, TokenList, &TokenIndex, &NumOfToken, Code);
    if(Token->Type == TOKEN_LDH_R       ) return P3AlPsr2LdStCodeGen((HEXCODE_LDH                    ), f, TokenList, &TokenIndex, &NumOfToken, Code);
    if(Token->Type == TOKEN_LDH_I       ) return P3AlPsr2LdStCodeGen((HEXCODE_LDH    | OPERAND_IS_IMM), f, TokenList, &TokenIndex, &NumOfToken, Code);
    if(Token->Type == TOKEN_LDH_UB_R    ) return P3AlPsr2LdStCodeGen((HEXCODE_LDHUB                  ), f, TokenList, &TokenIndex, &NumOfToken, Code);
    if(Token->Type == TOKEN_LDH_UB_I    ) return P3AlPsr2LdStCodeGen((HEXCODE_LDHUB  | OPERAND_IS_IMM), f, TokenList, &TokenIndex, &NumOfToken, Code);
    if(Token->Type == TOKEN_LDH_UA_R    ) return P3AlPsr2LdStCodeGen((HEXCODE_LDHUA                  ), f, TokenList, &TokenIndex, &NumOfToken, Code);
    if(Token->Type == TOKEN_LDH_UA_I    ) return P3AlPsr2LdStCodeGen((HEXCODE_LDHUA  | OPERAND_IS_IMM), f, TokenList, &TokenIndex, &NumOfToken, Code);
    if(Token->Type == TOKEN_LDB_R       ) return P3AlPsr2LdStCodeGen((HEXCODE_LDB                    ), f, TokenList, &TokenIndex, &NumOfToken, Code);
    if(Token->Type == TOKEN_LDB_I       ) return P3AlPsr2LdStCodeGen((HEXCODE_LDB    | OPERAND_IS_IMM), f, TokenList, &TokenIndex, &NumOfToken, Code);
    if(Token->Type == TOKEN_LDB_UB_R    ) return P3AlPsr2LdStCodeGen((HEXCODE_LDBUB                  ), f, TokenList, &TokenIndex, &NumOfToken, Code);
    if(Token->Type == TOKEN_LDB_UB_I    ) return P3AlPsr2LdStCodeGen((HEXCODE_LDBUB  | OPERAND_IS_IMM), f, TokenList, &TokenIndex, &NumOfToken, Code);
    if(Token->Type == TOKEN_LDB_UA_R    ) return P3AlPsr2LdStCodeGen((HEXCODE_LDBUA                  ), f, TokenList, &TokenIndex, &NumOfToken, Code);
    if(Token->Type == TOKEN_LDB_UA_I    ) return P3AlPsr2LdStCodeGen((HEXCODE_LDBUA  | OPERAND_IS_IMM), f, TokenList, &TokenIndex, &NumOfToken, Code);
    if(Token->Type == TOKEN_LDSH_R      ) return P3AlPsr2LdStCodeGen((HEXCODE_LDSH                   ), f, TokenList, &TokenIndex, &NumOfToken, Code);
    if(Token->Type == TOKEN_LDSH_I      ) return P3AlPsr2LdStCodeGen((HEXCODE_LDSH   | OPERAND_IS_IMM), f, TokenList, &TokenIndex, &NumOfToken, Code);
    if(Token->Type == TOKEN_LDSH_UB_R   ) return P3AlPsr2LdStCodeGen((HEXCODE_LDSHUB                 ), f, TokenList, &TokenIndex, &NumOfToken, Code);
    if(Token->Type == TOKEN_LDSH_UB_I   ) return P3AlPsr2LdStCodeGen((HEXCODE_LDSHUB | OPERAND_IS_IMM), f, TokenList, &TokenIndex, &NumOfToken, Code);
    if(Token->Type == TOKEN_LDSH_UA_R   ) return P3AlPsr2LdStCodeGen((HEXCODE_LDSHUA                 ), f, TokenList, &TokenIndex, &NumOfToken, Code);
    if(Token->Type == TOKEN_LDSH_UA_I   ) return P3AlPsr2LdStCodeGen((HEXCODE_LDSHUA | OPERAND_IS_IMM), f, TokenList, &TokenIndex, &NumOfToken, Code);
    if(Token->Type == TOKEN_LDSB_R      ) return P3AlPsr2LdStCodeGen((HEXCODE_LDSB                   ), f, TokenList, &TokenIndex, &NumOfToken, Code);
    if(Token->Type == TOKEN_LDSB_I      ) return P3AlPsr2LdStCodeGen((HEXCODE_LDSB   | OPERAND_IS_IMM), f, TokenList, &TokenIndex, &NumOfToken, Code);
    if(Token->Type == TOKEN_LDSB_UB_R   ) return P3AlPsr2LdStCodeGen((HEXCODE_LDSBUB                 ), f, TokenList, &TokenIndex, &NumOfToken, Code);
    if(Token->Type == TOKEN_LDSB_UB_I   ) return P3AlPsr2LdStCodeGen((HEXCODE_LDSBUB | OPERAND_IS_IMM), f, TokenList, &TokenIndex, &NumOfToken, Code);
    if(Token->Type == TOKEN_LDSB_UA_R   ) return P3AlPsr2LdStCodeGen((HEXCODE_LDSBUA                 ), f, TokenList, &TokenIndex, &NumOfToken, Code);
    if(Token->Type == TOKEN_LDSB_UA_I   ) return P3AlPsr2LdStCodeGen((HEXCODE_LDSBUA | OPERAND_IS_IMM), f, TokenList, &TokenIndex, &NumOfToken, Code);
    if(Token->Type == TOKEN_STW_R       ) return P3AlPsr2LdStCodeGen((HEXCODE_STW                    ), f, TokenList, &TokenIndex, &NumOfToken, Code);
    if(Token->Type == TOKEN_STW_I       ) return P3AlPsr2LdStCodeGen((HEXCODE_STW    | OPERAND_IS_IMM), f, TokenList, &TokenIndex, &NumOfToken, Code);
    if(Token->Type == TOKEN_STW_UB_R    ) return P3AlPsr2LdStCodeGen((HEXCODE_STWUB                  ), f, TokenList, &TokenIndex, &NumOfToken, Code);
    if(Token->Type == TOKEN_STW_UB_I    ) return P3AlPsr2LdStCodeGen((HEXCODE_STWUB  | OPERAND_IS_IMM), f, TokenList, &TokenIndex, &NumOfToken, Code);
    if(Token->Type == TOKEN_STW_UA_R    ) return P3AlPsr2LdStCodeGen((HEXCODE_STWUA                  ), f, TokenList, &TokenIndex, &NumOfToken, Code);
    if(Token->Type == TOKEN_STW_UA_I    ) return P3AlPsr2LdStCodeGen((HEXCODE_STWUA  | OPERAND_IS_IMM), f, TokenList, &TokenIndex, &NumOfToken, Code);
    if(Token->Type == TOKEN_STH_R       ) return P3AlPsr2LdStCodeGen((HEXCODE_STH                    ), f, TokenList, &TokenIndex, &NumOfToken, Code);
    if(Token->Type == TOKEN_STH_I       ) return P3AlPsr2LdStCodeGen((HEXCODE_STH    | OPERAND_IS_IMM), f, TokenList, &TokenIndex, &NumOfToken, Code);
    if(Token->Type == TOKEN_STH_UB_R    ) return P3AlPsr2LdStCodeGen((HEXCODE_STHUB                  ), f, TokenList, &TokenIndex, &NumOfToken, Code);
    if(Token->Type == TOKEN_STH_UB_I    ) return P3AlPsr2LdStCodeGen((HEXCODE_STHUB  | OPERAND_IS_IMM), f, TokenList, &TokenIndex, &NumOfToken, Code);
    if(Token->Type == TOKEN_STH_UA_R    ) return P3AlPsr2LdStCodeGen((HEXCODE_STHUA                  ), f, TokenList, &TokenIndex, &NumOfToken, Code);
    if(Token->Type == TOKEN_STH_UA_I    ) return P3AlPsr2LdStCodeGen((HEXCODE_STHUA  | OPERAND_IS_IMM), f, TokenList, &TokenIndex, &NumOfToken, Code);
    if(Token->Type == TOKEN_STB_R       ) return P3AlPsr2LdStCodeGen((HEXCODE_STB                    ), f, TokenList, &TokenIndex, &NumOfToken, Code);
    if(Token->Type == TOKEN_STB_I       ) return P3AlPsr2LdStCodeGen((HEXCODE_STB    | OPERAND_IS_IMM), f, TokenList, &TokenIndex, &NumOfToken, Code);
    if(Token->Type == TOKEN_STB_UB_R    ) return P3AlPsr2LdStCodeGen((HEXCODE_STBUB                  ), f, TokenList, &TokenIndex, &NumOfToken, Code);
    if(Token->Type == TOKEN_STB_UB_I    ) return P3AlPsr2LdStCodeGen((HEXCODE_STBUB  | OPERAND_IS_IMM), f, TokenList, &TokenIndex, &NumOfToken, Code);
    if(Token->Type == TOKEN_STB_UA_R    ) return P3AlPsr2LdStCodeGen((HEXCODE_STBUA                  ), f, TokenList, &TokenIndex, &NumOfToken, Code);
    if(Token->Type == TOKEN_STB_UA_I    ) return P3AlPsr2LdStCodeGen((HEXCODE_STBUA  | OPERAND_IS_IMM), f, TokenList, &TokenIndex, &NumOfToken, Code);
    if(Token->Type == TOKEN_DCDRAIN     ) return P3AlPsr2LdStCodeGen((HEXCODE_DRAIN                  ), f, TokenList, &TokenIndex, &NumOfToken, Code);
    if(Token->Type == TOKEN_PUSH        ) return P3AlPsr2LdStCodeGen((HEXCODE_PUSH                   ), f, TokenList, &TokenIndex, &NumOfToken, Code);
    if(Token->Type == TOKEN_POP         ) return P3AlPsr2LdStCodeGen((HEXCODE_POP                    ), f, TokenList, &TokenIndex, &NumOfToken, Code);

    if(Token->Type == TOKEN_MOV_I       ) return P3AlPsr2CalcCodeGen((HEXCODE_MOV    | OPERAND_IS_IMM), f, TokenList, &TokenIndex, &NumOfToken, Code);
    if(Token->Type == TOKEN_MOV_R       ) return P3AlPsr2CalcCodeGen((HEXCODE_MOV                    ), f, TokenList, &TokenIndex, &NumOfToken, Code);
    if(Token->Type == TOKEN_MOVL_I      ) return P3AlPsr2CalcCodeGen((HEXCODE_MOVL   | OPERAND_IS_IMM), f, TokenList, &TokenIndex, &NumOfToken, Code);
    if(Token->Type == TOKEN_MOVH_I      ) return P3AlPsr2CalcCodeGen((HEXCODE_MOVH   | OPERAND_IS_IMM), f, TokenList, &TokenIndex, &NumOfToken, Code);
    if(Token->Type == TOKEN_ADD_R       ) return P3AlPsr2CalcCodeGen((HEXCODE_ADD                    ), f, TokenList, &TokenIndex, &NumOfToken, Code);
    if(Token->Type == TOKEN_ADD_I       ) return P3AlPsr2CalcCodeGen((HEXCODE_ADD    | OPERAND_IS_IMM), f, TokenList, &TokenIndex, &NumOfToken, Code);
    if(Token->Type == TOKEN_SUB_R       ) return P3AlPsr2CalcCodeGen((HEXCODE_SUB                    ), f, TokenList, &TokenIndex, &NumOfToken, Code);
    if(Token->Type == TOKEN_SUB_I       ) return P3AlPsr2CalcCodeGen((HEXCODE_SUB    | OPERAND_IS_IMM), f, TokenList, &TokenIndex, &NumOfToken, Code);
    if(Token->Type == TOKEN_AND_R       ) return P3AlPsr2CalcCodeGen((HEXCODE_AND                    ), f, TokenList, &TokenIndex, &NumOfToken, Code);
    if(Token->Type == TOKEN_AND_I       ) return P3AlPsr2CalcCodeGen((HEXCODE_AND    | OPERAND_IS_IMM), f, TokenList, &TokenIndex, &NumOfToken, Code);
    if(Token->Type == TOKEN_OR_R        ) return P3AlPsr2CalcCodeGen((HEXCODE_OR                     ), f, TokenList, &TokenIndex, &NumOfToken, Code);
    if(Token->Type == TOKEN_OR_I        ) return P3AlPsr2CalcCodeGen((HEXCODE_OR     | OPERAND_IS_IMM), f, TokenList, &TokenIndex, &NumOfToken, Code);
    if(Token->Type == TOKEN_XOR_R       ) return P3AlPsr2CalcCodeGen((HEXCODE_XOR                    ), f, TokenList, &TokenIndex, &NumOfToken, Code);
    if(Token->Type == TOKEN_XOR_I       ) return P3AlPsr2CalcCodeGen((HEXCODE_XOR    | OPERAND_IS_IMM), f, TokenList, &TokenIndex, &NumOfToken, Code);
    if(Token->Type == TOKEN_LSR_R       ) return P3AlPsr2CalcCodeGen((HEXCODE_LSR                    ), f, TokenList, &TokenIndex, &NumOfToken, Code);
    if(Token->Type == TOKEN_LSR_I       ) return P3AlPsr2CalcCodeGen((HEXCODE_LSR    | OPERAND_IS_IMM), f, TokenList, &TokenIndex, &NumOfToken, Code);
    if(Token->Type == TOKEN_LSL_R       ) return P3AlPsr2CalcCodeGen((HEXCODE_LSL                    ), f, TokenList, &TokenIndex, &NumOfToken, Code);
    if(Token->Type == TOKEN_LSL_I       ) return P3AlPsr2CalcCodeGen((HEXCODE_LSL    | OPERAND_IS_IMM), f, TokenList, &TokenIndex, &NumOfToken, Code);
    if(Token->Type == TOKEN_ASR_R       ) return P3AlPsr2CalcCodeGen((HEXCODE_ASR                    ), f, TokenList, &TokenIndex, &NumOfToken, Code);
    if(Token->Type == TOKEN_ASR_I       ) return P3AlPsr2CalcCodeGen((HEXCODE_ASR    | OPERAND_IS_IMM), f, TokenList, &TokenIndex, &NumOfToken, Code);
    if(Token->Type == TOKEN_MUL_R       ) return P3AlPsr2CalcCodeGen((HEXCODE_MUL                    ), f, TokenList, &TokenIndex, &NumOfToken, Code);
    if(Token->Type == TOKEN_MUL_I       ) return P3AlPsr2CalcCodeGen((HEXCODE_MUL    | OPERAND_IS_IMM), f, TokenList, &TokenIndex, &NumOfToken, Code);
    if(Token->Type == TOKEN_DIVU_R      ) return P3AlPsr2CalcCodeGen((HEXCODE_DIVU                   ), f, TokenList, &TokenIndex, &NumOfToken, Code);
    if(Token->Type == TOKEN_DIVU_I      ) return P3AlPsr2CalcCodeGen((HEXCODE_DIVU   | OPERAND_IS_IMM), f, TokenList, &TokenIndex, &NumOfToken, Code);
    if(Token->Type == TOKEN_DIV_R       ) return P3AlPsr2CalcCodeGen((HEXCODE_DIV                    ), f, TokenList, &TokenIndex, &NumOfToken, Code);
    if(Token->Type == TOKEN_DIV_I       ) return P3AlPsr2CalcCodeGen((HEXCODE_DIV    | OPERAND_IS_IMM), f, TokenList, &TokenIndex, &NumOfToken, Code);
    if(Token->Type == TOKEN_MODU_R      ) return P3AlPsr2CalcCodeGen((HEXCODE_MODU                   ), f, TokenList, &TokenIndex, &NumOfToken, Code);
    if(Token->Type == TOKEN_MODU_I      ) return P3AlPsr2CalcCodeGen((HEXCODE_MODU   | OPERAND_IS_IMM), f, TokenList, &TokenIndex, &NumOfToken, Code);
    if(Token->Type == TOKEN_MOD_R       ) return P3AlPsr2CalcCodeGen((HEXCODE_MOD                    ), f, TokenList, &TokenIndex, &NumOfToken, Code);
    if(Token->Type == TOKEN_MOD_I       ) return P3AlPsr2CalcCodeGen((HEXCODE_MOD    | OPERAND_IS_IMM), f, TokenList, &TokenIndex, &NumOfToken, Code);

    if(Token->Type == TOKEN_DI          ) return P3AlPsr2SysCodeGen(HEXCODE_DI    , Token->FileName, Token->Line, &NumOfToken, Code);
    if(Token->Type == TOKEN_EI          ) return P3AlPsr2SysCodeGen(HEXCODE_EI    , Token->FileName, Token->Line, &NumOfToken, Code);
    if(Token->Type == TOKEN_DIC         ) return P3AlPsr2SysCodeGen(HEXCODE_DIC   , Token->FileName, Token->Line, &NumOfToken, Code);
    if(Token->Type == TOKEN_EIC         ) return P3AlPsr2SysCodeGen(HEXCODE_EIC   , Token->FileName, Token->Line, &NumOfToken, Code);
    if(Token->Type == TOKEN_DDC         ) return P3AlPsr2SysCodeGen(HEXCODE_DDC   , Token->FileName, Token->Line, &NumOfToken, Code);
    if(Token->Type == TOKEN_EDC         ) return P3AlPsr2SysCodeGen(HEXCODE_EDC   , Token->FileName, Token->Line, &NumOfToken, Code);
    if(Token->Type == TOKEN_BLK         ) return P3AlPsr2SysCodeGen(HEXCODE_BLK   , Token->FileName, Token->Line, &NumOfToken, Code);
    if(Token->Type == TOKEN_BULK        ) return P3AlPsr2SysCodeGen(HEXCODE_BULK  , Token->FileName, Token->Line, &NumOfToken, Code);
    if(Token->Type == TOKEN_BREAK       ) return P3AlPsr2SysCodeGen(HEXCODE_BREAK , Token->FileName, Token->Line, &NumOfToken, Code);
    if(Token->Type == TOKEN_NOP         ) return P3AlPsr2SysCodeGen(HEXCODE_NOP   , Token->FileName, Token->Line, &NumOfToken, Code);
    if(Token->Type == TOKEN_IMMSET      ) return P3AlPsr2ImmsetGen(Token->FileName, Token->Line, f, TokenList, &TokenIndex, &NumOfToken, Code);
    if(Token->Type == TOKEN_CPRD        ) return P3AlPsr2CpCodeGen(Token->FileName, Token->Line);
    if(Token->Type == TOKEN_CPWR        ) return P3AlPsr2CpCodeGen(Token->FileName, Token->Line);

    PrintError0(__LINE__, "\G[", "", "");
    P3AlPsr2PrintError(Token, __LINE__);
    return P3AL_NG;
}
//====================================================================================================================
static int  P3AlPsr2CpCodeGen(char *FileName, int Line)
//====================================================================================================================
// [@\] HEXR[hiRv߁j
// []
// [Ԓl] FP3AL_OK, sFP3AL_NG
{
    P3AlPsr2PrintError2(FileName, Line + 1, __LINE__);
    PrintError0(__LINE__, "Rv߂ɂ͖Ή", "", "");
    return P3AL_NG;
}

//====================================================================================================================
static int  P3AlPsr2ImmsetGen(char *FileName, int Line, Function *f, BiDirList *TokenList, int *TokenIndex, int *NumOfToken, CodeInfo *Code)
//====================================================================================================================
// [@\] HEXR[hilݒj
// []
// [Ԓl] FP3AL_OK, sFP3AL_NG
{
    TokenInfo           *Token;
    int                 Ret;
    unsigned long       Imm;

#ifdef TOKEN_READ_DEBUG
    Token = P3AlPsr2NewTokenGet(TokenList, TokenIndex, NumOfToken, __LINE__);
#else
    Token = P3AlPsr2NewTokenGet(TokenList, TokenIndex, NumOfToken);
#endif
    if(Token == NULL){ P3AlPsr2PrintError2(FileName, Line + 1, __LINE__); return P3AL_NG;}

    *TokenIndex -= 1; *NumOfToken += 1;//߂
    Ret = P3AlPsr2ConstExpressionTop(&Imm, f, TokenList, TokenIndex, NumOfToken, Code->Address);
    if(Ret == P3AL_NG){
        P3AlPsr2PrintError2(FileName, Line + 1, __LINE__);
        PrintError0(__LINE__, "Ō̃Iyh̉͂Ɏs", "", "");
        return P3AL_NG;
    }
    Code->HexCode = Imm;
    if(*NumOfToken != 0){
        P3AlPsr2PrintError2(FileName, Line + 1, __LINE__);
        PrintError0(__LINE__, "]ȋLqH", "", "");
        return P3AL_NG;
    }
    return P3AL_OK;
}
//====================================================================================================================
static int  P3AlPsr2SysCodeGen(unsigned long OpCode, char *FileName, int Line, int *NumOfToken, CodeInfo *Code)
//====================================================================================================================
// [@\] HEXR[hiSYS߁j
// []
// [Ԓl] FP3AL_OK, sFP3AL_NG
{
    TokenInfo           *Token2;

    Code->HexCode = OpCode;

    if(*NumOfToken != 0){
        P3AlPsr2PrintError2(FileName, Line + 1, __LINE__);
        PrintError0(__LINE__, "]ȋLqH", "", "");
        return P3AL_NG;
    }

    return P3AL_OK;
}

//====================================================================================================================
static int  P3AlPsr2ShiftCheck(unsigned long OpCode)
//====================================================================================================================
// [@\] SHIFT߂ǂ`FbN
// []
// [Ԓl] gFP3AL_OK, ȂFP3AL_NG
{
    unsigned long Hex;
    Hex = ((~OPERAND_IS_IMM) & OpCode);
    if(Hex == HEXCODE_LSR    ) return P3AL_OK;
    if(Hex == HEXCODE_LSL    ) return P3AL_OK;
    if(Hex == HEXCODE_ASR    ) return P3AL_OK;
    return P3AL_NG;
}
//====================================================================================================================
static int  P3AlPsr2SignExtendCheck(unsigned long OpCode)
//====================================================================================================================
// [@\] l̕g閽߂ǂ`FbN
// []
// [Ԓl] gFP3AL_OK, ȂFP3AL_NG
{
    unsigned long Hex;
    if(OpCode & OPERAND_IS_IMM){
        Hex = ((~OPERAND_IS_IMM) & OpCode);
        if(Hex == HEXCODE_MOV    ) return P3AL_OK;
        if(Hex == HEXCODE_ADD    ) return P3AL_OK;
        if(Hex == HEXCODE_SUB    ) return P3AL_OK;
        if(Hex == HEXCODE_MUL    ) return P3AL_OK;
        if(Hex == HEXCODE_DIVU   ) return P3AL_OK;
        if(Hex == HEXCODE_DIV    ) return P3AL_OK;
        if(Hex == HEXCODE_MODU   ) return P3AL_OK;
        if(Hex == HEXCODE_MOD    ) return P3AL_OK;
    }
    return P3AL_NG;
}
//====================================================================================================================
static int  P3AlPsr2MovCheck(unsigned long OpCode)
//====================================================================================================================
// [@\] MOV߂ǂ`FbN
// []
// [Ԓl] MOV߁FP3AL_OK, MOV߂łȂFP3AL_NG
{
    unsigned long Hex;
    if(OpCode == HEXCODE_MOVL  ) return P3AL_OK;
    if(OpCode == HEXCODE_MOVH  ) return P3AL_OK;
    Hex = ((~OPERAND_IS_IMM) & OpCode);
    if(Hex == HEXCODE_MOV   ) return P3AL_OK;
    return P3AL_NG;
}
//====================================================================================================================
static int  P3AlPsr2CalcCodeGen(unsigned long OpCode, Function *f, BiDirList *TokenList, int *TokenIndex, int *NumOfToken, CodeInfo *Code)
//====================================================================================================================
// [@\] HEXR[hiZ߁j
// []
// [Ԓl] FP3AL_OK, sFP3AL_NG
{
    TokenInfo           *Token;
    unsigned long       Hex;
    int                 Line;
    char                *FileName;
    int                 RegNo;
    int                 Ret;
    unsigned long       Imm;



#ifdef TOKEN_READ_DEBUG
    Token = P3AlPsr2NewTokenGet(TokenList, TokenIndex, NumOfToken, __LINE__);
#else
    Token = P3AlPsr2NewTokenGet(TokenList, TokenIndex, NumOfToken);
#endif
    if(Token == NULL){ P3AlPsr2PrintError2(FileName, Line + 1, __LINE__); return P3AL_NG;}

    FileName = Token->FileName;
    Line = Token->Line;
    Hex = OpCode;

    RegNo = P3AlPsr2GetRegNo(Token->Type);
    if(RegNo == P3AL_NG){
        P3AlPsr2PrintError2(FileName, Line + 1, __LINE__);
        return P3AL_NG;
    }
#ifdef P3AL_NEW_HW_MODE
    if(RegNo == 15){
        P3AlPsr2PrintError2(FileName, Line + 1, __LINE__);
        PrintError0(__LINE__, "WX^No͈͊O(PC(r15)gps)", "", "");
        return P3AL_NG;
    }
#endif
    if(RegNo <= 15){
        Hex = Hex | (RegNo << 20);
    }
    else if((OpCode == HEXCODE_MOV) && (RegNo == REG_NUM_ISR)){
        Hex = Hex | ((RegNo & 0xFF) << 20) | 0x00008000;
    }
    else{
        P3AlPsr2PrintError2(FileName, Line + 1, __LINE__);
        PrintError0(__LINE__, "WX^No͈͊O", "", "");
        return P3AL_NG;
    }

    if(P3AlPsr2MovCheck(OpCode) == P3AL_NG){
#ifdef TOKEN_READ_DEBUG
        Token = P3AlPsr2NewTokenGet(TokenList, TokenIndex, NumOfToken, __LINE__);
#else
        Token = P3AlPsr2NewTokenGet(TokenList, TokenIndex, NumOfToken);
#endif
        if(Token == NULL){ P3AlPsr2PrintError2(FileName, Line + 1, __LINE__); return P3AL_NG;}

        RegNo = P3AlPsr2GetRegNo(Token->Type);
        if(RegNo == P3AL_NG){
            P3AlPsr2PrintError2(FileName, Line + 1, __LINE__);
            return P3AL_NG;
        }

#ifdef P3AL_NEW_HW_MODE
    if(RegNo == 15){
        P3AlPsr2PrintError2(FileName, Line + 1, __LINE__);
        PrintError0(__LINE__, "WX^No͈͊O(PC(r15)gps)", "", "");
        return P3AL_NG;
    }
#endif
        if(RegNo <= 15) {
            Hex = Hex | (RegNo << 16);
        }
        else{
            P3AlPsr2PrintError2(FileName, Line + 1, __LINE__);
            PrintError0(__LINE__, "WX^No͈͊O", "", "");
            return P3AL_NG;
        }
    }


#ifdef TOKEN_READ_DEBUG
    Token = P3AlPsr2NewTokenGet(TokenList, TokenIndex, NumOfToken, __LINE__);
#else
    Token = P3AlPsr2NewTokenGet(TokenList, TokenIndex, NumOfToken);
#endif
    if(Token == NULL){ P3AlPsr2PrintError2(FileName, Line + 1, __LINE__); return P3AL_NG;}


    if(Hex & OPERAND_IS_IMM){
        *TokenIndex -= 1; *NumOfToken += 1;//߂
        Ret = P3AlPsr2ConstExpressionTop(&Imm, f, TokenList, TokenIndex, NumOfToken, Code->Address);
        if(Ret == P3AL_NG){
            P3AlPsr2PrintError2(FileName, Line + 1, __LINE__);
            PrintError0(__LINE__, "Ō̃Iyh̉͂Ɏs", "", "");
            return P3AL_NG;
        }
        if(P3AlPsr2ShiftCheck(OpCode) == P3AL_OK){
            if(Imm & 0xFFFFFFE0){
                P3AlPsr2PrintError2(FileName, Line + 1, __LINE__);
                PrintError0(__LINE__, "Vtgʔ͈͊O", "", "");
                return P3AL_NG;
            }
            Hex = Hex | (Imm & 0x0000001F);
        }
        else if(P3AlPsr2SignExtendCheck(OpCode) == P3AL_OK){
            if(P3AlPsr2Imm16RangeCheck(Imm) == P3AL_NG){
                P3AlPsr2PrintError2(FileName, Line + 1, __LINE__);
                PrintError0(__LINE__, "16rbgl͈̔͊O", "", "");
                return P3AL_NG;
            }
            Hex = Hex | (Imm & 0x0000FFFF);
        }
        else{
            if(P3AlPsr2UnsignedImm16RangeCheck(Imm) == P3AL_NG){
                P3AlPsr2PrintError2(FileName, Line + 1, __LINE__);
                PrintError0(__LINE__, "16rbgl͈̔͊O", "", "");
                return P3AL_NG;
            }
            Hex = Hex | (Imm & 0x0000FFFF);
        }
        Code->HexCode = Hex;
    }
    else{
        RegNo = P3AlPsr2GetRegNo(Token->Type);
        if(RegNo == P3AL_NG){
            P3AlPsr2PrintError2(FileName, Line + 1, __LINE__);
            return P3AL_NG;
        }
#ifdef P3AL_NEW_HW_MODE
        if(RegNo == 15){
            P3AlPsr2PrintError2(FileName, Line + 1, __LINE__);
            PrintError0(__LINE__, "WX^No͈͊O(PC(r15)gps)", "", "");
            return P3AL_NG;
        }
#endif
        if(RegNo <= 15){
            Hex = Hex | RegNo;
        }
        else if((OpCode == HEXCODE_MOV) && (RegNo <= REG_NUM_SR)){
            Hex = Hex | RegNo;
            if(Hex & 0x8000){
                P3AlPsr2PrintError2(FileName, Line + 1, __LINE__);
                PrintError0(__LINE__, "pWX^Ԃ̓]͕s", "", "");
                return P3AL_NG;
            }
        }
        else{
            P3AlPsr2PrintError2(FileName, Line + 1, __LINE__);
            PrintError0(__LINE__, "WX^No͈͊O", "", "");
            return P3AL_NG;
        }
        Code->HexCode = Hex;
    }
    if(*NumOfToken != 0){
        P3AlPsr2PrintError2(FileName, Line + 1, __LINE__);
        PrintError0(__LINE__, "]ȋLqH", "", "");
        return P3AL_NG;
    }
    return P3AL_OK;
}

//====================================================================================================================
static int  P3AlPsr2LdStWithUpDateCheck(unsigned long OpCode)
//====================================================================================================================
// [@\] |C^XVtLD/ST߂ǂ`FbN
// []
// [Ԓl] |C^XVtFP3AL_OK, |C^XVtłȂFP3AL_NG
{
    unsigned long Hex;
    Hex = ((~OPERAND_IS_IMM) & OpCode);
    if(Hex == HEXCODE_LDW   ) return P3AL_NG;
    if(Hex == HEXCODE_LDH   ) return P3AL_NG;
    if(Hex == HEXCODE_LDB   ) return P3AL_NG;
    if(Hex == HEXCODE_LDSH  ) return P3AL_NG;
    if(Hex == HEXCODE_LDSB  ) return P3AL_NG;
    if(Hex == HEXCODE_STW   ) return P3AL_NG;
    if(Hex == HEXCODE_STH   ) return P3AL_NG;
    if(Hex == HEXCODE_STB   ) return P3AL_NG;
    return P3AL_OK;
}
//====================================================================================================================
static int  P3AlPsr2LdStCodeGen(unsigned long OpCode, Function *f, BiDirList *TokenList, int *TokenIndex, int *NumOfToken, CodeInfo *Code)
//====================================================================================================================
// [@\] HEXR[hiLD/ST߁j
// []
// [Ԓl] FP3AL_OK, sFP3AL_NG
{
    TokenInfo           *Token;
    unsigned long       Hex;
    int                 Line;
    char                *FileName;
    int                 RegNo;
    int                 Ret;
    unsigned long       Imm;



#ifdef TOKEN_READ_DEBUG
    Token = P3AlPsr2NewTokenGet(TokenList, TokenIndex, NumOfToken, __LINE__);
#else
    Token = P3AlPsr2NewTokenGet(TokenList, TokenIndex, NumOfToken);
#endif
    if(Token == NULL){ P3AlPsr2PrintError2(FileName, Line + 1, __LINE__); return P3AL_NG;}

    FileName = Token->FileName;
    Line = Token->Line;
    Hex = OpCode;

    RegNo = P3AlPsr2GetRegNo(Token->Type);
    if(RegNo == P3AL_NG){
        P3AlPsr2PrintError2(FileName, Line + 1, __LINE__);
        return P3AL_NG;
    }
    if(RegNo > 14) {
        P3AlPsr2PrintError2(FileName, Line + 1, __LINE__);
        PrintError0(__LINE__, "WX^No͈͊O", "", "");
        return P3AL_NG;
    }

    if(OpCode == HEXCODE_DRAIN){
        Hex = Hex | (RegNo << 16);
        if(*NumOfToken != 0){
            P3AlPsr2PrintError2(FileName, Line + 1, __LINE__);
            PrintError0(__LINE__, "WX^wR[ȟɁA]ȋLqH", "", "");
            return P3AL_NG;
        }
        Code->HexCode = Hex;
        return P3AL_OK;
    }
    else{
        Hex = Hex | (RegNo << 20);
    }

#ifdef TOKEN_READ_DEBUG
    Token = P3AlPsr2NewTokenGet(TokenList, TokenIndex, NumOfToken, __LINE__);
#else
    Token = P3AlPsr2NewTokenGet(TokenList, TokenIndex, NumOfToken);
#endif
    if(Token == NULL){ P3AlPsr2PrintError2(FileName, Line + 1, __LINE__); return P3AL_NG;}

    RegNo = P3AlPsr2GetRegNo(Token->Type);
    if(RegNo == P3AL_NG){
        P3AlPsr2PrintError2(FileName, Line + 1, __LINE__);
        return P3AL_NG;
    }

#ifdef P3AL_NEW_HW_MODE
    if(P3AlPsr2LdStWithUpDateCheck(OpCode) == P3AL_OK){ // x[XWX^XVtLD/ST͎gp֎~
        P3AlPsr2PrintError2(FileName, Line + 1, __LINE__);
        PrintError0(__LINE__, "x[XWX^XVtLD/ST͎gp֎~", "", "");
        return P3AL_NG;
    }
    if(RegNo <= 14){
#else
    if((RegNo <= 14) || ((P3AlPsr2LdStWithUpDateCheck(OpCode) == P3AL_NG) && (RegNo == 15))){

#endif
        Hex = Hex | (RegNo << 16);
    }
    else{
        P3AlPsr2PrintError2(FileName, Line + 1, __LINE__);
        PrintError0(__LINE__, "WX^No͈͊O", "", "");
#ifdef P3AL_NEW_HW_MODE
        if(RegNo == 15) PrintError0(__LINE__, "PC΃AhbVOgps", "", "");
#endif
        return P3AL_NG;
    }


    if((OpCode == HEXCODE_POP) || (OpCode == HEXCODE_PUSH)){
        if(OpCode == HEXCODE_POP) Hex = Hex | 0x4;
        else                      Hex = Hex | ((-4) & 0xFFFF);
        if(*NumOfToken != 0){
            P3AlPsr2PrintError2(FileName, Line + 1, __LINE__);
            PrintError0(__LINE__, "WX^wR[ȟɁA]ȋLqH", "", "");
            return P3AL_NG;
        }
        Code->HexCode = Hex;
        return P3AL_OK;
    }

#ifdef TOKEN_READ_DEBUG
    Token = P3AlPsr2NewTokenGet(TokenList, TokenIndex, NumOfToken, __LINE__);
#else
    Token = P3AlPsr2NewTokenGet(TokenList, TokenIndex, NumOfToken);
#endif
    if(Token == NULL){ P3AlPsr2PrintError2(FileName, Line + 1, __LINE__); return P3AL_NG;}

    if(Hex & OPERAND_IS_IMM){
        *TokenIndex -= 1; *NumOfToken += 1;//߂
        Ret = P3AlPsr2ConstExpressionTop(&Imm, f, TokenList, TokenIndex, NumOfToken, Code->Address);
        if(Ret == P3AL_NG){
            P3AlPsr2PrintError2(FileName, Line + 1, __LINE__);
            PrintError0(__LINE__, "Ō̃Iyh̉͂Ɏs", "", "");
            return P3AL_NG;
        }
        if(P3AlPsr2Imm16RangeCheck(Imm) == P3AL_NG){
            P3AlPsr2PrintError2(FileName, Line + 1, __LINE__);
            PrintError0(__LINE__, "16rbgl͈̔͊O", "", "");
            return P3AL_NG;
        }
        Code->HexCode = Hex | (Imm & 0x0000FFFF);
    }
    else{
        RegNo = P3AlPsr2GetRegNo(Token->Type);
        if(RegNo == P3AL_NG){
            P3AlPsr2PrintError2(FileName, Line + 1, __LINE__);
            return P3AL_NG;
        }
        if(RegNo > 14) {
            P3AlPsr2PrintError2(FileName, Line + 1, __LINE__);
            PrintError0(__LINE__, "WX^No͈͊O", "", "");
            return P3AL_NG;
        }
        Code->HexCode = Hex | RegNo;
    }
    if(*NumOfToken != 0){
        P3AlPsr2PrintError2(FileName, Line + 1, __LINE__);
        PrintError0(__LINE__, "]ȋLqH", "", "");
        return P3AL_NG;
    }
    return P3AL_OK;
}


//====================================================================================================================
static int  P3AlPsr2BranchCodeGen(unsigned long OpCode, Function *f, BiDirList *TokenList, int *TokenIndex, int *NumOfToken, CodeInfo *Code)
//====================================================================================================================
// [@\] HEXR[hi򖽗߁j
// []
// [Ԓl] FP3AL_OK, sFP3AL_NG
{
    TokenInfo           *Token;
    unsigned long       Hex;
    int                 Line;
    char                *FileName;
    int                 RegNo;
    int                 Ret;
    unsigned long       Imm;



#ifdef TOKEN_READ_DEBUG
    Token = P3AlPsr2NewTokenGet(TokenList, TokenIndex, NumOfToken, __LINE__);
#else
    Token = P3AlPsr2NewTokenGet(TokenList, TokenIndex, NumOfToken);
#endif

    if(Token == NULL){ P3AlPsr2PrintError2(FileName, Line + 1, __LINE__); return P3AL_NG;}
    FileName = Token->FileName;
    Line = Token->Line;
    Hex = OpCode;

    if     (Token->Type == TOKEN_COND_ALWAYS                      ) Hex |= COND_AL;
    else if(Token->Type == TOKEN_COND_ZERO                        ) Hex |= COND_EQ;
    else if(Token->Type == TOKEN_COND_NOT_ZERO                    ) Hex |= COND_NE;
    else if(Token->Type == TOKEN_COND_UNSIGNED_HIGHER_OR_SAME     ) Hex |= COND_HS;
    else if(Token->Type == TOKEN_COND_UNSIGNED_LOWER              ) Hex |= COND_LO;
    else if(Token->Type == TOKEN_COND_MINUS                       ) Hex |= COND_MI;
    else if(Token->Type == TOKEN_COND_PLUS                        ) Hex |= COND_PL;
    else if(Token->Type == TOKEN_COND_OVERFLOW                    ) Hex |= COND_VS;
    else if(Token->Type == TOKEN_COND_NOT_OVERFLOW                ) Hex |= COND_VC;
    else if(Token->Type == TOKEN_COND_UNSIGNED_HIGHER             ) Hex |= COND_HI;
    else if(Token->Type == TOKEN_COND_UNSIGNED_LOWER_OR_SAME      ) Hex |= COND_LS;
    else if(Token->Type == TOKEN_COND_SIGNED_GRATER_THAN_OR_EQ    ) Hex |= COND_GE;
    else if(Token->Type == TOKEN_COND_SIGNED_LESS_THAN            ) Hex |= COND_LT;
    else if(Token->Type == TOKEN_COND_SIGNED_GRATER_THAN          ) Hex |= COND_GT;
    else if(Token->Type == TOKEN_COND_SIGNED_LESS_THAN_OR_EQ      ) Hex |= COND_LE;
    else{
        P3AlPsr2PrintError(Token, __LINE__);
        PrintError0(__LINE__, "R[hH", "", "");
        return P3AL_NG;
    }

    if((OpCode == HEXCODE_RTI) || (OpCode == HEXCODE_RTS)){
        if(*NumOfToken != 0){
            P3AlPsr2PrintError2(FileName, Line + 1, __LINE__);
            PrintError0(__LINE__, "R[ȟɁA]ȋLqH", "", "");
            return P3AL_NG;
        }
        if(OpCode == HEXCODE_RTI) RegNo = P3AlPsr2GetRegNo(TOKEN_ILR);
        else                      RegNo = P3AlPsr2GetRegNo(TOKEN_LR);

        Code->HexCode = Hex | (RegNo << 20);
        return P3AL_OK;
    }

#ifdef TOKEN_READ_DEBUG
    Token = P3AlPsr2NewTokenGet(TokenList, TokenIndex, NumOfToken, __LINE__);
#else
    Token = P3AlPsr2NewTokenGet(TokenList, TokenIndex, NumOfToken);
#endif
    if(Token == NULL){ P3AlPsr2PrintError2(FileName, Line + 1, __LINE__); return P3AL_NG;}

    if(Hex & OPERAND_IS_IMM){
        *TokenIndex -= 1; *NumOfToken += 1;//߂
        Ret = P3AlPsr2ConstExpressionTop(&Imm, f, TokenList, TokenIndex, NumOfToken, Code->Address);
        if(Ret == P3AL_NG){
            P3AlPsr2PrintError2(FileName, Line + 1, __LINE__);
            PrintError0(__LINE__, "R[ȟ̋Lq̉͂Ɏs", "", "");
            return P3AL_NG;
        }
        if(P3AlPsr2Imm24RangeCheck(Imm) == P3AL_NG){
            P3AlPsr2PrintError2(FileName, Line + 1, __LINE__);
            PrintError0(__LINE__, "24rbgl͈̔͊O", "", "");
            return P3AL_NG;
        }
        Code->HexCode = Hex | ((Imm >> 2) & 0x00FFFFFF);
    }
    else{
        RegNo = P3AlPsr2GetRegNo(Token->Type);
        if(RegNo == P3AL_NG){
            P3AlPsr2PrintError2(FileName, Line + 1, __LINE__);
            return P3AL_NG;
        }
        if(RegNo > 14) {
            P3AlPsr2PrintError2(FileName, Line + 1, __LINE__);
            PrintError0(__LINE__, "WX^No͈͊O", "", "");
            return P3AL_NG;
        }
        Code->HexCode = Hex | (RegNo << 20);
    }
    if(*NumOfToken != 0){
        P3AlPsr2PrintError2(FileName, Line + 1, __LINE__);
        PrintError0(__LINE__, "]ȋLqH", "", "");
        return P3AL_NG;
    }
    return P3AL_OK;
}
//====================================================================================================================
static int P3AlPsr2ConstExpressionTop(unsigned long *Result, Function *f, BiDirList *TokenList, int *TokenIndex, int *NumOfToken, unsigned long Adr)
//====================================================================================================================
// [@\] 萔̉
// []
// [Ԓl] FP3CC_OK, sFP3AL_NG
{
    int                 Ret;

    Ret = P3AlPsr2ConstExpressionBitOr(Result, f, TokenList, TokenIndex, NumOfToken, Adr);

    if(ConstantExpressionDebugFlag){
        fprintf(LogOut, "P3AlPsr2ConstExpressionTop = %d, 0x08x\n", *Result, *Result);
    }
    return Ret;
}
//====================================================================================================================
static int P3AlPsr2ConstExpressionBitOr(unsigned long *Result, Function *f, BiDirList *TokenList, int *TokenIndex, int *NumOfToken, unsigned long Adr)
//====================================================================================================================
// [@\] 萔̉
// []
// [Ԓl] FP3CC_OK, sFP3AL_NG
{
    TokenInfo           *Token;
    int                 Ret;
    unsigned long       Arg0, Arg1;


    Ret = P3AlPsr2ConstExpressionBitXor(&Arg0, f, TokenList, TokenIndex, NumOfToken, Adr);
    if(Ret == P3AL_NG) return P3AL_NG;
    while(1){
#ifdef TOKEN_READ_DEBUG
        Token = P3AlPsr2NewTokenGet(TokenList, TokenIndex, NumOfToken, __LINE__);
#else
        Token = P3AlPsr2NewTokenGet(TokenList, TokenIndex, NumOfToken);
#endif
        if(Token == NULL){
            *TokenIndex -= 1; *NumOfToken += 1;//߂
            break;
        }
        if(Token->Type != TOKEN_OR){
            *TokenIndex -= 1; *NumOfToken += 1;//߂
            break;
        }
        Ret = P3AlPsr2ConstExpressionBitXor(&Arg1, f, TokenList, TokenIndex, NumOfToken, Adr);
        if(Ret == P3AL_NG) return P3AL_NG;
        Arg0 = Arg0 | Arg1;

        if(ConstantExpressionDebugFlag){
            fprintf(LogOut, "P3AlPsr2ConstExpressionBitOr = %d, 0x%08x\n", Arg0, Arg0);
        }

    }

    *Result = Arg0;
    return P3AL_OK;
}
//====================================================================================================================
static int P3AlPsr2ConstExpressionBitXor(unsigned long *Result, Function *f, BiDirList *TokenList, int *TokenIndex, int *NumOfToken, unsigned long Adr)
//====================================================================================================================
// [@\] 萔̉
// []
// [Ԓl] FP3CC_OK, sFP3AL_NG
{
    TokenInfo           *Token;
    int                 Ret;
    unsigned long       Arg0, Arg1;


    Ret = P3AlPsr2ConstExpressionBitAnd(&Arg0, f, TokenList, TokenIndex, NumOfToken, Adr);
    if(Ret == P3AL_NG) return P3AL_NG;
    while(1){
#ifdef TOKEN_READ_DEBUG
        Token = P3AlPsr2NewTokenGet(TokenList, TokenIndex, NumOfToken, __LINE__);
#else
        Token = P3AlPsr2NewTokenGet(TokenList, TokenIndex, NumOfToken);
#endif
        if(Token == NULL){
            *TokenIndex -= 1; *NumOfToken += 1;//߂
            break;
        }
        if(Token->Type != TOKEN_XOR){
            *TokenIndex -= 1; *NumOfToken += 1;//߂
            break;
        }
        Ret = P3AlPsr2ConstExpressionBitAnd(&Arg1, f, TokenList, TokenIndex, NumOfToken, Adr);
        if(Ret == P3AL_NG) return P3AL_NG;
        Arg0 = Arg0 ^ Arg1;

        if(ConstantExpressionDebugFlag){
            fprintf(LogOut, "P3AlPsr2ConstExpressionBitXor = %d, 0x%08x\n", Arg0, Arg0);
        }

    }

    *Result = Arg0;
    return P3AL_OK;
}
//====================================================================================================================
static int P3AlPsr2ConstExpressionBitAnd(unsigned long *Result, Function *f, BiDirList *TokenList, int *TokenIndex, int *NumOfToken, unsigned long Adr)
//====================================================================================================================
// [@\] 萔̉
// []
// [Ԓl] FP3CC_OK, sFP3AL_NG
{
    TokenInfo           *Token;
    int                 Ret;
    unsigned long       Arg0, Arg1;


    Ret = P3AlPsr2ConstExpressionShift(&Arg0, f, TokenList, TokenIndex, NumOfToken, Adr);
    if(Ret == P3AL_NG) return P3AL_NG;
    while(1){
#ifdef TOKEN_READ_DEBUG
        Token = P3AlPsr2NewTokenGet(TokenList, TokenIndex, NumOfToken, __LINE__);
#else
        Token = P3AlPsr2NewTokenGet(TokenList, TokenIndex, NumOfToken);
#endif
        if(Token == NULL){
            *TokenIndex -= 1; *NumOfToken += 1;//߂
            break;
        }
        if(Token->Type != TOKEN_AMPERSAND){
            *TokenIndex -= 1; *NumOfToken += 1;//߂
            break;
        }
        Ret = P3AlPsr2ConstExpressionShift(&Arg1, f, TokenList, TokenIndex, NumOfToken, Adr);
        if(Ret == P3AL_NG) return P3AL_NG;
        Arg0 = Arg0 & Arg1;

        if(ConstantExpressionDebugFlag){
            fprintf(LogOut, "P3AlPsr2ConstExpressionBitAnd = %d, 0x%08x\n", Arg0, Arg0);
        }

    }

    *Result = Arg0;
    return P3AL_OK;
}
//====================================================================================================================
static int P3AlPsr2ConstExpressionShift(unsigned long *Result, Function *f, BiDirList *TokenList, int *TokenIndex, int *NumOfToken, unsigned long Adr)
//====================================================================================================================
// [@\] 萔̉
// []
// [Ԓl] FP3CC_OK, sFP3AL_NG
{
    TokenInfo           *Token;
    int                 Ret;
    unsigned long       Arg0, Arg1;


    Ret = P3AlPsr2ConstExpressionAddaptive(&Arg0, f, TokenList, TokenIndex, NumOfToken, Adr);
    if(Ret == P3AL_NG) return P3AL_NG;
    while(1){
#ifdef TOKEN_READ_DEBUG
        Token = P3AlPsr2NewTokenGet(TokenList, TokenIndex, NumOfToken, __LINE__);
#else
        Token = P3AlPsr2NewTokenGet(TokenList, TokenIndex, NumOfToken);
#endif
        if(Token == NULL){
            *TokenIndex -= 1; *NumOfToken += 1;//߂
            break;
        }
        if((Token->Type != TOKEN_SHIFT_L) && (Token->Type != TOKEN_SHIFT_R)){
            *TokenIndex -= 1; *NumOfToken += 1;//߂
            break;
        }
        Ret = P3AlPsr2ConstExpressionAddaptive(&Arg1, f, TokenList, TokenIndex, NumOfToken, Adr);
        if(Ret == P3AL_NG) return P3AL_NG;
        if(Token->Type == TOKEN_SHIFT_L) Arg0 = Arg0 << Arg1;
        else                             Arg0 = Arg0 >> Arg1;

        if(ConstantExpressionDebugFlag){
            fprintf(LogOut, "P3AlPsr2ConstExpressionShift = %d, 0x%08x\n", Arg0, Arg0);
        }

    }
    *Result = Arg0;
    return P3AL_OK;
}
//====================================================================================================================
static int P3AlPsr2ConstExpressionAddaptive(unsigned long *Result, Function *f, BiDirList *TokenList, int *TokenIndex, int *NumOfToken, unsigned long Adr)
//====================================================================================================================
// [@\] 萔̉
// []
// [Ԓl] FP3CC_OK, sFP3AL_NG
{
    TokenInfo           *Token;
    int                 Ret;
    unsigned long       Arg0, Arg1;


    Ret = P3AlPsr2ConstExpressionMultiplicative(&Arg0, f, TokenList, TokenIndex, NumOfToken, Adr);
    if(Ret == P3AL_NG) return P3AL_NG;
    while(1){
#ifdef TOKEN_READ_DEBUG
        Token = P3AlPsr2NewTokenGet(TokenList, TokenIndex, NumOfToken, __LINE__);
#else
        Token = P3AlPsr2NewTokenGet(TokenList, TokenIndex, NumOfToken);
#endif
        if(Token == NULL){
            *TokenIndex -= 1; *NumOfToken += 1;//߂
            break;
        }
        if((Token->Type != TOKEN_PLUS) && (Token->Type != TOKEN_MINUS)){
            *TokenIndex -= 1; *NumOfToken += 1;//߂
            break;
        }
        Ret = P3AlPsr2ConstExpressionMultiplicative(&Arg1, f, TokenList, TokenIndex, NumOfToken, Adr);
        if(Ret == P3AL_NG) return P3AL_NG;
        if(Token->Type == TOKEN_PLUS) Arg0 = Arg0 + Arg1;
        else                          Arg0 = Arg0 - Arg1;

        if(ConstantExpressionDebugFlag){
            fprintf(LogOut, "P3AlPsr2ConstExpressionAddaptive = %d, 0x%08x\n", Arg0, Arg0);
        }

    }

    *Result = Arg0;
    return P3AL_OK;
}

//====================================================================================================================
static int P3AlPsr2ConstExpressionMultiplicative(unsigned long *Result, Function *f, BiDirList *TokenList, int *TokenIndex, int *NumOfToken, unsigned long Adr)
//====================================================================================================================
// [@\] 萔̉
// []
// [Ԓl] FP3CC_OK, sFP3AL_NG
{
    TokenInfo           *Token;
    int                 Ret;
    unsigned long       Arg0, Arg1;


    Ret = P3AlPsr2ConstExpressionPrimary(&Arg0, f, TokenList, TokenIndex, NumOfToken, Adr);
    if(Ret == P3AL_NG) return P3AL_NG;
    while(1){
#ifdef TOKEN_READ_DEBUG
        Token = P3AlPsr2NewTokenGet(TokenList, TokenIndex, NumOfToken, __LINE__);
#else
        Token = P3AlPsr2NewTokenGet(TokenList, TokenIndex, NumOfToken);
#endif
        if(Token == NULL){
            *TokenIndex -= 1; *NumOfToken += 1;//߂
            break;
        }
        if((Token->Type != TOKEN_ASTERISK) && (Token->Type != TOKEN_DIV) && (Token->Type != TOKEN_MOD)){
            *TokenIndex -= 1; *NumOfToken += 1;//߂
            break;
        }
        Ret = P3AlPsr2ConstExpressionPrimary(&Arg1, f, TokenList, TokenIndex, NumOfToken, Adr);
        if(Ret == P3AL_NG) return P3AL_NG;
        if     (Token->Type == TOKEN_ASTERISK) Arg0 = Arg0 * Arg1;
        else if(Token->Type == TOKEN_DIV     ) Arg0 = Arg0 / Arg1;
        else                                   Arg0 = Arg0 % Arg1;

        if(ConstantExpressionDebugFlag){
            fprintf(LogOut, "P3AlPsr2ConstExpressionMultiplicative = %d, 0x%08x\n", Arg0, Arg0);
        }
    }

    *Result = Arg0;
    return P3AL_OK;
}
//====================================================================================================================
static int P3AlPsr2ConstExpressionPrimary(unsigned long *Result, Function *f, BiDirList *TokenList, int *TokenIndex, int *NumOfToken, unsigned long Adr)
//====================================================================================================================
// [@\] 萔̉
// []
// [Ԓl] FP3CC_OK, sFP3AL_NG
{
    TokenInfo           *Token;
    int                 TokenType;
    int                 Ret;
    unsigned long       Res;
    char                *Id;
    Variable            *v;

#ifdef TOKEN_READ_DEBUG
    Token = P3AlPsr2NewTokenGet(TokenList, TokenIndex, NumOfToken, __LINE__);
#else
    Token = P3AlPsr2NewTokenGet(TokenList, TokenIndex, NumOfToken);
#endif
    if(Token == NULL){
        *TokenIndex -= 1; *NumOfToken += 1;//߂
        return P3AL_NG;
    }
    TokenType = Token->Type;
    if(TokenType == TOKEN_BRACKET_L){ // "()"ň͂܂ꂽ
        Ret = P3AlPsr2ConstExpressionTop(&Res, f, TokenList, TokenIndex, NumOfToken, Adr);
        if(Ret == P3AL_NG) return P3AL_NG;
#ifdef TOKEN_READ_DEBUG
        Token = P3AlPsr2NewTokenGet(TokenList, TokenIndex, NumOfToken, __LINE__);
#else
        Token = P3AlPsr2NewTokenGet(TokenList, TokenIndex, NumOfToken);
#endif
        if((Token->Type == NULL) || (Token->Type != TOKEN_BRACKET_R)){
            *TokenIndex -= 1; *NumOfToken += 1;//߂
            PrintError0(__LINE__, "ʂ̑ΉρH", "", "");
            return P3AL_NG;
        }
        if(ConstantExpressionDebugFlag){
            fprintf(LogOut, "P3AlPsr2ConstExpressionPrimary () = %d, 0x08x\n", Res, Res);
        }
    }
    else if(TokenType == TOKEN_NUMERIC_LITERAL){
        Res = *(unsigned long *)(Token->ExtInfo);
        if(ConstantExpressionDebugFlag){
            fprintf(LogOut, "P3AlPsr2ConstExpressionPrimary NUMERIC_LITERAL = %d, 0x%08x\n", Res, Res);
        }
    }
    else if((TokenType == TOKEN_PcOffsetOf) || (TokenType == TOKEN_FpOffsetOf) 
    || (TokenType == TOKEN_AddressOf) || (TokenType == TOKEN_AddressHiOf) || (TokenType == TOKEN_AddressLoOf)
    || (TokenType == TOKEN_GpOffsetOf) || (TokenType == TOKEN_GpOffsetHiOf) || (TokenType == TOKEN_GpOffsetLoOf)
    || (TokenType == TOKEN_EntryPointOf) || (TokenType == TOKEN_EntryPointHiOf) || (TokenType == TOKEN_EntryPointLoOf)){

#ifdef TOKEN_READ_DEBUG
        Token = P3AlPsr2NewTokenGet(TokenList, TokenIndex, NumOfToken, __LINE__);
#else
        Token = P3AlPsr2NewTokenGet(TokenList, TokenIndex, NumOfToken);
#endif
        if((Token == NULL) || (Token->Type != TOKEN_BRACKET_L)){
            *TokenIndex -= 1; *NumOfToken += 1;//߂
            return P3AL_NG;
        }
#ifdef TOKEN_READ_DEBUG
        Token = P3AlPsr2NewTokenGet(TokenList, TokenIndex, NumOfToken, __LINE__);
#else
        Token = P3AlPsr2NewTokenGet(TokenList, TokenIndex, NumOfToken);
#endif
        if((Token == NULL) || (Token->Type != TOKEN_IDENTIFIER)){
            *TokenIndex -= 1; *NumOfToken += 1;//߂
            return P3AL_NG;
        }
        Id = (char *)Token->ExtInfo;
        if(TokenType == TOKEN_PcOffsetOf){
            if(P3AlPsr2LabelAdrGet(&Res, f, Id) == P3AL_NG){
                PrintError0(__LINE__, "Ή̍\H", "", "");
                return P3AL_NG;
            }
            Res = ((int)(Res - Adr));
            if(ConstantExpressionDebugFlag){
                fprintf(LogOut, "P3AlPsr2ConstExpressionPrimary PcOffsetOf() = %d, 0x%08x\n", Res, Res);
            }
        }
        else if(TokenType == TOKEN_FpOffsetOf){
            v = BiDirListObjectFind(f->ArgList, Id);
            if(v == NULL){
                v = BiDirListObjectFind(f->LocalList, Id);
                if(v == NULL){
                    PrintError0(__LINE__, "or[JϐɎs", "", "");
                    return P3AL_NG;
                }
            }
            Res = v->Offset;
            if(ConstantExpressionDebugFlag){
                fprintf(LogOut, "P3AlPsr2ConstExpressionPrimary FpOffsetOf() = %d, 0x%08x\n", Res, Res);
            }
        }
        else if((TokenType == TOKEN_GpOffsetOf) || (TokenType == TOKEN_GpOffsetHiOf) || (TokenType == TOKEN_GpOffsetLoOf)){
            v = BiDirListObjectFind(Global0, Id);
            if(v == NULL){
                v = BiDirListObjectFind(Global1, Id);
                if(v == NULL){
                    PrintError0(__LINE__, "O[o̓X^eBbNϐɎs", "", "");
                    return P3AL_NG;
                }
            }
            if((SmallMemory == P3AL_TRUE) && (v->Offset > 0x7FFF)){
                PrintError0(__LINE__, "O[o̓X^eBbNϐɎs", "", "");
                return P3AL_NG;
            }
            if(TokenType == TOKEN_GpOffsetOf){
                Res = v->Offset;
            }
            else if(TokenType == TOKEN_GpOffsetHiOf){
                Res = v->Offset >> 16;
            }
            else{
                Res = v->Offset & 0xFFFF;
            }
            if(ConstantExpressionDebugFlag){
                fprintf(LogOut, "P3AlPsr2ConstExpressionPrimary GpOffsetOf() = %d, 0x%08x\n", Res, Res);
            }
        }
        else if(TokenType == TOKEN_EntryPointHiOf){
            if(P3AlPsr2LabelAdrGet(&Res, f, Id) == P3AL_NG){
                PrintError0(__LINE__, "Ή̍\H", "", "");
                return P3AL_NG;
            }
            Res = Res >> 16;
            if(ConstantExpressionDebugFlag){
                fprintf(LogOut, "P3AlPsr2ConstExpressionPrimary EntryPointOf()/TOKEN_AddressOf() = %d, 0x%08x\n", Res, Res);
            }
        }
        else if(TokenType == TOKEN_EntryPointLoOf){
            if(P3AlPsr2LabelAdrGet(&Res, f, Id) == P3AL_NG){
                PrintError0(__LINE__, "Ή̍\H", "", "");
                return P3AL_NG;
            }
            Res = Res & 0xFFFF;
            if(ConstantExpressionDebugFlag){
                fprintf(LogOut, "P3AlPsr2ConstExpressionPrimary EntryPointOf()/TOKEN_AddressOf() = %d, 0x%08x\n", Res, Res);
            }
        }
        else if((TokenType == TOKEN_AddressHiOf) || (TokenType == TOKEN_AddressLoOf)){//TOKEN_AddressHiOf, TOKEN_AddressLoOf
            if(P3AlPsr2LabelAdrGet(&Res, f, Id) == P3AL_NG){
                PrintError0(__LINE__, "Ή̍\H", "", "");
                return P3AL_NG;
            }
            if(TokenType == TOKEN_AddressHiOf){
                Res = Res >> 16;
            }
            else{
                Res = Res & 0xFFFF;
            }
            if(ConstantExpressionDebugFlag){
                fprintf(LogOut, "P3AlPsr2ConstExpressionPrimary EntryPointOf()/TOKEN_AddressOf() = %d, 0x%08x\n", Res, Res);
            }
        }
        else{//TOKEN_AddressOf, TOKEN_EntryPointOf
            if(P3AlPsr2LabelAdrGet(&Res, f, Id) == P3AL_NG){
                PrintError0(__LINE__, "Ή̍\H", "", "");
                return P3AL_NG;
            }
            if(ConstantExpressionDebugFlag){
                fprintf(LogOut, "P3AlPsr2ConstExpressionPrimary EntryPointOf()/TOKEN_AddressOf() = %d, 0x%08x\n", Res, Res);
            }
        }
#ifdef TOKEN_READ_DEBUG
        Token = P3AlPsr2NewTokenGet(TokenList, TokenIndex, NumOfToken, __LINE__);
#else
        Token = P3AlPsr2NewTokenGet(TokenList, TokenIndex, NumOfToken);
#endif
        if((Token == NULL) || (Token->Type != TOKEN_BRACKET_R)){
            *TokenIndex -= 1; *NumOfToken += 1;//߂
            return P3AL_NG;
        }
    }
    else if(Token->Type == TOKEN_SizeOfGlobals){
        Res = TotalSizeOfGlobal;
        if(ConstantExpressionDebugFlag){
            fprintf(LogOut, "P3AlPsr2ConstExpressionPrimary SizeOfGlobals = %d, 0x%08x\n", Res, Res);
        }
    }
    else if(Token->Type == TOKEN_OffsetOfGlobals){
        Res = AddressOfInitData + TotalSizeOfGlobal1;
        if(ConstantExpressionDebugFlag){
            fprintf(LogOut, "P3AlPsr2ConstExpressionPrimary OffsetOfGlobals = %d, 0x%08x\n", Res, Res);
        }
    }
    else if(Token->Type == TOKEN_SizeOfGlobals0){
        Res = TotalSizeOfGlobal0;
        if(ConstantExpressionDebugFlag){
            fprintf(LogOut, "P3AlPsr2ConstExpressionPrimary SizeOfGlobals0 = %d, 0x%08x\n", Res, Res);
        }
    }
    else if(Token->Type == TOKEN_SizeOfGlobals1){
        Res = TotalSizeOfGlobal1;
        if(ConstantExpressionDebugFlag){
            fprintf(LogOut, "P3AlPsr2ConstExpressionPrimary SizeOfGlobals1 = %d, 0x%08x\n", Res, Res);
        }
    }
    else if(Token->Type == TOKEN_InitialValue){
        Res = AddressOfInitData;
        if(ConstantExpressionDebugFlag){
            fprintf(LogOut, "P3AlPsr2ConstExpressionPrimary InitialValue = %d, 0x%08x\n", Res, Res);
        }
    }
    else if((Token->Type == TOKEN_NOT) || (Token->Type == TOKEN_PLUS) || (Token->Type == TOKEN_MINUS)){
        TokenType = Token->Type;
        Ret = P3AlPsr2ConstExpressionPrimary(&Res, f, TokenList, TokenIndex, NumOfToken, Adr);
        if(Ret == P3AL_NG) return P3AL_NG;
        if(TokenType == TOKEN_NOT) Res = ~Res;
        else if(TokenType == TOKEN_MINUS) Res = 0 - Res;
        if(ConstantExpressionDebugFlag){
            fprintf(LogOut, "P3AlPsr2ConstExpressionPrimary (Prefix)= %d, 0x%08x\n", Res, Res);
        }
    }
    else{
        *TokenIndex -= 1; *NumOfToken += 1;//߂
        PrintError0(__LINE__, "Ή̍\H", "", "");
        return P3AL_NG;
    }

    *Result = Res;
    return P3AL_OK;
}

//====================================================================================================================
static int P3AlPsr2LabelAdrGet(unsigned long *Result, Function *f, char *Label)
//====================================================================================================================
// [@\] x
// []
// [Ԓl] FP3CC_OK, sFP3AL_NG
{
    CodeInfo            *Code;
    int                 NumOfFiles;
    int                 i,j;
    InputSrcFileInfo    *SrcInfo;
    Function            *Func;
    int                 NumOfFunc;

    Code = BiDirListObjectFind(f->CodeList, Label);
    if(Code != NULL){
        *Result = Code->Address;
        return P3AL_OK;
    }
    else{
        NumOfFiles = BiDirListNumOfMemberGet(InputSrcList);
        for(i = 0; i < NumOfFiles; i++){
            SrcInfo = (InputSrcFileInfo *)BiDirListObjectGet(InputSrcList, i);
            NumOfFunc = BiDirListNumOfMemberGet(SrcInfo->FunctionList);
            for(j = 0; j < NumOfFunc; j++){
                Func = (Function *)BiDirListObjectGet(SrcInfo->FunctionList, j);
                if(strcmp(Func->Name, Label) == 0){
                    *Result = Func->EntryAddress;
                    return P3AL_OK;
                }
            }
        }
    }
    PrintError0(__LINE__, "xɎs", "", "");
    return P3AL_NG;
}

//====================================================================================================================
static int P3AlPsr2Imm16RangeCheck(unsigned long Imm)
//====================================================================================================================
// [@\] 16rbgl͈̓`FbN
// []
// [Ԓl] FP3CC_OK, sFP3AL_NG
{
    if(((int)Imm > 0xFFFF8000) && ((int)Imm < 0x00007FFF)) return P3AL_OK;
    if((0xFFFF0000 & Imm) == 0) return P3AL_OK;
    return P3AL_NG;
}

//====================================================================================================================
static int P3AlPsr2UnsignedImm16RangeCheck(unsigned long Imm)
//====================================================================================================================
// [@\] 16rbgl͈̓`FbN
// []
// [Ԓl] FP3CC_OK, sFP3AL_NG
{
    if(0xFFFF0000 & Imm) return P3AL_NG;
    return P3AL_OK;
}

//====================================================================================================================
static int P3AlPsr2Imm24RangeCheck(unsigned long Imm)
//====================================================================================================================
// [@\] 24rbgl͈̓`FbN
// []
// [Ԓl] FP3CC_OK, sFP3AL_NG
{
    if(((int)Imm > 0xFF800000) && ((int)Imm < 0x007FFFFF)) return P3AL_OK;
    return P3AL_NG;
}
//====================================================================================================================
static int P3AlPsr2GetRegNo(int TokenType)
//====================================================================================================================
// [@\] WX^No擾
// []
// [Ԓl] FWX^No, sFP3AL_NG
{
    if(TokenType == TOKEN_NON ) return REG_NUM_NON;
    if(TokenType == TOKEN_R0  ) return 0 ;
    if(TokenType == TOKEN_R1  ) return 1 ;
    if(TokenType == TOKEN_R2  ) return 2 ;
    if(TokenType == TOKEN_R3  ) return 3 ;
    if(TokenType == TOKEN_R4  ) return 4 ;
    if(TokenType == TOKEN_R5  ) return 5 ;
    if(TokenType == TOKEN_R6  ) return 6 ;
    if(TokenType == TOKEN_R7  ) return 7 ;
    if(TokenType == TOKEN_R8  ) return 8 ;
    if(TokenType == TOKEN_R9  ) return 9 ;
    if(TokenType == TOKEN_R10 ) return 10;
    if(TokenType == TOKEN_R11 ) return 11;
    if(TokenType == TOKEN_R12 ) return 12;
    if(TokenType == TOKEN_R13 ) return 13;
    if(TokenType == TOKEN_R14 ) return 14;
    if(TokenType == TOKEN_R15 ) return 15;
    if(TokenType == TOKEN_ISR ) return REG_NUM_ISR   ;
    if(TokenType == TOKEN_SR  ) return REG_NUM_SR    ;
    if(TokenType == TOKEN_FP  ) return REG_NUM_FP    ;
    if(TokenType == TOKEN_GP  ) return REG_NUM_GP    ;
    if(TokenType == TOKEN_SP  ) return REG_NUM_SP    ;
    if(TokenType == TOKEN_LR  ) return REG_NUM_LR    ;
    if(TokenType == TOKEN_ILR ) return REG_NUM_ILR   ;
    if(TokenType == TOKEN_PC  ) return REG_NUM_PC    ;
    PrintError0(__LINE__, "WX^҂ĂʒuɃWX^̋LqȂH", "", "");
    return P3AL_NG;
}

//====================================================================================================================
static int P3AlPsr1LocalLabelCheck(void)
//====================================================================================================================
// [@\] x`FbN
// []
// [Ԓl] FP3CC_OK, sFP3AL_NG
{
    int                 NumOfFiles;
    int                 i,j,k,m;
    InputSrcFileInfo    *SrcInfo;
    Function            *Func;
    int                 NumOfFunc;
    CodeInfo            *Code0;
    CodeInfo            *Code1;
    int                 NumOfCode;
    char                Msg[1024];

    NumOfFiles = BiDirListNumOfMemberGet(InputSrcList);
    for(i = 0; i < NumOfFiles; i++){
        SrcInfo = (InputSrcFileInfo *)BiDirListObjectGet(InputSrcList, i);
        NumOfFunc = BiDirListNumOfMemberGet(SrcInfo->FunctionList);
        for(j = 0; j < NumOfFunc; j++){
            Func = (Function *)BiDirListObjectGet(SrcInfo->FunctionList, j);
            NumOfCode = BiDirListNumOfMemberGet(Func->CodeList);
            for(k = 0; k < NumOfCode; k++){
                Code0 = (CodeInfo *)BiDirListObjectGet(Func->CodeList, k);
                if(Code0->Label != NULL){
                    for(m = k + 1; m < NumOfCode; m++){
                        Code1 = (CodeInfo *)BiDirListObjectGet(Func->CodeList, m);
                        if(Code1->Label != NULL){
                            if(strcmp(Code0->Label, Code1->Label) == 0){
                                sprintf(Msg, "%s ̊֐ %s Ńx %s dĂ܂", SrcInfo->FileName, Func->Name, Code0->Label);
                                PrintError0(__LINE__, Msg, "", "");
                                return P3AL_NG;
                            }
                        }
                    }
                }
            }
        }
    }
    return P3AL_OK;
}
//====================================================================================================================
static int P3AlPsr1Global1Trim(void)
//====================================================================================================================
// [@\] tO[oϐ̃ItZbg
// []
// [Ԓl] FP3AL_OK, sFP3AL_NG
{
    int                 i;
    int                 NumOfGloval1;
    Variable            *v;

    if(TotalSizeOfGlobal1 == 0) return P3AL_OK;

    NumOfGloval1 = BiDirListNumOfMemberGet(Global1);
    for(i = 0; i < NumOfGloval1; i++){
        v = (Variable *)BiDirListObjectGet(Global1, i);
        v->Offset += TotalSizeOfGlobal0;
    }

    return P3AL_OK;
}

//====================================================================================================================
static int P3AlPsr1InitializerAlloc(void)
//====================================================================================================================
// [@\] f[^zu
// []
// [Ԓl] Ff[^TCY, sFP3AL_NG
{
    int                 i, j;
    int                 NumOfGloval1;
    Variable            *v;
    int                 NumOfIniData;
    Initializer         *Init;
    unsigned char       *p;

    if(TotalSizeOfGlobal1 == 0) return P3AL_OK;
    InitData = calloc(TotalSizeOfGlobal1, 1);

    NumOfGloval1 = BiDirListNumOfMemberGet(Global1);
    for(i = 0; i < NumOfGloval1; i++){
        v = (Variable *)BiDirListObjectGet(Global1, i);
        if(v->InitializerList != NULL){
            NumOfIniData = BiDirListNumOfMemberGet(v->InitializerList);
            p = InitData + v->Offset - TotalSizeOfGlobal0;
            for(j = 0; j < NumOfIniData; j++){
                Init = (Initializer *)BiDirListObjectGet(v->InitializerList, j);
                *p = Init->InitVal;
                ++p;
            }
        }
    }

    return P3AL_OK;
}
//====================================================================================================================
static int P3AlPsr1InitDataTrim(void)
//====================================================================================================================
// [@\] ̑Af[^̃V{QƂ̉Ȃ
// []
// [Ԓl] FP3AL_OK, sFP3AL_NG
{
    int                 i, j;
    int                 NumOfGloval1;
    Variable            *v;
    int                 NumOfIniData;
    Initializer         *Init;
    char                *Id;
    Function            *f;
    unsigned long       EntryAddress;   // ֐̃AhX

    NumOfGloval1 = BiDirListNumOfMemberGet(Global1);
    for(i = 0; i < NumOfGloval1; i++){
        v = (Variable *)BiDirListObjectGet(Global1, i);
        if(v->InitializerList != NULL){
            NumOfIniData = BiDirListNumOfMemberGet(v->InitializerList);
            for(j = 0; j < NumOfIniData; j++){
                Init = (Initializer *)BiDirListObjectGet(v->InitializerList, j);
                if(Init->Type == TOKEN_IDENTIFIER){
                    if(Init->StrNo == 3){
                        Id = Init->Str;
                        f = P3AlPsrFindFunction(Id);
                        if(f == NULL){
                            PrintError0(__LINE__, "V{\"", Id, "\"̎QƂ̉ɎsB");
                            return P3AL_NG;
                        }
                        EntryAddress = f->EntryAddress;
                        Init->InitVal = 0xFF & (EntryAddress >> 24);
                    }
                    else if(Init->StrNo == 2){
                        Init->InitVal = 0xFF & (EntryAddress >> 16);
                    }
                    else if(Init->StrNo == 1){
                        Init->InitVal = 0xFF & (EntryAddress >> 8);
                    }
                    else{
                        Init->InitVal = 0xFF & EntryAddress;
                    }
                }
            }
        }
    }

    return P3AL_OK;
}

//====================================================================================================================
static Function *P3AlPsrFindFunction(char *FuncName)
//====================================================================================================================
// [@\] ̑Af[^̃V{QƂ̉Ȃ
// []
// [Ԓl] F֐ւ̃|C^, sFNULL
{
    int                 NumOfFiles;
    int                 i, j;
    InputSrcFileInfo    *SrcInfo;
    Function            *f;
    int                 NumOfFunc;

    NumOfFiles = BiDirListNumOfMemberGet(InputSrcList);
    for(i = 0; i < NumOfFiles; i++){
        SrcInfo = (InputSrcFileInfo *)BiDirListObjectGet(InputSrcList, i);
        NumOfFunc = BiDirListNumOfMemberGet(SrcInfo->FunctionList);
        for(j = 0; j < NumOfFunc; j++){
            f = (Function *)BiDirListObjectGet(SrcInfo->FunctionList, j);
            if(strcmp(FuncName, f->Name) == 0) return f;
        }
    }
    return NULL;
}

//====================================================================================================================
static int P3AlPsr1MakeReadOnlyData(void)
//====================================================================================================================
// [@\] READ ONLYf[^쐬
// []
// [Ԓl] Ff[^TCY, sFP3AL_NG
{
    int                 i, j;
    int                 NumOfGloval1;
    Variable            *v;
    int                 NumOfIniData;
    Initializer         *Init;
    unsigned long       Offset;
    unsigned long       DataSize;
    unsigned long       TotalDataSize;
    char                *p;

    TotalDataSize = 0;
    NumOfGloval1 = BiDirListNumOfMemberGet(Global1);
    for(i = 0; i < NumOfGloval1; i++){
        v = (Variable *)BiDirListObjectGet(Global1, i);
        if(v->InitializerList != NULL){
            NumOfIniData = BiDirListNumOfMemberGet(v->InitializerList);
            for(j = 0; j < NumOfIniData; j++){
                Init = (Initializer *)BiDirListObjectGet(v->InitializerList, j);
                if((Init->Type == TOKEN_STRING_LITERAL) && (Init->StrNo == 3)){
                    DataSize = ((strlen(Init->Str) + 1) + 3) & (~0x3);
                    TotalDataSize += DataSize;
                }
            }
        }
    }
    if(TotalDataSize == 0) return 0;
    ReadOnlyData = calloc(TotalDataSize, 1);

    TotalDataSize = 0;
    p = (char *)ReadOnlyData;
    for(i = 0; i < NumOfGloval1; i++){
        v = (Variable *)BiDirListObjectGet(Global1, i);
        if(v->InitializerList != NULL){
            NumOfIniData = BiDirListNumOfMemberGet(v->InitializerList);
            for(j = 0; j < NumOfIniData; j++){
                Init = (Initializer *)BiDirListObjectGet(v->InitializerList, j);
                if(Init->Type == TOKEN_STRING_LITERAL){
                    if(Init->StrNo == 3){
                        Offset = TotalDataSize + AddressOfReadOnlyData;
                        strcpy(p, Init->Str);
                        DataSize = ((strlen(Init->Str) + 1) + 3) & (~0x3);
                        TotalDataSize += DataSize;
                        p = p + DataSize;
                        Init->InitVal = 0xFF & (Offset >> 24);
                    }
                    else if(Init->StrNo == 2){
                        Init->InitVal = 0xFF & (Offset >> 16);
                    }
                    else if(Init->StrNo == 1){
                        Init->InitVal = 0xFF & (Offset >> 8);
                    }
                    else{
                        Init->InitVal = 0xFF & Offset;
                    }
                }
            }
        }
    }


    return TotalDataSize;
}


//====================================================================================================================
static int P3AlPsr1LocalAndArgAlloc(void)
//====================================================================================================================
// [@\] Localϐ & zu
// []
// [Ԓl] FP3AL_OK, sFP3AL_NG
{
    int                 NumOfFiles;
    int                 i, j;
    InputSrcFileInfo    *SrcInfo;
    Function            *f;
    int                 NumOfFunc;
    NumOfFiles = BiDirListNumOfMemberGet(InputSrcList);
    for(i = 0; i < NumOfFiles; i++){
        SrcInfo = (InputSrcFileInfo *)BiDirListObjectGet(InputSrcList, i);
        NumOfFunc = BiDirListNumOfMemberGet(SrcInfo->FunctionList);
        for(j = 0; j < NumOfFunc; j++){
            f = (Function *)BiDirListObjectGet(SrcInfo->FunctionList, j);
            P3AlPsr1VariableAlloc(VARIABLE_LOCAL, f->LocalList);
            P3AlPsr1VariableAlloc(VARIABLE_ARG, f->ArgList);
        }
    }
    return P3AL_OK;
}

//====================================================================================================================
static long P3AlPsr1VariableAlloc(int Mode, BiDirList *VList)
//====================================================================================================================
// [@\] ϐzu
// [] Mode : VARIABLE_GLOBAL
//               VARIABLE_LOCAL
//               VARIABLE_ARG
// [Ԓl] FϐŜ̃TCY, sFP3AL_NG
{
    int                 i;
    int                 NumOfVariable;
    Variable            *v;
    int                 Counter;
    long                Total;
    long                TopOffset;

    Counter = 0;
    NumOfVariable = BiDirListNumOfMemberGet(VList);
    for(i = 0; i < NumOfVariable; i++){
        v = (Variable *)BiDirListObjectGet(VList, i);
        Counter += v->OffsetIsValid;
        if(i == 0) TopOffset = v->Offset;
    }
    if(Mode == VARIABLE_GLOBAL){
        if(Counter != 0){
            PrintError0(__LINE__, "\ᔽBGLOBALϐ̐錾ɃItZbgLqĂ܂B", "", "");
            return P3AL_NG;
        }
        else{
            Total = P3AlPsr1VariableAllocBody(Mode, VList);
        }
    }
    else{
        if(Counter == 0){
            Total = P3AlPsr1VariableAllocBody(Mode, VList);
        }
        else if(Counter != NumOfVariable){
            PrintError0(__LINE__, "\ᔽBLOCALϐ͈̐錾ŃItZbgL^݂Ă܂B", "", "");
            return P3AL_NG;
        }
        else{
            if(Mode == VARIABLE_LOCAL) Total = 0 - TopOffset;
            else                       Total = NumOfVariable * 4;
        }
    }
    return Total;
}
//====================================================================================================================
static long P3AlPsr1VariableAllocBody(int Mode, BiDirList *VList)
//====================================================================================================================
// [@\] ϐzu
//
// [] Mode : VARIABLE_GLOBAL
//               VARIABLE_LOCAL
//               VARIABLE_ARG
// [Ԓl] FϐŜ̃TCY, sFP3AL_NG
{
    int                 i;
    int                 NumOfVariable;
    Variable            *v;
    long                Total;

    NumOfVariable = BiDirListNumOfMemberGet(VList);
    Total = 0;
    for(i = 0; i < NumOfVariable; i++){
        v = (Variable *)BiDirListObjectGet(VList, i);
        if(Mode == VARIABLE_ARG){
            Total += 4;
            v->Offset = Total;
        }
        else{
            if(v->Size == 1){
                v->Offset = Total;
                Total = Total + 1;
            }
            else if(v->Size == 2){
                Total = ((Total + 1) & (~0x1));
                v->Offset = Total;
                Total = Total + 2;
            }
            else{
                Total = ((Total + 3) & (~0x3));
                v->Offset = Total;
                Total = Total + v->Size;
            }
        }
    }
    Total = ((Total + 3) & (~0x3));
    if(Mode == VARIABLE_LOCAL){
        for(i = 0; i < NumOfVariable; i++){
            v = (Variable *)BiDirListObjectGet(VList, i);
            v->Offset = v->Offset - Total;
        }
    }
    return Total;
}
//====================================================================================================================
static unsigned long P3AlPsr1CodeAlloc(void)
//====================================================================================================================
// [@\] R[hzu
// []
// [Ԓl] FR[h̍ŏIAhX{S, sFP3AL_NG
{
    int                 NumOfFiles;
    int                 i, j, k;
    InputSrcFileInfo    *SrcInfo;
    unsigned long       Adr;
    Function            *f;
    int                 NumOfFunc;
    CodeInfo            *Code;
    int                 NumOfCode;

    Adr = 0;
    NumOfFiles = BiDirListNumOfMemberGet(InputSrcList);
    for(i = 0; i < NumOfFiles; i++){
        SrcInfo = (InputSrcFileInfo *)BiDirListObjectGet(InputSrcList, i);
        NumOfFunc = BiDirListNumOfMemberGet(SrcInfo->FunctionList);
        for(j = 0; j < NumOfFunc; j++){
            f = (Function *)BiDirListObjectGet(SrcInfo->FunctionList, j);
            f->EntryAddress = Adr;
            NumOfCode = BiDirListNumOfMemberGet(f->CodeList);
            for(k = 0; k < NumOfCode; k++){
                Code = (CodeInfo *)BiDirListObjectGet(f->CodeList, k);
                Code->Address = Adr + Code->Offset;
            }
            Adr += f->CodeSize;
        }
    }
    return Adr;
}

//====================================================================================================================
static int P3AlPsr0Body(TokenAccessHandler *TokenHandle)
//====================================================================================================================
// [@\] ϐ\ER[h\̍쐬({)
// []
// [Ԓl] FP3AL_OK, sFP3AL_NG
{
    BiDirList       *TokenList;
    TokenInfo       *Token;
    char            Msg[1024];

    TokenList = TokenHandle->SrcInfo->TokenList;
    while(1){
        if(TokenHandle->TokenIndex >= TokenHandle->NumOfToken) break;
        Token = P3AlPsrTokenGet(TokenList, TokenHandle->TokenIndex);
        if(Token->Type == TOKEN_GLOBAL_VAR){
            if(P3AlPsr0VariableGet(TokenHandle) == P3AL_NG){ PrintError0(__LINE__, "GLOBALϐ錾͎s", "", "");return P3AL_NG; }
        }
        else if(Token->Type == TOKEN_GLOBAL_BASE){
            if(P3AlPsr0GlobalBaseGet(TokenHandle) == P3AL_NG){ PrintError0(__LINE__, "GLOBALϐ錾͎s", "", "");return P3AL_NG; }
        }
        else if(Token->Type == TOKEN_FUNCTION){
            if(P3AlPsr0FunctionGet(TokenHandle) == P3AL_NG){ PrintError0(__LINE__, "GLOBALϐ錾͎s", "", "");return P3AL_NG; }
        }
        else if(Token->Type == TOKEN_EXTERNAL_FUNC){
            P3AlPsrTokenSkip2LF(TokenHandle); // s܂ŃXLbviƂ肠j
        }
        else if(Token->Type == TOKEN_EXTERNAL_VAR){
            P3AlPsrTokenSkip2LF(TokenHandle); // s܂ŃXLbviƂ肠j
        }
        else if(Token->Type == TOKEN_LF){
            TokenHandle->TokenIndex += 1;
        }
        else{
            PrintTokenBody(Msg, Token);
            PrintError0(__LINE__, "͕s\ȃg[N [", Msg, "]\n");
            return P3AL_NG;
        }
    }
    return P3AL_OK;
}
//====================================================================================================================
static int P3AlPsr0GlobalBaseGet(TokenAccessHandler *TokenHandle)
//====================================================================================================================
// [@\] O[ox[XAhX擾
// [] TokenAccessHandler *TokenHandle
// [Ԓl] FP3AL_OK, sFP3AL_NG
{
    TokenInfo       *Token;
    BiDirList       *TokenList;
    char            Msg[1024];

    TokenList = TokenHandle->SrcInfo->TokenList;

    if(P3AlPsr0IncTokenIndex(TokenHandle) == P3AL_NG){// .GLOBAL_BASE_ADDRESS̎
        PrintError0(__LINE__, "\̓rŏI?", "", "");
        return P3AL_NG; 
    }
    Token = P3AlPsrTokenGet(TokenList, TokenHandle->TokenIndex);
    if(Token->Type != TOKEN_NUMERIC_LITERAL){
        PrintTokenBody(Msg, Token);
        PrintError0(__LINE__, "\ᔽ [", Msg, "]\n");
        return P3AL_NG;
    }

    GlobalBaseAddress = *(unsigned long *)(Token->ExtInfo);

    if(P3AlPsr0IncTokenIndex(TokenHandle) == P3AL_NG){
        PrintError0(__LINE__, "\̓rŏI?", "", "");
        return P3AL_NG; // 
    }
    return P3AL_OK;
}

//====================================================================================================================
static int P3AlPsr0IncTokenIndex(TokenAccessHandler *TokenHandle)
//====================================================================================================================
// [@\] TokenIndexi߂
// [] TokenAccessHandler *TokenHandle
// [] int Line :sڂĂяoꂽ
// [Ԓl] FP3AL_OK, sFP3AL_NG
{
    TokenHandle->TokenIndex += 1;
    if(TokenHandle->TokenIndex >= TokenHandle->NumOfToken){
        return P3AL_NG;
    }
    return P3AL_OK;
}

//====================================================================================================================
static int P3AlPsr0FunctionGet(TokenAccessHandler *TokenHandle)
//====================================================================================================================
// [@\] ֐i[JϐƈXgAyуR[h\j쐬
// [] TokenAccessHandler *TokenHandle
// [Ԓl] FP3AL_OK, sFP3AL_NG
{
    unsigned long   i;
    BiDirList       *TokenList;
    TokenInfo       *Token;
    Function        f;
    char            Msg[1024];

    f.Name = NULL;
    f.FileName = NULL;
    f.EntryAddress = 0;
    f.CodeSize = 0;
    f.ArgList = BiDirListCreate(NULL, FindVariable);
    f.LocalList = BiDirListCreate(NULL, FindVariable);
    f.CodeList = BiDirListCreate(NULL, FindLabel);
    TokenHandle->f = &f;

    TokenList = TokenHandle->SrcInfo->TokenList;

    if(P3AlPsr0IncTokenIndex(TokenHandle) == P3AL_NG){ // .FUNCTION̎
        PrintError0(__LINE__, "\̓rŏI?", "", "");
        return P3AL_NG;
    }
    
    Token = P3AlPsrTokenGet(TokenList, TokenHandle->TokenIndex);
    if(Token->Type != TOKEN_IDENTIFIER){
        PrintTokenBody(Msg, Token);
        PrintError0(__LINE__, "\ᔽ [", Msg, "]\n");
        return P3AL_NG;
    }
    f.Name = Token->ExtInfo; //֐
    f.FileName = Token->FileName; //֐

    if(P3AlPsr0IncTokenIndex(TokenHandle) == P3AL_NG){ // ֐̎
        PrintError0(__LINE__, "\̓rŏI?", "", "");
        return P3AL_NG;
    }
    Token = P3AlPsrTokenGet(TokenList, TokenHandle->TokenIndex);
    if(Token->Type != TOKEN_LF){
        PrintTokenBody(Msg, Token);
        PrintError0(__LINE__, "\ᔽ [", Msg, "]\n");
        return P3AL_NG;
    }
    if(P3AlPsr0IncTokenIndex(TokenHandle) == P3AL_NG){// s̎
        PrintError0(__LINE__, "\̓rŏI?", "", "");
        return P3AL_NG;
    }
    
    while(1){
        Token = P3AlPsrTokenGet(TokenList, TokenHandle->TokenIndex);
        if(Token->Type == TOKEN_ENDFUNCTION){
            if(P3AlPsr0IncTokenIndex(TokenHandle) == P3AL_NG){ // .ENDFUNCTION̎
                PrintError0(__LINE__, "\̓rŏI?", "", "");
                return P3AL_NG;
            }
            break;
        }
        else if(Token->Type == TOKEN_LOCAL_VAR){
            if(P3AlPsr0VariableGet(TokenHandle) == P3AL_NG){ PrintError0(__LINE__, "LOCALϐ錾͎s", "", "");return P3AL_NG; }
        }
        else if(Token->Type == TOKEN_ARG){
            if(P3AlPsr0VariableGet(TokenHandle) == P3AL_NG){ PrintError0(__LINE__, "錾͎s", "", "");return P3AL_NG; }
        }
        else if(Token->Type == TOKEN_CODE){
            if(P3AlPsr0CodeGet(TokenHandle) == P3AL_NG){ PrintError0(__LINE__, "R[h͎s", "", "");return P3AL_NG; }
        }
        else if(Token->Type == TOKEN_LF){
            if(P3AlPsr0IncTokenIndex(TokenHandle) == P3AL_NG){ // s̎
                PrintError0(__LINE__, "\̓rŏI?", "", "");
                return P3AL_NG;
            }
        }
        else{
            PrintTokenBody(Msg, Token);
            PrintError0(__LINE__, "͕s\ȃg[N [", Msg, "]\n");
            return P3AL_NG;
        }
    }

    if(P3AlPsrFindFunction(f.Name) == NULL){
        if(BiDirListMemberAdd(TokenHandle->SrcInfo->FunctionList, &f, sizeof(Function)) == NULL){
            PrintError0(__LINE__, "֐Xgǉs", "", "");
            return P3AL_NG;
        }
    }
    else{
        PrintError0(__LINE__, "O̊֐B ", f.Name, "");
        return P3AL_NG;
    }
    return P3AL_OK;
}
//====================================================================================================================
static Function *P3AlPsr0FunctionFind(char *Name)
//====================================================================================================================
// [@\] ֐
// []
// [Ԓl] FFunctionւ̃|C^, sFNULL
{
    int                 NumOfFiles;
    int                 i,j;
    InputSrcFileInfo    *SrcInfo;
    Function            *Func;
    int                 NumOfFunc;

    NumOfFiles = BiDirListNumOfMemberGet(InputSrcList);
    for(i = 0; i < NumOfFiles; i++){
        SrcInfo = (InputSrcFileInfo *)BiDirListObjectGet(InputSrcList, i);
        NumOfFunc = BiDirListNumOfMemberGet(SrcInfo->FunctionList);
        for(j = 0; j < NumOfFunc; j++){
            Func = (Function *)BiDirListObjectGet(SrcInfo->FunctionList, j);
            if(strcmp(Func->Name, Name) == 0){
                return Func;
            }
        }
    }
    return NULL;
}


//====================================================================================================================
static int P3AlPsr0CodeGet(TokenAccessHandler *TokenHandle)
//====================================================================================================================
// [@\] ֐i[JϐƈXgAyуR[h\j쐬
// [] TokenAccessHandler *TokenHandle
// [Ԓl] FP3AL_OK, sFP3AL_NG
{
    unsigned long   i;
    BiDirList       *TokenList;
    TokenInfo       *Token;
    TokenInfo       *Token0;
    TokenInfo       *Token1;
    CodeInfo        Code;
    char            Msg[1024];

    Code.Line = 0;
    Code.Label = NULL;
    Code.StartTokenIndex = 0;
    Code.NumOfToken = 0;
    Code.Offset = 0;
    Code.HexCode = HEXCODE_NOP;

    TokenList = TokenHandle->SrcInfo->TokenList;
    if(P3AlPsr0IncTokenIndex(TokenHandle) == P3AL_NG){// .CODE̎
        PrintError0(__LINE__, "\̓rŏI?", "", "");
        return P3AL_NG; 
    }
    
    while(1){
        Token = P3AlPsrTokenGet(TokenList, TokenHandle->TokenIndex);
        if(Token->Type == TOKEN_ENDFUNCTION){
            break;
        }
        else if(Token->Type == TOKEN_LF){
            if(P3AlPsr0IncTokenIndex(TokenHandle) == P3AL_NG){// s̎
                PrintError0(__LINE__, "\̓rŏI?", "", "");
                return P3AL_NG; 
            }
            continue;
        }
        else{
            Code.Line = Token->Line;
            Code.StartTokenIndex = TokenHandle->TokenIndex;
            Code.NumOfToken += 1;
            while(1){
                if(P3AlPsr0IncTokenIndex(TokenHandle) == P3AL_NG){// 
                    PrintError0(__LINE__, "\̓rŏI?", "", "");
                    return P3AL_NG; 
                }
                Token = P3AlPsrTokenGet(TokenList, TokenHandle->TokenIndex);
                if(Token->Type == TOKEN_LF){
                    break;
                }
                Code.NumOfToken += 1;
            }
            Token0 = P3AlPsrTokenGet(TokenList, Code.StartTokenIndex);
            Token1 = P3AlPsrTokenGet(TokenList, Code.StartTokenIndex + 1);
            if((Token0->Type == TOKEN_IDENTIFIER) && (Token1->Type == TOKEN_COLON)){
                Code.Label = (char *)Token0->ExtInfo;
                Code.StartTokenIndex += 2;
                Code.NumOfToken -=2;
                if(Code.NumOfToken <= 0){
                    PrintTokenBody(Msg, Token);
                    PrintError0(__LINE__, "\G[ [", Msg, "]\n");
                    return P3AL_NG;
                }
            }
            if(BiDirListMemberAdd(TokenHandle->f->CodeList, &Code, sizeof(CodeInfo)) == NULL){ PrintError0(__LINE__, "R[hXgǉs", "", "");return P3AL_NG; }
            Code.NumOfToken = 0;
            Code.Offset += 4;
            Code.Label = NULL;
        }
    }

    TokenHandle->f->CodeSize = 4 * BiDirListNumOfMemberGet(TokenHandle->f->CodeList);

    return P3AL_OK;
}
//====================================================================================================================
static int P3AlPsr0VariableGet(TokenAccessHandler *TokenHandle)
//====================================================================================================================
// [@\] ϐ\̍쐬({)
// [] TokenAccessHandler *TokenHandle
// [Ԓl] FP3AL_OK, sFP3AL_NG
{
    int             Mode;
    int             MinusFlag;
    unsigned long   i;
    BiDirList       *TokenList;
    TokenInfo       *Token;
    Variable        v;
    Initializer     Ini;
    char            Msg[1024];

    TokenList = TokenHandle->SrcInfo->TokenList;
    Token = P3AlPsrTokenGet(TokenList, TokenHandle->TokenIndex);
    Mode = Token->Type;
    if((Mode != TOKEN_GLOBAL_VAR) && (Token->Type != TOKEN_LOCAL_VAR) && (Token->Type != TOKEN_ARG)){
        PrintTokenBody(Msg, Token);
        PrintError0(__LINE__, "AZũoO [", Msg, "]\n");
        return P3AL_NG;
    }

    if(P3AlPsr0IncTokenIndex(TokenHandle) == P3AL_NG){
        PrintError0(__LINE__, "\̓rŏI?", "", "");
        return P3AL_NG;
    }
    Token = P3AlPsrTokenGet(TokenList, TokenHandle->TokenIndex);
    if(Token->Type != TOKEN_IDENTIFIER){
        PrintTokenBody(Msg, Token);
        PrintError0(__LINE__, "\ᔽ [", Msg, "]\n");
        return P3AL_NG;
    }
    v.Name = Token->ExtInfo; //ϐ

    if(P3AlPsr0IncTokenIndex(TokenHandle) == P3AL_NG){
        PrintError0(__LINE__, "\̓rŏI?", "", "");
        return P3AL_NG;
    }
    Token = P3AlPsrTokenGet(TokenList, TokenHandle->TokenIndex);
    if(Token->Type != TOKEN_NUMERIC_LITERAL){
        PrintTokenBody(Msg, Token);
        PrintError0(__LINE__, "\ᔽ [", Msg, "]\n");
        return P3AL_NG;
    }
    v.Size = *(unsigned long *)Token->ExtInfo; //ϐTCY
    v.Offset = 0;
    v.OffsetIsValid = 0;

    if(P3AlPsr0IncTokenIndex(TokenHandle) == P3AL_NG){
        PrintError0(__LINE__, "\̓rŏI?", "", "");
        return P3AL_NG;
    }
    Token = P3AlPsrTokenGet(TokenList, TokenHandle->TokenIndex);
    if((Token->Type == TOKEN_NUMERIC_LITERAL) || (Token->Type == TOKEN_MINUS)){
        MinusFlag = 0;
        if(Token->Type == TOKEN_MINUS){
            MinusFlag = 1;
            if(P3AlPsr0IncTokenIndex(TokenHandle) == P3AL_NG){
                PrintError0(__LINE__, "\̓rŏI?", "", "");
                return P3AL_NG;
            }
            Token = P3AlPsrTokenGet(TokenList, TokenHandle->TokenIndex);
        }
        if(Token->Type != TOKEN_NUMERIC_LITERAL){
            PrintTokenBody(Msg, Token);
            PrintError0(__LINE__, "\ᔽ [", Msg, "]\n");
            return P3AL_NG;
        }
        v.Offset = *(long *)Token->ExtInfo; //ϐTCY
        if(MinusFlag) v.Offset = 0 - v.Offset;
        v.OffsetIsValid = 1;
        if(P3AlPsr0IncTokenIndex(TokenHandle) == P3AL_NG){
            PrintError0(__LINE__, "\̓rŏI?", "", "");
            return P3AL_NG;
        }
        Token = P3AlPsrTokenGet(TokenList, TokenHandle->TokenIndex);
    }

    if(Token->Type == TOKEN_LF){
        v.InitializerList = NULL;
    }
    else if(Token->Type == TOKEN_EQ){
        //l
        v.InitializerList = BiDirListCreate(NULL, NULL);

        if(P3AlPsr0IncTokenIndex(TokenHandle) == P3AL_NG){
            PrintError0(__LINE__, "\̓rŏI?", "", "");
            return P3AL_NG;
        }
        Token = P3AlPsrTokenGet(TokenList, TokenHandle->TokenIndex);
        if(Token->Type == TOKEN_BRACE_L){
            if(P3AlPsr0IncTokenIndex(TokenHandle) == P3AL_NG){
                PrintError0(__LINE__, "\̓rŏI?", "", "");
                return P3AL_NG;
            }
        }

        i = 0;
        while(1){
            Token = P3AlPsrTokenGet(TokenList, TokenHandle->TokenIndex);
            if(Token->Type == TOKEN_NUMERIC_LITERAL){
                Ini.InitVal = (unsigned char)(*(unsigned long *)(Token->ExtInfo));
                Ini.Type = Token->Type;
                Ini.StrNo = 0;
                Ini.Str = NULL;
                if(BiDirListMemberAdd(v.InitializerList, &Ini, sizeof(Initializer)) == NULL){ PrintError0(__LINE__, "ϐXgǉs", "", "");return P3AL_NG; }
                ++i;
            }
            else if((Token->Type == TOKEN_STRING_LITERAL) || (Token->Type == TOKEN_IDENTIFIER)){
                Ini.InitVal = 0;
                Ini.Type = Token->Type;
                Ini.StrNo = 3;
                Ini.Str = (char *)Token->ExtInfo;
                if(BiDirListMemberAdd(v.InitializerList, &Ini, sizeof(Initializer)) == NULL){ PrintError0(__LINE__, "ϐXgǉs", "", "");return P3AL_NG; }
                Ini.StrNo = 2;
                if(BiDirListMemberAdd(v.InitializerList, &Ini, sizeof(Initializer)) == NULL){ PrintError0(__LINE__, "ϐXgǉs", "", "");return P3AL_NG; }
                Ini.StrNo = 1;
                if(BiDirListMemberAdd(v.InitializerList, &Ini, sizeof(Initializer)) == NULL){ PrintError0(__LINE__, "ϐXgǉs", "", "");return P3AL_NG; }
                Ini.StrNo = 0;
                if(BiDirListMemberAdd(v.InitializerList, &Ini, sizeof(Initializer)) == NULL){ PrintError0(__LINE__, "ϐXgǉs", "", "");return P3AL_NG; }
                i += 4;
            }
            else{
                PrintTokenBody(Msg, Token);
                PrintError0(__LINE__, "\ᔽ [", Msg, "]\n");
                return P3AL_NG;
            }

            while(1){
                if(P3AlPsr0IncTokenIndex(TokenHandle) == P3AL_NG){
                    if( i >= v.Size) break;
                    PrintError0(__LINE__, "\̓rŏI?", "", "");
                    return P3AL_NG;
                }
                Token = P3AlPsrTokenGet(TokenList, TokenHandle->TokenIndex);
                if((Token->Type != TOKEN_LF) && (Token->Type != TOKEN_COMMA) && (Token->Type != TOKEN_BRACE_R)) break;
            }
            if( i >= v.Size) break;
        }
/*
        while(1){
            if(P3AlPsr0IncTokenIndex(TokenHandle, __LINE__) == P3AL_NG) return P3AL_NG;
            Token = P3AlPsrTokenGet(TokenList, TokenHandle->TokenIndex);
            if((Token->Type != TOKEN_LF) && (Token->Type != TOKEN_COMMA) && (Token->Type != TOKEN_BRACE_R)) break;
        }
*/
    }
    else{
        PrintTokenBody(Msg, Token);
        PrintError0(__LINE__, "\ᔽ [", Msg, "]\n");
        return P3AL_NG;
    }

    if(Mode == TOKEN_GLOBAL_VAR){
        if((BiDirListObjectFind(Global0, v.Name) == NULL) && (BiDirListObjectFind(Global1, v.Name) == NULL)){
            if(v.InitializerList == NULL){
                    if(BiDirListMemberAdd(Global0, &v, sizeof(Variable)) == NULL){ PrintError0(__LINE__, "ϐXgǉs", "", "");return P3AL_NG; }
            }
            else{
                if(BiDirListMemberAdd(Global1, &v, sizeof(Variable)) == NULL){ PrintError0(__LINE__, "ϐXgǉs", "", "");return P3AL_NG; }
            }
        }
        else{
            PrintError0(__LINE__, "ϐXgǉsB", "ϐ݁B ", v.Name);
            return P3AL_NG;
        }
    }
    else if(Mode == TOKEN_LOCAL_VAR){
        if((BiDirListObjectFind(TokenHandle->f->LocalList, v.Name) == NULL) && (BiDirListObjectFind(TokenHandle->f->ArgList, v.Name) == NULL)){
            if(BiDirListMemberAdd(TokenHandle->f->LocalList, &v, sizeof(Variable)) == NULL){ PrintError0(__LINE__, "ϐXgǉs", "", "");return P3AL_NG; }
        }
        else{
            PrintError0(__LINE__, "ϐXgǉsB", "ϐ݁B ", v.Name);
            return P3AL_NG;
        }
    }
    else{
        if((BiDirListObjectFind(TokenHandle->f->LocalList, v.Name) == NULL) && (BiDirListObjectFind(TokenHandle->f->ArgList, v.Name) == NULL)){
            if(BiDirListMemberAdd(TokenHandle->f->ArgList, &v, sizeof(Variable)) == NULL){ PrintError0(__LINE__, "ϐXgǉs", "", "");return P3AL_NG; }
        }
        else{
            PrintError0(__LINE__, "ϐXgǉsB", "ϐ݁B ", v.Name);
            return P3AL_NG;
        }
    }
    return P3AL_OK;
}

//====================================================================================================================
static int P3AlPsrTokenSkip2LF(TokenAccessHandler *TokenHandle)
//====================================================================================================================
// [@\] ϐ\ER[h\̍쐬({)
// []
// [Ԓl] FP3AL_OK, sFP3AL_NG
{
    BiDirList       *TokenList;
    TokenInfo       *Token;
    TokenList = TokenHandle->SrcInfo->TokenList;
    while(1){
        if(TokenHandle->TokenIndex >= TokenHandle->NumOfToken) break;
        Token = P3AlPsrTokenGet(TokenList, TokenHandle->TokenIndex);
        if(Token->Type == TOKEN_LF) break;
        TokenHandle->TokenIndex += 1;
    }
    return P3AL_OK;
}
//====================================================================================================================
#ifdef TOKEN_READ_DEBUG
static TokenInfo *P3AlPsr2NewTokenGet(BiDirList   *TokenList, int *TokenIndex, int *NumOfToken, int Line)
#else
static TokenInfo *P3AlPsr2NewTokenGet(BiDirList   *TokenList, int *TokenIndex, int *NumOfToken)
#endif
//====================================================================================================================
// [@\] g[Nւ̃|C^Ԃ
// []
// [Ԓl] sFNULL
{
    TokenInfo       *Token;

    *NumOfToken -= 1;
    if(*NumOfToken < 0) return NULL;
    Token = P3AlPsrTokenGet(TokenList, *TokenIndex);
    *TokenIndex += 1;
    if(Token->Type == TOKEN_COMMA){
        *NumOfToken -= 1;
        if(*NumOfToken < 0) return NULL;
        Token = P3AlPsrTokenGet(TokenList, *TokenIndex);
        *TokenIndex += 1;
    }
#ifdef TOKEN_READ_DEBUG
    {
        char buf[1024];
        fprintf(LogOut, "[%d][%d,%d]", Line, *TokenIndex + 1, *NumOfToken + 1);
        PrintTokenBody(buf, Token);
        fprintf(LogOut, " %s\n", buf);
    }
#endif

    return Token;
}
//====================================================================================================================
static TokenInfo *P3AlPsrTokenGet(BiDirList   *TokenList, int TokenIndex)
//====================================================================================================================
// [@\] g[Nւ̃|C^Ԃ
// []
// [Ԓl] sFNULL
{
    return  (TokenInfo *)BiDirListObjectGet(TokenList, TokenIndex);
}

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// Xg֘A(ėp)
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
//====================================================================================================================
static int FindLabel(BiDirListMember *Position, void *Key)
//====================================================================================================================
// [@\] Coce,Labelr
// []
// [Ԓl] vFBIDIR_LIST_OK, sFBIDIR_LIST_NG
{
    CodeInfo    *Code;
    char        *p0;
    char        *p1;

    Code = (CodeInfo *)(Position->Object);
    p0 = Code->Label;
    if(p0 == NULL) return BIDIR_LIST_NG;
    p1 = (char *)Key;
    if(strcmp(p0, p1) == 0) return BIDIR_LIST_OK;
    else                    return BIDIR_LIST_NG;
}
//====================================================================================================================
static int FindFunction(BiDirListMember *Position, void *Key)
//====================================================================================================================
// [@\] Function,Namer
// []
// [Ԓl] vFBIDIR_LIST_OK, sFBIDIR_LIST_NG
{
    Function    *f;
    char        *p0;
    char        *p1;

    f = (Function *)(Position->Object);
    p0 = f->Name;
    p1 = (char *)Key;
    if(strcmp(p0, p1) == 0) return BIDIR_LIST_OK;
    else                    return BIDIR_LIST_NG;
}

//====================================================================================================================
static int FindVariable(BiDirListMember *Position, void *Key)
//====================================================================================================================
// [@\] Variable,Namer
// []
// [Ԓl] vFBIDIR_LIST_OK, sFBIDIR_LIST_NG
{
    Variable    *v;
    char        *p0;
    char        *p1;

    v = (Variable *)(Position->Object);
    p0 = v->Name;
    p1 = (char *)Key;
    if(strcmp(p0, p1) == 0) return BIDIR_LIST_OK;
    else                    return BIDIR_LIST_NG;
}
//====================================================================================================================
static int FindStr(BiDirListMember *Position, void *Key)
//====================================================================================================================
// [@\] r
// []
// [Ԓl] vFBIDIR_LIST_OK, sFBIDIR_LIST_NG
{
    char        *p0;
    char        *p1;

    p0 = (char *)Position->Object;
    p1 = (char *)Key;
    if(strcmp(p0, p1) == 0) return BIDIR_LIST_OK;
    else                    return BIDIR_LIST_NG;
}
//====================================================================================================================
static int FindNum(BiDirListMember *Position, void *Key)
//====================================================================================================================
// [@\] lr
// []
// [Ԓl] vFBIDIR_LIST_OK, sFBIDIR_LIST_NG
{
    unsigned long   *p0;
    unsigned long   *p1;

    p0 = (unsigned long *)Position->Object;
    p1 = (unsigned long *)Key;
    if(*p0 == *p1) return BIDIR_LIST_OK;
    else           return BIDIR_LIST_NG;
}

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// 񑀍֘A
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
//=====================================================================================================================
static int FileExtensionSwitch(char *In, char *Out, char *Ext)
//=====================================================================================================================
//= FileExtensionSwitch[t@C쐬igq̒uj]
// [@\] *In̕"."*ExtŒu*Out֊i[
// [] LQ
// [Ԓl] P3AL_OKԂB
{
    while(*In != '\0'){
        *Out = *In;
        ++Out, ++In;
        if(*In == '.') break;
    }
    *Out = '.';
    ++Out;
    while(*Ext != '\0'){
        *Out = *Ext;
        ++Out, ++Ext;
    }
    *Out = '\0';
    return P3AL_OK;
}
//=====================================================================================================================
static int FileExtensionCut(char *In, char *Out)
//=====================================================================================================================
//= FileExtensionCut[t@C̊gq̍폜]
// [@\] *In̕"."O*Out֊i[
// [] LQ
// [Ԓl] P3AL_OKԂB
{
    while(*In != '\0'){
        *Out = *In;
        ++Out, ++In;
        if(*In == '.') break;
    }
    *Out = '\0';
    return P3AL_OK;
}
//=====================================================================================================================
static int IsChar(char c, char *s)
//=====================================================================================================================
//= IsChar[csɊ܂܂镶̂ꂩƈvP3AL_OKԂ]
{
    while(*s != '\0'){
        if(c == *s) return P3AL_OK;
        ++s;
    }
    return P3AL_NG;
}
//=====================================================================================================================
static int IsAlphaAndUnderLineDol(char c)
//=====================================================================================================================
//= IsAlphaAndUnderLineDol[ca-zA-Z_P3AL_OKԂ]
{
    if(isalpha(0xFF & (int)c)) return P3AL_OK;
    return IsChar(c, "_$");
}
//=====================================================================================================================
static int IsAlphaAndNumAndUnderLine(char c)
//=====================================================================================================================
//= IsAlphaAndNumAndUnderLine[ca-zA-Z0-9_P3AL_OKԂ]
{
    if(isalnum(0xFF & (int)c)) return P3AL_OK;
    return IsChar(c, "_");
}
//=====================================================================================================================
static int IsAlNumUnderLineAtDotDol(char c)
//=====================================================================================================================
//= IsAlphaAndNumAndUnderLine[ca-zA-Z0-9_P3AL_OKԂ]
{
    if(isalnum(0xFF & (int)c)) return P3AL_OK;
    return IsChar(c, "_@.$");
}
//=====================================================================================================================
static int IsNum(char c)
//=====================================================================================================================
//= IsNum[c0-9P3AL_OKԂ]
{
    if(isdigit(0xFF & (int)c)) return P3AL_OK;
    return P3AL_NG;
}

//=====================================================================================================================
static int IsHex(char c)
//=====================================================================================================================
//= IsHex[c0-9a-fA-FP3AL_OKԂ]
{
    if(isdigit(0xFF & (int)c)) return P3AL_OK;
    return IsChar(c, "abcdefABCDEF");
}
//=====================================================================================================================
static long str2long(char *p)
//=====================================================================================================================
//= str2ul[long֒u]
{
    long    Ret;

    if(strncmp(p, "0x", 2) == 0) Ret = strtol(p,NULL,16);
    else                         Ret = strtol(p,NULL,10);
    //printf("%s, %d, %08x\n",p,radix,Ret);
    return Ret;
}

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// fobO֘A
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

//====================================================================================================================
static void PrintSrcFile(int Mode)
//====================================================================================================================
// [@\]
// [] Mode: 0=OrgSrcList, 1=SrcList
// [Ԓl]
{
    int                 i, j;
    InputSrcFileInfo    *p;
    BiDirList           *List;
    char                buf[MAX_LINE_LENGTH * 2];

    if(InputSrcList == NULL) return;
    for(i = 0; i < InputSrcList->NumOfMember; i++){
        p = (InputSrcFileInfo *)BiDirListObjectGet(InputSrcList, i);
        if(Mode == 0){
            fprintf(LogOut, "====== original src =================\n");
            List = p->OrgSrcList;
        }
        else{
            fprintf(LogOut, "====== trimmed src =================\n");
            List = p->SrcList;
        }
        fprintf(LogOut, "%s\n", p->FileName);
        fprintf(LogOut, "=====================================\n");
        for(j = 0; j < List->NumOfMember; j++){
            fprintf(LogOut, "%s", (char *)BiDirListObjectGet(List, j));
        }
    }
    fprintf(LogOut, "\n");

}
//====================================================================================================================
static void PrintTokenBody0(char *buf, TokenInfo  *Token)
//====================================================================================================================
// [@\] TokenInfo\
// []
// [Ԓl]
{
    char                TokenStr[16];
    char                *Str;

    TokenStr[0] = '\0';
    if(Token->Type == TOKEN_SQUARE_L ) strcpy(TokenStr, "[");
    if(Token->Type == TOKEN_SQUARE_R ) strcpy(TokenStr, "]");
    if(Token->Type == TOKEN_BRACE_L  ) strcpy(TokenStr, "{");
    if(Token->Type == TOKEN_BRACE_R  ) strcpy(TokenStr, "}");
    if(Token->Type == TOKEN_BRACKET_L) strcpy(TokenStr, "(");
    if(Token->Type == TOKEN_BRACKET_R) strcpy(TokenStr, ")");
    if(Token->Type == TOKEN_COLON    ) strcpy(TokenStr, ":");
    if(Token->Type == TOKEN_SEMICOLON) strcpy(TokenStr, ";");
    if(Token->Type == TOKEN_COMMA    ) strcpy(TokenStr, ",");
    if(Token->Type == TOKEN_PERIOD   ) strcpy(TokenStr, ".");
    if(Token->Type == TOKEN_NOT      ) strcpy(TokenStr, "~");
    if(Token->Type == TOKEN_PLUS     ) strcpy(TokenStr, "+");
    if(Token->Type == TOKEN_MINUS    ) strcpy(TokenStr, "-");
    if(Token->Type == TOKEN_ASTERISK ) strcpy(TokenStr, "*");
    if(Token->Type == TOKEN_DIV      ) strcpy(TokenStr, "/");
    if(Token->Type == TOKEN_MOD      ) strcpy(TokenStr, "%");
    if(Token->Type == TOKEN_AMPERSAND) strcpy(TokenStr, "&");
    if(Token->Type == TOKEN_OR       ) strcpy(TokenStr, "|");
    if(Token->Type == TOKEN_XOR      ) strcpy(TokenStr, "^");
    if(Token->Type == TOKEN_EQ       ) strcpy(TokenStr, "=");
    if(Token->Type == TOKEN_LF       ) strcpy(TokenStr, "[LF]");
    if(Token->Type == TOKEN_SHIFT_L  ) strcpy(TokenStr, "<<");
    if(Token->Type == TOKEN_SHIFT_R  ) strcpy(TokenStr, ">>");
    if(Token->Type == TOKEN_NUMERIC_LITERAL  ) sprintf(TokenStr, "0x%08x",*(unsigned long *)Token->ExtInfo);
    if(TokenStr[0] == '\0'){
        Str = (char *)Token->ExtInfo;
    }
    else{
        Str = TokenStr;
    }
    sprintf(buf, "%s ", Str);

}

//====================================================================================================================
static void PrintTokenBody(char *buf, TokenInfo  *Token)
//====================================================================================================================
// [@\] TokenInfo\
// []
// [Ԓl]
{
    char   Str[1024];
    PrintTokenBody0(Str, Token);
    sprintf(buf, "%s, %4d, %3d, %s", Token->FileName, Token->Line + 1, Token->Type, Str);
}

//====================================================================================================================
static void PrintToken(void)
//====================================================================================================================
// [@\] TokenList\
// []
// [Ԓl]
{
    int                 i, j;
    InputSrcFileInfo    *p;
    BiDirList           *TokenList;
    TokenInfo           *Token;
    char                buf[1024];

    if(InputSrcList == NULL) return;
    for(i = 0; i < InputSrcList->NumOfMember; i++){
        p = (InputSrcFileInfo *)BiDirListObjectGet(InputSrcList, i);
        TokenList = p->TokenList;
        fprintf(LogOut, "=====================================\n");
        fprintf(LogOut, "%s TOKENF%d\n", p->FileName, TokenList->NumOfMember);
        fprintf(LogOut, "=====================================\n");
        for(j = 0; j < TokenList->NumOfMember; j++){
            Token = (TokenInfo *)BiDirListObjectGet(TokenList, j);
            PrintTokenBody(buf, Token);
            fprintf(LogOut, "%s\n", buf);
        }
    }
}
//====================================================================================================================
static void PrintGlobal(void)
//====================================================================================================================
{
    fprintf(LogOut, "======== GLOBAL0 [%d(%08x)]===========\n", TotalSizeOfGlobal0, TotalSizeOfGlobal0);
    PrintVariable(Global0);
    fprintf(LogOut, "\n");

    fprintf(LogOut, "======== GLOBAL1 [%d(%08x)]===========\n", TotalSizeOfGlobal1, TotalSizeOfGlobal1);
    PrintVariable(Global1);
    fprintf(LogOut, "\n");
}
//====================================================================================================================
static void PrintVariable(BiDirList *VariableList)
//====================================================================================================================
// [@\] ϐXg\
// []
// [Ԓl]
{
    int         i;
    int         Num;
    Variable    *v;
    if(VariableList == NULL) return;
    Num = BiDirListNumOfMemberGet(VariableList);
    for(i = 0; i < Num; i++){
        fprintf(LogOut, " ");
        PrintVariableBody((Variable *)BiDirListObjectGet(VariableList, i));
    }
}

//====================================================================================================================
static void PrintVariableBody(Variable *v)
//====================================================================================================================
// [@\] Variable\
// []
// [Ԓl]
{
    int             i, Num;
    BiDirList       *InitList; // l񃊃XgioInitializerj
    Initializer     *Init;

    fprintf(LogOut, "%s,", v->Name);
    Num = 32 - strlen(v->Name);
    for(i = 0; i < Num; i++) fprintf(LogOut, " ");
    fprintf(LogOut, "%4d, %4d(0x%08x)", v->Size, v->Offset, v->Offset);
    InitList = v->InitializerList;
    if(InitList != NULL){
        Num = BiDirListNumOfMemberGet(InitList);
        for(i = 0; i < Num; i++){
            Init = (Initializer *)BiDirListObjectGet(InitList, i);
            if(i == 0)  fprintf(LogOut, " = ");
            else        fprintf(LogOut, ", ");
            fprintf(LogOut, "0x%02x", Init->InitVal);
        }
    }
    fprintf(LogOut, "\n");
}

//====================================================================================================================
static void PrintFunction(void)
//====================================================================================================================
// [@\] ֐\
// []
// [Ԓl]
{
    int                 i, j;
    InputSrcFileInfo    *p;
    BiDirList           *FunctionList;
    Function            *f;

    if(InputSrcList == NULL) return;
    for(i = 0; i < InputSrcList->NumOfMember; i++){
        p = (InputSrcFileInfo *)BiDirListObjectGet(InputSrcList, i);
        FunctionList = p->FunctionList;
        for(j = 0; j < FunctionList->NumOfMember; j++){
            f = (Function *)BiDirListObjectGet(FunctionList, j);
            PrintFunctionBody(f, p->TokenList);
            fprintf(LogOut, "\n");
        }
    }
}
//====================================================================================================================
static void PrintFunctionBody(Function *f, BiDirList   *TokenList)
//====================================================================================================================
// [@\] ֐\
// []
// [Ԓl]
{
    fprintf(LogOut, "======= FUNCTION %s ========\n", f->Name);
    fprintf(LogOut, "EntryAddress   : 0x%08x\n", f->EntryAddress);
    fprintf(LogOut, "CodeSize(byte) : %d (0x%08x)\n", f->CodeSize, f->CodeSize);
    fprintf(LogOut, "---ARG---\n");
    if(f->ArgList != NULL) PrintVariable(f->ArgList);
    fprintf(LogOut, "---LOCAL---\n");
    if(f->LocalList != NULL) PrintVariable(f->LocalList);
    fprintf(LogOut, "\n");
    if(f->CodeList != NULL) PrintCode(f->CodeList, TokenList);
    fprintf(LogOut, "\n");
}

//====================================================================================================================
static void PrintCode(BiDirList *CodeList, BiDirList *TokenList)
//====================================================================================================================
// [@\] R[h\
// []
// [Ԓl]
{
    int         i,Num;
    CodeInfo    *Code;

    fprintf(LogOut, "---CODE---\n");
    Num = BiDirListNumOfMemberGet(CodeList);
    for(i = 0; i < Num; i++){
        Code = (CodeInfo *)BiDirListObjectGet(CodeList, i);
        PrintCodeBody(Code, TokenList);
    }
}
//====================================================================================================================
static void PrintCodeBody(CodeInfo *Code, BiDirList *TokenList)
//====================================================================================================================
// [@\] R[h\
// []
// [Ԓl]
{
    int i,Num, LabelStrMax, TokenIndex;
    TokenInfo  *Token;
    char buf[1024];

    LabelStrMax = 16;
    fprintf(LogOut, " 0x%08x, 0x%08x, 0x%08x, ", Code->Address, Code->Offset, Code->HexCode);
    //fprintf(LogOut, "%d, %d", Code->StartTokenIndex, Code->NumOfToken);
    if(Code->Label != NULL){
        fprintf(LogOut, "%s:", Code->Label);
        Num = LabelStrMax - (strlen(Code->Label) + 1);
        for(i=0; i < Num; i++) fprintf(LogOut, " ");
    }
    else{
        for(i=0; i < LabelStrMax; i++) fprintf(LogOut, " ");
    }
    for(TokenIndex = Code->StartTokenIndex, i = 0; i < Code->NumOfToken; i++, TokenIndex++){
        Token = (TokenInfo *)BiDirListObjectGet(TokenList, TokenIndex);
        PrintTokenBody0(buf,Token);
        fprintf(LogOut, "%s", buf);
    }
    fprintf(LogOut, "\n");
}

//====================================================================================================================
static void PrintEqu(BiDirList *EquList)
//====================================================================================================================
// [@\] TokenList\
// []
// [Ԓl]
{
    int                 i;
    EquInfo             *Equ;

    if(EquList == NULL) return;
    for(i = 0; i < EquList->NumOfMember; i++){
        Equ = BiDirListObjectGet(EquList, i);
        fprintf(LogOut, ".EQU %s %s\n", Equ->BeforeStr, Equ->AfterStr);
    }
}
//====================================================================================================================
static void PrintReadOnlyData(void)
//====================================================================================================================
// [@\] READ ONLYf[^\
// []
// [Ԓl]
{
    unsigned long   i;
    unsigned long   Data;

    fprintf(LogOut, "\n====== RO DATA ========\n");
    for(i = 0; i < TotalSizeOfReadOnlyData; i++){
        if(i%4 ==0) Data  = (ReadOnlyData[i] << 24) & 0xFF000000;
        if(i%4 ==1) Data |= (ReadOnlyData[i] << 16) & 0x00FF0000;
        if(i%4 ==2) Data |= (ReadOnlyData[i] << 8)  & 0x0000FF00;
        if(i%4 ==3){
            Data |= ReadOnlyData[i] & 0x00000FF;
            fprintf(LogOut, " 0x%08x, 0x%08x, 0x%08x\n", (AddressOfReadOnlyData + i - 3), (i - 3), Data);
        }
    }

}

//====================================================================================================================
static void PrintInitData(void)
//====================================================================================================================
// [@\] ltϐ̏f[^\
// []
// [Ԓl]
{
    unsigned long   i;
    unsigned long   Data;

    fprintf(LogOut, "\n====== INIT ========\n");
    for(i = 0; i < TotalSizeOfGlobal1; i++){
        if(i%4 ==0) Data  = (InitData[i] << 24) & 0xFF000000;
        if(i%4 ==1) Data |= (InitData[i] << 16) & 0x00FF0000;
        if(i%4 ==2) Data |= (InitData[i] << 8)  & 0x0000FF00;
        if(i%4 ==3){
            Data |= InitData[i] & 0x00000FF;
            fprintf(LogOut, " 0x%08x, 0x%08x, 0x%08x\n", (AddressOfInitData + i - 3), (i - 3), Data);
        }
    }

}

/*
//====================================================================================================================
static void PrintWarning(int Line, char *Str0, char *Str1, char *Str2)
//====================================================================================================================
// [@\] x\
// []
// [Ԓl]
{
    fprintf(MsgOut, "yxz(%s  LINE:%d) %s %s %s %s%ds\n"
                ,__FILE__ , Line, Str0, Str1, Str2, TokenSrcFileNameGet(TokenIndex), TokenSrcLineGet(TokenIndex));
}
//====================================================================================================================
static void PrintInfo(int Line, char *Str0, char *Str1, char *Str2)
//====================================================================================================================
// [@\] \
// []
// [Ԓl]
{
    fprintf(MsgOut, "yINFOz(%s  LINE:%d) %s %s %s %s%ds\n"
                ,__FILE__ , Line, Str0, Str1, Str2, TokenSrcFileNameGet(TokenIndex), TokenSrcLineGet(TokenIndex));
}

//====================================================================================================================
static void PrintError(int Line, char *Str0, char *Str1, char *Str2)
//====================================================================================================================
// [@\] G[\
// []
// [Ԓl]
{
    fprintf(MsgOut, "yG[z(%s  LINE:%d) %s %s %s %s%ds\n"
                ,__FILE__ , Line, Str0, Str1, Str2, TokenSrcFileNameGet(TokenIndex), TokenSrcLineGet(TokenIndex));

}
*/
//====================================================================================================================
static void PrintError0(int Line, char *Str0, char *Str1, char *Str2)
//====================================================================================================================
// [@\] G[\
// []
// [Ԓl]
{
    fprintf(MsgOut, "yG[z(%s  LINE:%d) %s %s %s\n"
                ,__FILE__ , Line, Str0, Str1, Str2);

}

